//"ekspDK.sci","Eksport DK - include","\Eksport\Eksport include\",0,2.0.3,SYSTEM
/////////////////////////////////////////
// "Eksport DK - include"
// ekspDK.sci
/////////////////////////////////////////

MKP_EXP = 0
#ifdef EKSPORT_MK
	MKP_EXP = 1
#endif
#define ROWNOLEGLE_KSIEG_MAG		0x1
#define NIE_EKSP_OZNAK				0x2
#define lOPIS	200
//#define DOK_PUSTAOPER			0x20		// analogicznie po stronie FK  , nie wysyamy flagi, bazujemy na typach dokumentw FK

Dispatch xConnection
Dispatch xRecordSet

int DECLARE EksportDKbyDisp(dispatch xDokumentDkPar, int iOpcje)

int Sub EksportDKbyDisp(dispatch xDokumentDkPar, int iOpcje)
	Dispatch dpRejestr
	Dispatch dpStVat
	Dispatch xTypDokumentuSp
	Dispatch xKsSchematSp
	Dispatch xKonTmp
	Dispatch xDokumentMg
	Dispatch xTowar
	Dispatch xKZ
	Dispatch xTmp

	EksportDKbyDisp = 1

	int bKorekta = 0
	int iStVat
	string sRejVat
	string sRejVatNazw
	int iRejVatRodz
	int iPom, iPomStVat, iPos
	int iSubtyp
	float sumanetto, sumavat
	int dokanul
	int nRes, ii, k, nWalutowy
	String strOkres
	float dKwota, dKurs
	int czyRelatedDokument = 0
	int czyExportowy = 0, czyDEX = 0
	String		sRequest

	Select Case xDokumentDkPar.charakter
	Case DXK, DEX, WDT, WDK, REX, RXK
		czyExportowy = 1
		if xDokumentDkPar.charakter == DEX || xDokumentDkPar.charakter == DXK then	czyDEX = 1
	Case Else
			czyExportowy = 0
	EndSelect

	rozUidStrona = ROZ_STRONA_WN

	long tIdMG(1)
	long idDK = xDokumentDkPar.id
	dokanul = iif(xDokumentDkPar.czyAnulowany, 1, 0)

	if !CzyPrzerwEkspBufor(xDokumentDkPar.czyWystawiony, xDokumentDkPar.numer) then
		EksportDKbyDisp = 0 // pomijamy
		Exit
	endif

	// sprawdzamy typ dokumentu
	Select Case xDokumentDkPar.charakter
		Case FVS, FKS, RUS, RKS, DXK, DEX, FAS, FAK, PAR, PRK, FVW, FKW, ANUL, PANUL, FZS, ZKS, WDT, FWS, WKS, WDK, FVT, FTK, REX, RXK, SZA, SZK, SKO, SKK, SKW, SKWK, SZW, SZWK
		Case Else
			EksportDKbyDisp = 0 // pomijamy
			eksport.AddError("Nie mona wyeksportowa dokumentu " + xDokumentDkPar.numer + ". Dokument tego typu jest nieeksportowalny.")
	EndSelect
	
	if ( EksportDKbyDisp == 0 ) then Exit

	if !dokanul && !CzyEkspBrakSchematu(xDokumentDkPar.schematKsiegowania, xDokumentDkPar.numer) then
		EksportDKbyDisp = 0 // pomijamy
		Exit
	endif

	xKsSchematSp = GetObjByKod("BKsSchematSp", xDokumentDkPar.schematKsiegowania)
	if xKsSchematSp then
		nRes = 0
	else
		nRes = 1
	endif

	if !dokanul && !CzyEkspBlednySchemat(nRes, xDokumentDkPar.numer) then
		EksportDKbyDisp = 0 // pomijamy
		Exit
	endif


	xTypDokumentuSp = GetObjByKod("BTypDokumentuSp", xDokumentDkPar.typDk)
	if xTypDokumentuSp then
		if(xTypDokumentuSp.typFK == "FVS" || xTypDokumentuSp.typFK == "RUS" || xTypDokumentuSp.typFK == "FVZ" ||xTypDokumentuSp.typFK == "RUZ" || xTypDokumentuSp.typFK == "FVSM" || xTypDokumentuSp.typFK == "FVT") then
		 	czyRelatedDokument = 1		
		else
			czyRelatedDokument = 0
		endif		
		xDokumentDkPar.SprawdzUzgodnienieFK()
		nRes = 0
	else
		nRes = 1
	endif

	if !dokanul && !CzyEkspBrakTypDK(nRes, xDokumentDkPar.numer, xDokumentDkPar.charakter, xDokumentDkPar.typDk) then
		EksportDKbyDisp = 0 // pomijamy
		Exit
	endif

	//jesli kontrakt, sprawdzamy czy zrealizowany tzn czy ma ustawiona date realizacji
	if !nRes && xDokumentDkPar.czyKontrakt then
		if !AskKontrZrealiz(xDokumentDkPar) then
			EksportDKbyDisp = 0 // pomijamy
			Exit
		endif
	endif

	iSubtyp = xDokumentDkPar.charakter
	//sprawdzamy czy faktury walutowe nie sa eksportowane jako stare( nie walutowe) do FK
	if(iSubtyp == FVW || iSubtyp == FKW)  && (xTypDokumentuSp.typFK != "FWS" && xTypDokumentuSp.typFK != "FWSK") && (xDokumentDkPar.kurs != xDokumentDkPar.kursDoch) then
		nRes = 1
	else
		nRes = 0
	endif		
	if !dokanul && !CzyEkspBlednyTypFK(nRes, xDokumentDkPar.numer) then
		EksportDKbyDisp = 0 // pomijamy
		Exit
	endif
/* 
	//sprawdzamy czy dokumenty zlotowkowe nie sa eksportowane jako faktura walutowa
	if (xTypDokumentuSp.typFK == "FWS" || xTypDokumentuSp.typFK == "FWSK") && (xDokumentDkPar.waluta == "") then
	nRes = 1
	else
		nRes = 0
	endif
	if !dokanul && !CzyEkspBlednyTypFK2(nRes,xDokumentDkPar.numer, xDokumentDkPar.charakter) then
		EksportDKbyDisp = 0 // pomijamy
		Exit
	endif
*/		
	if ( xDokumentDkPar.czyKorekta ) then bKorekta = 1

	eksport.PoczatekSekcji("Dokument", idDK)
		eksport.Pole("uid", xDokumentDkPar.guid)//teraz zawsze wysyamy guid dokumentu

		eksport.Pole("anulowany", using "%d",dokanul)
		eksport.Pole("anulowanyFaktura", Using "%d",IIF(PAF2FK(xDokumentDkPar), 1, 0))
		eksport.Pole("rodzaj_dok", "sprzeday")

		if (iSubtyp == WDT || iSubtyp == FWS || iSubtyp == WDK || iSubtyp == WKS) then
			eksport.Pole("metoda_VAT", "2")
		else
			eksport.Pole("metoda_VAT", iif(xDokumentDkPar.metodaVAT,"1","0"))
		endif

		if ( !dokanul && iSubtyp != FWS && iSubtyp != WKS ) then
			eksport.Pole("dozaplaty", (Using "%.12f", (xDokumentDkPar.rozrachunekDk.kwota-xDokumentDkPar.rozrachunekDk.kwotaRozl)))
			eksport.Pole("rozrachunek", (Using "%.12f", xDokumentDkPar.rozrachunekDk.kwota))
		endif

		eksport.Pole("rejestr_platnosci", xDokumentDkPar.rejestr.kod)
		eksport.Pole("forma_platnosci", PoleFormaPlatnosci(xDokumentDkPar.formaPl))

		eksport.PoczatekPodsekcji("Dane nabywcy")
			eksport.Pole("khid", (Using "%l", xDokumentDkPar.danekh.KhID))
			xKonTmp = KonFullGetByKod(xDokumentDkPar.danekh.KhKod, xDokumentDkPar.danekh.KhTyp)
			if !nRes then eksport.Pole("fk_ident", xKonTmp.identyfikatorFK)
			eksport.Pole("khkod", xDokumentDkPar.danekh.KhKod)
			eksport.Pole("khnazwa", xDokumentDkPar.danekh.KhNazwa)
			eksport.Pole("KhUlica", xDokumentDkPar.danekh.KhUlica)
			eksport.Pole("KhDomu", xDokumentDkPar.danekh.KhDomu)
			eksport.Pole("KhLokal", xDokumentDkPar.danekh.KhLokal)
			eksport.Pole("khmiasto", IIF(Len(xDokumentDkPar.danekh.KhMiasto) > lenMIASTO, Mid(xDokumentDkPar.danekh.KhMiasto,0,lenMIASTO), xDokumentDkPar.danekh.KhMiasto))
			eksport.Pole("khkodpocz", xDokumentDkPar.danekh.KhPoczta)
			eksport.Pole("khnip", xDokumentDkPar.danekh.KhNIP)

			eksport.PoczatekPodsekcji("kraj")
//				eksport.Pole("aktywny", (Using "%d", xDokumentDkPar.danekh.kraj.aktywny))
				eksport.Pole("symbol", xDokumentDkPar.danekh.kraj.symbol)
//				eksport.Pole("nazwa", xDokumentDkPar.danekh.kraj.nazwa)
//				eksport.Pole("ue", (Using "%d", xDokumentDkPar.danekh.kraj.ue))

				EksportKraj(xDokumentDkPar.danekh.kraj.symbol)
			eksport.KoniecSekcji() // "kraj"

			if 0 != xDokumentDkPar.danekh.KhID then
				EksportKH(xDokumentDkPar.danekh.KhID, 0)
			endif
		eksport.KoniecSekcji() //"Dane nabywcy"

		nWalutowy = 0
		if ( !dokanul && iSubtyp != FWS && iSubtyp != WKS && iSubtyp != SKO && iSubtyp != SKK && iSubtyp != SKW && iSubtyp != SKWK && !xDokumentDkPar.czyKoncowaZerowa ) then
			if ( CzyWalutowy(xDokumentDkPar.GetRozrachunek().id)) then	nWalutowy = 1
		endif

		if nWalutowy then
			if(xTypDokumentuSp.typFK == "FWS" || xTypDokumentuSp.typFK == "FWSK")  then //nowy typ dokumentu w FK - wielowalutowy
				eksport.PoczatekPodsekcji("AtrybutWaluta")
					eksport.Pole("kurs", (Using "%.12f", xDokumentDkPar.kursDoch))
					eksport.Pole("waluta", xDokumentDkPar.waluta)
					eksport.Pole("dane","kurs CIT/PIT")
				eksport.KoniecSekcji() //"AtrybutWaluta"
				eksport.PoczatekPodsekcji("AtrybutWaluta")
					eksport.Pole("kurs", (Using "%.12f", xDokumentDkPar.kurs))
					eksport.Pole("waluta", xDokumentDkPar.waluta)
					eksport.Pole("dane","kurs VAT")
				eksport.KoniecSekcji() //"AtrybutWaluta"
				eksport.Pole("wkwota", (Using "%.2f", xDokumentDkPar.wysokoscNaleznosci))
			else
				dKurs = xDokumentDkPar.kurs
				eksport.Pole("kurs", (Using "%.12f", dKurs))
				eksport.Pole("waluta", xDokumentDkPar.waluta)

				dKwota = xDokumentDkPar.wysokoscNaleznosci
				eksport.Pole("wkwota", (Using "%.2f", dKwota))
				eksport.Pole("kwota", (Using "%.2f", Round(dKwota * dKurs, 2)))
			endif
		else
			dKwota = xDokumentDkPar.netto + xDokumentDkPar.niePodlega + xDokumentDkPar.vat
			eksport.Pole("kwota", (Using "%.2f", dKwota))
		endif

		eksport.Pole("symbol FK", xTypDokumentuSp.symbolFK)
		eksport.Pole("obsluguj jak", xTypDokumentuSp.TypFK)

		if iSubtyp == SKO || iSubtyp == SKK || iSubtyp == SKW || iSubtyp == SKWK then
			eksport.Pole("dataWystawienia", xDokumentDkPar.dataRealizacji)
			eksport.Pole("dataSprzedazy", xDokumentDkPar.dataRealizacji)
		else
			eksport.Pole("dataWystawienia", xDokumentDkPar.dataWystawienia)
			eksport.Pole("dataSprzedazy", xDokumentDkPar.dataSprzedazy)
			// Czy akceptowalna pusta data operacji gospodarczej ?
			// Tak jesli akceptowalna pusta data sprzedazy.
			//eksport.Pole("flag", (Using "%d", IIF(xDokumentDKPar.PustaDataSprzedazy, DOK_PUSTAOPER, 0))) // nie wysyamy flagi, bazujemy na typach dokumentw FK
		endif
		eksport.Pole("terminPlatnosci", xDokumentDkPar.terminPlatnosci)

		if bKorekta then
			if xDokumentDkPar.czyKZ then	//korekta zbiorcza
				xKZ = xDokumentDkPar.dokumentyKorygowaneKZ
				k = 1
				for k to k > xKZ.Count
					eksport.PoczatekPodsekcji("Dokument korygowany")
						eksport.Pole("guid", xKZ.item(k).guid)
						eksport.Pole("kod", xKZ.item(k).kod)
						eksport.Pole("data",xKZ.item(k).data)
					eksport.KoniecSekcji()
				next k
			else
				// musimy siegnac do dokumentu korygowanego pierwotnego
				// numer i data dokumentu korygowanego
				// przyjete ze jest to pierwszy w kolekcji
				if xDokumentDkPar.DokumentZKorektami.Count() && xDokumentDkPar.DokumentZKorektami.item(1).Numer!= xDokumentDkPar.Numer then
					eksport.Pole("NazwaKor", xDokumentDkPar.DokumentZKorektami.item(1).Numer)
					eksport.Pole("DataKor", xDokumentDkPar.DokumentZKorektami.item(1).Data)
					eksport.PoczatekPodsekcji("Dokument korygowany")
						eksport.Pole("guid", xDokumentDkPar.DokumentZKorektami.item(1).guid)
						eksport.Pole("kod", xDokumentDkPar.DokumentZKorektami.item(1).Numer)
						eksport.Pole("data", xDokumentDkPar.DokumentZKorektami.item(1).Data)
					eksport.KoniecSekcji()
				endif
			endif
		else
			if xDokumentDkPar.DokumentZKorektami.Count() && xDokumentDkPar.DokumentZKorektami.item(1).Numer== xDokumentDkPar.Numer then
				k = 2
				for k to k > xDokumentDkPar.DokumentZKorektami.Count()		
					eksport.PoczatekPodsekcji("Korekta dokumentu")
						eksport.Pole("guid", xDokumentDkPar.DokumentZKorektami.item(k).guid)
						eksport.Pole("kod", xDokumentDkPar.DokumentZKorektami.item(k).Numer)
						eksport.Pole("data", xDokumentDkPar.DokumentZKorektami.item(k).Data)
					eksport.KoniecSekcji()
				next k
			endif
		endif

		// split payment
		eksport.Pole("mppFlags", (using "%d", xDokumentDkPar.mppFlags))

		// pozycje dokumentu
		////////////////////////[Pozycja VAT]//////////////////////////
		TabPozVat.ClearRec()
		float wartosc
		dispatch pozycja
		////////////////////////[Pozycja VAT] - koniec ///////////////
		If iSubtyp != FVT && iSubtyp != FTK Then
		// pozycje dokumentu
		for ii=1 to ii>(xDokumentDkPar.Pozycje.Count())
			if (!xDokumentDkPar.Pozycje.item(ii).dokompletu && ((!xDokumentDkPar.CzyKorekta) || (xDokumentDkPar.CzyKorekta && xDokumentDkPar.Pozycje.item(ii).wlasna))) then
				if (xDokumentDkPar.CzyKorekta) then
					wartosc = 0
					if (xDokumentDkPar.Pozycje.item(ii).idpozkoryg) then
						pozycja = xDokumentDkPar.Pozycje.item(ii).przedKorekta
						dpRejestr = pozycja.rejestrVAT
						dpStVat = pozycja.stVAT
						TabRejVat.Wstaw(dpRejestr, dpStVat, pozycja,1,0,1,xDokumentDkPar.SendAggregated)
						//////////////////////////////[Pozycja VAT]///////////////
						wartosc = -(pozycja.niePodlega + pozycja.netto)
						//dpRejestr = xDokumentDkPar.Pozycje.item(ii).przedKorekta.rejestrVAT
						//dpStVat = xDokumentDkPar.Pozycje.item(ii).przedKorekta.stVAT
						//TabRejVat.Wstaw(dpRejestr, dpStVat, -xDokumentDkPar.Pozycje.item(ii).przedKorekta.netto, -xDokumentDkPar.Pozycje.item(ii).przedKorekta.VAT, -xDokumentDkPar.Pozycje.item(ii).przedKorekta.niePodlega,1,0)
						//////////////////////////////[Pozycja VAT]///////////////
						//wartosc = -(xDokumentDkPar.Pozycje.item(ii).przedKorekta.niePodlega + xDokumentDkPar.Pozycje.item(ii).przedKorekta.netto)
					endif
					
					pozycja = xDokumentDkPar.Pozycje.item(ii).poKorekcie
					dpRejestr = pozycja.rejestrVAT
					dpStVat = pozycja.stVAT
					TabRejVat.Wstaw(dpRejestr, dpStVat, pozycja,1,0,0,xDokumentDkPar.SendAggregated)
					//////////////////////////////[Pozycja VAT]///////////////
					wartosc = wartosc + (pozycja.niePodlega + pozycja.netto)
					if czyExportowy || iSubtyp == FVS || iSubtyp == FKS || iSubtyp == FVW || iSubtyp == FKW || iSubtyp == FVT || iSubtyp == FTK then 
						TabPozVat.Wstaw(pozycja, round(wartosc,2), czyDEX)
					endif
				else
					pozycja = xDokumentDkPar.Pozycje.item(ii)
					dpRejestr = pozycja.rejestrVAT
					dpStVat = pozycja.stVAT
					TabRejVat.Wstaw(dpRejestr, dpStVat, pozycja,1,0,0,xDokumentDkPar.SendAggregated)
					//////////////////////////////[Pozycja VAT]///////////////
					if czyExportowy || iSubtyp == FVS || iSubtyp == FKS || iSubtyp == FVW || iSubtyp == FKW || iSubtyp == FVT || iSubtyp == FTK then
						wartosc = pozycja.niePodlega + pozycja.netto
						TabPozVat.Wstaw(pozycja, round(wartosc,2), czyDEX)
					endif
				endif
			endif
		next ii
		Else
			sSqlRequest  = " SELECT RV.netto AS RV_netto, RV.vat AS RV_vat, S.id AS S_id, R.id AS R_id, RV.JPK_V7 AS RV_JPK_V7 "
			sSqlRequest += "   FROM HM.RV JOIN HM.XT AS S ON RV.stvat = S.id AND S.typ = 20 JOIN HM.XT AS R ON RV.rejestr = R.id "	// AND R.typ = 55
			sSqlRequest += "   WHERE RV.dkid = " + ( Using "%l", idDK ) + " "
	
			xAdoRecordset.Open( sSqlRequest, xAdoConnection )
			If xAdoRecordset.RecordCount() Then
				While !xAdoRecordset.EOF()
					StVatRV = GetObjById( "BStawkaVAT", xAdoRecordset.Fields( "S_id" ).Value )
					RejVatRV = GetObjById( "BRejSp",  xAdoRecordset.Fields( "R_id" ).Value )
					TabRejVat.WstawRV( RejVatRV, xAdoRecordset.Fields( "RV_JPK_V7" ).Value, StVatRV, xAdoRecordset.Fields( "RV_netto" ).Value, xAdoRecordset.Fields( "RV_vat" ).Value )
					xAdoRecordset.MoveNext()
				Wend
			EndIf
			xAdoRecordset.Close()
		EndIf

		// eksport do jpk
		eksport.Pole( "jpk", ( Using "%d", xDokumentDkPar.jpk ) )

		//////////////////////////////////////////////////////
		// numer dokumentu w MKP
		eksport.Pole("kod", xDokumentDkPar.numer)
		// numer dokumentu w FK
		eksport.Pole("FK nazwa", xDokumentDkPar.numer)
		
		//JPK V7
		eksport.Pole("JPK_V7", xDokumentDkPar.JPK_V7)

		//na potrzeby MKP
		eksport.Pole("od_brutto", IIF( xDokumentDkPar.rodzajCeny == 1, "1", "0" ))

		eksport.Pole("typ_dk", xDokumentDkPar.typDk )
		eksport.Pole("seria", xDokumentDkPar.seria )
		eksport.Pole("serianr", (Using "%l", xDokumentDkPar.numerWSerii))
		If (MKP_EXP) then
			eksport.Pole("okres", (Using "%d", RecalculatePeriod(xDokumentDkPar.okresNumeracji, xDokumentDkPar.dataWystawienia)))
		else
			eksport.Pole("okres", (Using "%d", xDokumentDkPar.okresNumeracji))
		endif
		eksport.Pole("dzial", (Using "%l", xDokumentDkPar.dzial.id))
		EksportNotatka(xDokumentDkPar.Notatka, "Notatka_Dl")
		If (!xDokumentDkPar.czyAnulowany) Then
			xTmp = xDokumentDkPar.rozrachunekDk
			If (xTmp) Then
				Eksport_RozrachunekDok(xTmp, 1)
			EndIf
			Eksport_RozliczenieDok(xDokumentDkPar.rozrachunekDk)
		EndIf

		// rwnolege ksigowania magazynowe - sprawdzenie
		if iOpcje & ROWNOLEGLE_KSIEG_MAG then
			if bKorekta then
				for ii=1 to ii>xDokumentDkPar.zwiazkiOdpDok.Count()
					if ((xDokumentDkPar.zwiazkiOdpDok.item(ii).dkBase == 33) && xDokumentDkPar.zwiazkiOdpDok.item(ii).idDk) then
						nRes=!(xDokumentMg=GetObjById("BDokumentMg",xDokumentDkPar.zwiazkiOdpDok.item(ii).idDk))
						if nRes then  error "Dokument nie zaadowany"
						if xDokumentMg.czyWystawiony && xDokumentMg.czyZatwWart then // czy wystawiony i zatwierdzony wartosciowo
							if !( !((iOpcje & NIE_EKSP_OZNAK) && xDokumentMg.czyWyeksportFK) ) then
								eksport.AddInfo("Nie mona powtrnie wyeksportowa zapisw do dokumentu " + xDokumentMg.numer + ".")
							endif
						endif
					endif
				next ii
			else
				for ii=1 to ii>xDokumentDkPar.transakcjaTw.powiazaniaTw.Count()
					nRes=!(xDokumentMg=GetObjById("BDokumentMg",xDokumentDkPar.transakcjaTw.powiazaniaTw.item(ii).idWlascicielaTrans))
					if nRes then  error "Dokument nie zaadowany"
					if xDokumentMg.czyWystawiony && xDokumentMg.czyZatwWart then // czy wystawiony i zatwierdzony wartosciowo
						if !( !((iOpcje & NIE_EKSP_OZNAK) && xDokumentMg.czyWyeksportFK) ) then
							eksport.AddInfo("Nie mona powtrnie wyeksportowa zapisw do dokumentu " + xDokumentMg.numer + ".")
						endif
					endif
				next ii
			endif
		endif // rwnolege ksigowania magazynowe

		xDekretacjeSp.Clear()
		xDekretParamsSp = xDekretacjeSp.Params()
		xDekretParamsSp.id = xDokumentDkPar.id
		xDekretParamsSp.RownolegleMAG = (iOpcje & ROWNOLEGLE_KSIEG_MAG)
		xDekretParamsSp.czyEkspOznak = !(iOpcje & NIE_EKSP_OZNAK)
		xDekretacjeSp.Dekret(xDekretParamsSp)
		eksport.Pole("opis FK",	xDekretacjeSp.trescwFK)
		
		if(xTypDokumentuSp.typFK == "FWS" || xTypDokumentuSp.typFK == "FWSK")  then //nowy typ dokumentu w FK - wielowalutowy
		//ewentualne rownolegle ksiegowanie magazynowe tylko w PLN
			ZapiszZAP(xDekretacjeSp, 0, 0, "", 0, !czyRelatedDokument, TiDokSp)
		else
			ZapiszZAP(xDekretacjeSp, 0, nWalutowy, xDokumentDkPar.waluta, xDokumentDkPar.kurs, !czyRelatedDokument, TiDokSp)
		endif

		ZapiszETRANSFERS(xDokumentDkPar, xDekretacjeSp)

		long lStawka
		float dStawka
		string opis = ""
		// rejestry VAT
		If ( iSubtyp == SZA || iSubTyp == SZW ) && xDokumentDkPar.czyKoncowaZerowa Then
			// zerowa faktura zaliczkowa koncowa
			xConnection = GetAdoConnection()
			xRecordSet = "ADODB.Recordset"

			sRequest  = "SELECT r.kod AS Skrot, r.nazwa AS Nazwa, r.long2 AS Rodzaj, v.wartosc * 100 AS Stawka "
			sRequest += "  FROM HM.RV "
			sRequest += "       JOIN HM.XT r ON RV.rejestr = r.id "
			sRequest += "	    JOIN HM.XT v ON RV.stvat = v.id "
			sRequest += " WHERE dkid = "
			sRequest += ( Using "%d", xDokumentDkPar.id )
			xRecordSet.Open( sRequest, xConnection )
			If xRecordSet.RecordCount() Then
				While !xRecordSet.EOF()
					eksport.PoczatekPodsekcji( "Rejestr" )
						eksport.Pole( "Skrot", xRecordSet.Fields( "Skrot" ).Value )
						eksport.Pole( "Nazwa", xRecordSet.Fields( "Nazwa" ).Value )
						eksport.Pole( "Rodzaj", ( Using "%l", xRecordSet.Fields( "Rodzaj" ).Value ) )
						eksport.Pole( "JPK_V7", "" )
						eksport.Pole( "ABC", "1" )
						eksport.Pole( "metoda_VAT", IIF( xDokumentDkPar.metodaVAT, "1", "0" ) )
						eksport.Pole( "datarej", xDokumentDkPar.dataRejestrVAT )
						buf = xDokumentDkPar.dataRejestrVAT
						strOkres = Find Regular "????????" // osiem pierwszych znakw
						eksport.Pole( "okres", ( strOkres + "01" ) )
						eksport.Pole( "stawka", ( Using "%.2f", xRecordSet.Fields( "Stawka" ).Value ) )
						eksport.Pole( "brutto", "0.00" )
						eksport.Pole( "netto", "0.00" )
						eksport.Pole( "vat", "0.00" )
					eksport.KoniecSekcji()
					xRecordSet.MoveNext()
				Wend
			EndIf
			xRecordSet.Close()
		Else
		Select Case iSubtyp
			Case FVS, FKS, RUS, RKS, DEX, DXK, PAR, PRK, FAS, FAK, FVW, FKW, FZS, ZKS, WDT, FWS, WKS, WDK, FVT, FTK, REX, RXK,SZA, SZK, SZW, SZWK
				for iPom=1 to iPom>TabRejVat.IloscRejestrow(0)
					for iPomStVat=1 to iPomStVat>TabRejVat.IloscStawek(iPom)
						eksport.PoczatekPodsekcji("Rejestr")
							// ABC
							eksport.Pole("Skrot", TabRejVat.RejVat(iPom).Skrot)
							eksport.Pole("Nazwa", TabRejVat.RejVat(iPom).Nazwa)
							eksport.Pole("Rodzaj", (using "%d",TabRejVat.RejVat(iPom).rodzaj))
							eksport.Pole("JPK_V7", IIF(!xDokumentDkPar.SendAggregated, TabRejVat.RejVat(iPom).JPK_V7, AggregatedGTU()))
							eksport.Pole("ABC", "1")
							if (iSubtyp == WDT || iSubtyp == FWS || iSubtyp == WDK || iSubtyp == WKS) then
								eksport.Pole("metoda_VAT", "2")
							else
								eksport.Pole("metoda_VAT", iif(xDokumentDkPar.metodaVAT,"1","0"))
							endif
							// okres
							eksport.Pole("datarej", xDokumentDkPar.dataRejestrVAT)	//dla maej ksigowoci
							buf =xDokumentDkPar.dataRejestrVAT
							strOkres = Find Regular "????????" // osiem pierwszych znakw
							eksport.Pole("okres", (strOkres + "01"))

							eksport.Pole("stawka", (Using "%.2f", TabRejVat.Wartosc(iPom, iPomStVat, "stawka")))
							eksport.Pole("brutto", (Using "%.2f", Round( (TabRejVat.Wartosc(iPom, iPomStVat, "netto") + TabRejVat.Wartosc(iPom, iPomStVat, "vat")),2 )))
							eksport.Pole("netto", (Using "%.2f", Round( TabRejVat.Wartosc(iPom, iPomStVat, "netto"),2 )))
							eksport.Pole("vat", (Using "%.2f", Round( TabRejVat.Wartosc(iPom, iPomStVat, "vat"),2 )))
							
							if (iSubtyp == FVS || iSubtyp == FKS || iSubtyp == FVW || iSubtyp == FKW) then
								buf=xDokumentDkPar.daneod.KhNIP
								if(xDokumentDkPar.daneod.KhNIP == "" || find "P:") then
									eksport.Pole("KrajKod", xDokumentDkPar.daneod.kraj.symbol)
								endif
							endif
							//eksport.Pole("sumanetto", (Using "%.2f", Round( TabRejVat.RejVat(iPom).SumNetto,2 )))
							//eksport.Pole("sumavat", (Using "%.2f", Round( TabRejVat.RejVat(iPom).SumVat,2 )))
							
							if(nWalutowy &&(xTypDokumentuSp.typFK == "FWS" || xTypDokumentuSp.typFK == "FWSK"))  then //nowy typ dokumentu w FK - wielowalutowy
								eksport.Pole("bruttoWaluta", (Using "%.2f", Round(TabRejVat.Wartosc(iPom, iPomStVat, "wbrutto"),2 )))
								eksport.Pole("nettoWaluta", (Using "%.2f", Round( TabRejVat.Wartosc(iPom, iPomStVat, "wnetto"),2 )))
								eksport.Pole("vatWaluta", (Using "%.2f", Round((TabRejVat.Wartosc(iPom, iPomStVat, "wbrutto") - TabRejVat.Wartosc(iPom, iPomStVat, "wnetto")),2 )))
							endif
							
							//////////////////////////////[Pozycja VAT]///////////////
							if (czyExportowy || iSubtyp == FVS || iSubtyp == FKS || iSubtyp == FVW || iSubtyp == FKW || iSubtyp == FVT || iSubtyp == FTK) then
								for iPos=1 to iPos > TabPozVat.Rozmiar()
									if TabPozVat.PozVat(iPos).rejestrVat == TabRejVat.RejVat(iPom).id && TabPozVat.PozVat(iPos).JPK_V7 == TabRejVat.RejVat(iPom).JPK_V7 then
										eksport.PoczatekPodsekcji("pozycja VAT")
										lStawka = TabPozVat.PozVat(iPos).stawka
										dStawka = TabPozVat.StVat(TabPozVat.ZnajdzStawke(lStawka)).stawka
										eksport.Pole("Stawka", (Using "%.2f", dStawka))
										//towar
										if TabPozVat.PozVat(iPos).towar != "" then
											if (xTowar = GetObjByKod("BTowar", TabPozVat.PozVat(iPos).towar)) then
												opis = xTowar.nazwa
												lStawka = TabPozVat.StVat(TabPozVat.InitStawke(xTowar.stVAT)).id
												dStawka = TabPozVat.StVat(TabPozVat.ZnajdzStawke(lStawka)).stawka
											endif
										else
											opis = TabPozVat.PozVat(iPos).opis
										endif

										opis = NormalizeString(opis, lOPIS)

										eksport.Pole("Stawka_pl", (Using "%d", dStawka))
										eksport.Pole("Opis", opis)

										eksport.Pole("Wartosc", (Using "%f",TabPozVat.PozVat(iPos).wartosc))
										eksport.Pole("rejestrVat", TabRejVat.RejVat(iPom).Skrot)
										eksport.Pole("Usluga", (Using "%d", TabPozVat.PozVat(iPos).usluga))
										eksport.Pole("UE", (Using "%d",TabPozVat.PozVat(iPos).UE))
										eksport.KoniecSekcji() //"Pozycja VAT"
									endif
								next iPos
							endif
							//////////////////////////////[Pozycja VAT] - koniec//////
						eksport.KoniecSekcji() //"Rejestr"
					next iPomStVat
				next iPom

				TabRejVat.IloscRejestrow(-1)
				TabRejVat.ClearRec()
		EndSelect
		EndIf

		ZapiszTRAROZ(xDekretacjeSp, 0, xDokumentDkPar.kurs)

	eksport.KoniecSekcji() //"Dokument"
EndSub