//"EksportDkNew.sci","Eksport dokumentw (nowych) - include","\Eksport\Eksport include\",0,1.0.1,SYSTEM
// Eksport dokumentw (nowych) - include

#include "Waciwoci dokumentw - include"

//#define DOK_PUSTAOPER			0x20		// analogicznie po stronie FK   , nie wysyamy flagi, bazujemy na typach dokumentw FK
MKP_EXP = 0

Int SKIP_INVOICE_CORRECTION_defined
#ifdef SKIP_INVOICE_CORRECTION
	SKIP_INVOICE_CORRECTION_defined = 1
#else
	SKIP_INVOICE_CORRECTION_defined = 0
#endif

#ifdef EKSPORT_MK
	MKP_EXP = 1
#endif
#ifndef __EKSPORTDKNEW_SCI
#define	__EKSPORTDKNEW_SCI

int declare EksportujRozliczeniaPn(Dispatch xRozliczenia)

int Sub Eksport_rozrachunek(Dispatch xRozr)
	if (!xRozr) then
		Eksport_rozrachunek = 0
		Exit
	EndIf

	Eksport_rozrachunek = 1

	String strSectionName
	strSectionName = "rozrachunek"

	eksport.PoczatekPodsekcji(strSectionName)
		eksport.Pole("uid", xRozr.guid)
		eksport.Pole("numer", Using "%s", xRozr.numer)
		eksport.Pole("waluta", xRozr.waluta)
		eksport.Pole("kurs", Using "%.12f", xRozr.kurs)
		eksport.Pole("kwota", Using "%f", xRozr.kwota)
		eksport.Pole("data_platnosci", xRozr.data_platnosci)
		eksport.Pole("termin", xRozr.termin)
		eksport.Pole("znacznik", Using "%l", xRozr.znacznik)
		eksport.Pole("opis", xRozr.opis)
		eksport.Pole("wartoscrozl", Using "%f", xRozr.kwotaRozl)
		eksport.Pole("ok", Using "%d", xRozr.rozliczona)
		EksportNotatka(xRozr.notatka, "notatka")
	eksport.KoniecSekcji()
EndSub

int Sub Eksport_ITS(Dispatch xDk)
	Eksport_ITS = 1

	if (!xDk.czyITS) then
		Eksport_ITS = 0
		Exit
	EndIf

	Dispatch xIntrastat, xTmp
	long i, nCount, idDk
	String strSectionName
	strSectionName = "Intrastat"

	xIntrastat = xFactory.NewObject("BIntrastat")
	Eksport_ITS = xIntrastat.Load(Using "id = %l", xDk.id)
	if (!Eksport_ITS) then
		eksport.PoczatekPodsekcji(strSectionName)
			eksport.Pole("nazwa", xIntrastat.nazwa)
			eksport.Pole("kodMg", xDk.numer)
			eksport.Pole("czyPrzychod", Using "%d", xIntrastat.czyPrzychod)
			eksport.PoczatekPodsekcji("transakcja")
				eksport.Pole("kod", xIntrastat.transakcja.kod)
			eksport.KoniecSekcji()
			eksport.PoczatekPodsekcji("dostawa")
				eksport.Pole("kod", xIntrastat.dostawa.kod)
			eksport.KoniecSekcji()
			eksport.PoczatekPodsekcji("transport")
				eksport.Pole("kod", xIntrastat.transport.kod)
			eksport.KoniecSekcji()
			if (xIntrastat.czyPrzychod) then
				eksport.PoczatekPodsekcji("krajWysylki")
					eksport.Pole("symbol", xIntrastat.krajWysylki.symbol)
					EksportKrajIST(xIntrastat.krajWysylki.symbol, xIntrastat.krajWysylki.czyKraj)
				eksport.KoniecSekcji()
			Else
				eksport.PoczatekPodsekcji("krajPrzeznaczenia")
					eksport.Pole("symbol", xIntrastat.krajPrzeznaczenia.symbol)
					EksportKrajIST(xIntrastat.krajPrzeznaczenia.symbol, xIntrastat.krajPrzeznaczenia.czyKraj)
				eksport.KoniecSekcji()
			EndIf
			nCount = xIntrastat.pozycje.count
			for i=1 to i>nCount
				xTmp = xIntrastat.pozycje.item(i)
				eksport.PoczatekPodsekcji("pozycja")
					eksport.Pole("lp", Using "%d", xTmp.lp)
					eksport.Pole("kodTw", xTmp.kodTw)
					eksport.Pole("wartstat", Using "%f", xTmp.wartstat)
					eksport.PoczatekPodsekcji("krajPochodzenia")
						eksport.Pole("symbol", xTmp.krajPochodzenia.symbol)
						EksportKrajIST(xTmp.krajPochodzenia.symbol, xTmp.krajPochodzenia.czyKraj)
					eksport.KoniecSekcji()
				eksport.KoniecSekcji()
			next i
		eksport.KoniecSekcji()
	EndIf
EndSub

int Sub EksportOpisu(string strOpis)
	String opis = strOpis
	If opis != "" Then
		Arg "#*", "$#$*"
		Arg "#&", "$#$&"
		buf=opis
		Replace Arg
		Delete Arg
		opis=buf
		Arg "\r", "#&"
		Arg "\n", "#*"
		buf=opis
		Replace Arg
		Delete Arg
		opis=buf
		while opis
			eksport.PoczatekPodsekcji("opis")
				eksport.Pole("opis", Mid( opis, 1, MaxLenLine ))
			eksport.KoniecSekcji()
			opis=Mid( opis, MaxLenLine+1, 10000)
		wend
	EndIf
	EksportOpisu = 0
EndSub

int Sub WypelnijEksportRec_Uz(Dispatch xUz)

	dispatch xUzytkownik

	eksport.PoczatekPodsekcji("osoba")	//osoba
		xUzytkownik = GetObjByKod("BUzytkownik", xUz.kod)
		eksport.Pole("kod", xUzytkownik.kod)
		eksport.Pole("nazwa", xUzytkownik.nazwa)
	eksport.KoniecSekcji()	//osoba
	WypelnijEksportRec_Uz = 0
EndSub

int Sub WypelnijEksportRec_Kh(Dispatch xKh)
	eksport.Pole("KhKod", xKh.KhKod)
	eksport.Pole("id", Using "%l", xKh.id)
	eksport.Pole("KhID", Using "%l", xKh.KhID)
	eksport.Pole("KhTyp", Using "%l", xKh.KhTyp)
	eksport.Pole("KhNazwa", xKh.KhNazwa)
	eksport.Pole("KhAdres", xKh.KhAdres)
	eksport.Pole("KhUlica", xKh.KhUlica)
	eksport.Pole("KhDomu", xKh.KhDomu)
	eksport.Pole("KhLokal", xKh.KhLokal)
	eksport.Pole("KhMiasto", xKh.KhMiasto)
	eksport.Pole("KhPoczta", xKh.KhPoczta)
	eksport.Pole("KhNIP", xKh.KhNIP)
	eksport.Pole("KhRodzaj", Using "%l", xKh.KhRodzaj)
	eksport.Pole("KhCharakter", Using "%l", xKh.KhCharakter)
	eksport.Pole("nazwaAdresu", xKh.nazwaAdresu)
	eksport.PoczatekPodsekcji("kraj")	//kraj
//		eksport.Pole("aktywny", Using "%l", xKh.kraj.aktywny)
//		eksport.Pole("ue", Using "%l", xKh.kraj.ue)
		eksport.Pole("symbol", xKh.kraj.symbol)
//		eksport.Pole("nazwa", xKh.kraj.nazwa)
//		eksport.Pole("formatVAT", xKh.kraj.formatVAT)
//		eksport.Pole("formatNIP", xKh.kraj.formatNIP)

		EksportKraj(xKh.kraj.symbol)
	eksport.KoniecSekcji()		//kraj

	WypelnijEksportRec_Kh = 0
EndSub

int Sub WypelnijEksportRec_Poz(Dispatch xPoz, Long idSuperKoryg, Int CzyPrzychod)

	Dispatch xDok
	String   strDokument
	Int czyKorekta = IIF( xPoz.id == 0, 1, 0 )

	eksport.Pole("wlasna", Using "%d", xPoz.wlasna)
	eksport.Pole("id", Using "%l", xPoz.id)
	eksport.Pole("kod", xPoz.kod)
	eksport.Pole("lp", Using "%l", xPoz.lp)
	eksport.Pole("lpsuper", Using "%l", xPoz.lpsuper)
	If idSuperKoryg Then
		// korekta zbiorcza - dodatkowa informacja o dokumencie korygowanym zbiorczo
		If CzyPrzychod Then
			strDokument = "BDokZk"
		Else
			strDokument = "BDokSp"
		EndIf
		xDok = GetObjById( strDokument, idSuperKoryg )
		If !xDok Then PrintError( Using "Brak w bazie DK rekordu o id = %d", idSuperKoryg )
		eksport.Pole( "kodDokKZ", xDok.numer )
	EndIf
	EksportOpisu(xPoz.opis)
	xPoz.PodajKodObcy()
	eksport.Pole("kodObcy", xPoz.kodObcy)
	eksport.Pole("ilosc", Using "%f", xPoz.ilosc)
	eksport.Pole("iloscWp", Using "%f", xPoz.iloscWp)
	eksport.Pole("jednostkaMiary", xPoz.jednostkaMiary)
	eksport.Pole("jednostkaMiaryWp", xPoz.jednostkaMiaryWp)
	eksport.Pole("PKWiU", xPoz.PKWiU)
	eksport.Pole("cena", Using "%f", xPoz.cena)
	eksport.Pole("idPozKoryg", Using "%l", xPoz.idPozKoryg)
	eksport.Pole("flagi", Using "%l", xPoz.flagi)
	eksport.Pole("typFlagi", Using "%l", xPoz.typFlagi)

	Select Case xPoz.objId
		Case TiPozycjaSp
			eksport.Pole("wartPrzychod", Using "%f", xPoz.wartPrzychod)
			eksport.Pole("cenaZakupu", Using "%f", xPoz.cenaZakupu)
			eksport.Pole("cenaZakupuPl", Using "%f", xPoz.cenaZakupuPl)
			eksport.Pole("cenaCennikowa", Using "%f", xPoz.cenaCennikowa)
			eksport.Pole("rabat", Using "%f", xPoz.rabat)
			eksport.Pole("eksportUslug", Using "%d", xPoz.eksportUslug)
			eksport.Pole("VATUE", Using "%d", xPoz.VATUE)
			EksportRejestrVAT(xPoz.rejestrVAT)
			eksport.PoczatekPodsekcji("rejestrVAT")	//rejestrVAT
				eksport.Pole("skrot", xPoz.rejestrVAT.skrot)
			eksport.KoniecSekcji()	//rejestrVAT
			If CzyCechaOO( xPoz.Dokument.charakter ) Then
				eksport.Pole( "odwrotneObc", ( Using "%d", xPoz.odwrotneObc ) )
			EndIf
			eksport.Pole("JPK_V7", xPoz.JPK_V7)
		Case TiPozycjaZo
			eksport.Pole("cenaCennikowa", Using "%f", xPoz.cenaCennikowa)
			eksport.Pole("rabat", Using "%f", xPoz.rabat)
		Case TiPozycjaZk
			eksport.Pole("cenaWWalucie", Using "%f", xPoz.cenaWWalucie)
			eksport.Pole("cenaWWalucieWp", Using "%f", xPoz.cenaWWalucieWp)
			eksport.Pole("kosztZakupu", Using "%f", xPoz.kosztZakupu)
			EksportRejestrVAT(xPoz.rejestrVAT)
			eksport.PoczatekPodsekcji("rejestrVAT")	//rejestrVAT
				eksport.Pole("skrot", xPoz.rejestrVAT.skrot)
			eksport.KoniecSekcji()	//rejestrVAT

			if xPoz.rejVATnalicz then
				EksportRejestrVAT(xPoz.rejVATnalicz)
				eksport.PoczatekPodsekcji("rejVATnalicz")	//rejestrVAT
					eksport.Pole("skrot", xPoz.rejVATnalicz.skrot)
				eksport.KoniecSekcji()
			endif

			if xPoz.rejestrVATnalezny then
				EksportRejestrVAT(xPoz.rejestrVATnalezny)
				eksport.PoczatekPodsekcji("rejestrVATnalezny")	//rejestrVAT
					eksport.Pole("skrot", xPoz.rejestrVATnalezny.skrot)
				eksport.KoniecSekcji()
			endif
			If CzyCechaOO( xPoz.Dokument.charakter ) Then
				eksport.Pole( "odwrotneObc", ( Using "%d", xPoz.odwrotneObc ) )
			EndIf
			If CzyCechaVat50( xPoz.Dokument.charakter ) Then
				eksport.Pole( "vat50", ( Using "%d", xPoz.czyVat50 ) )
			EndIf
			eksport.Pole("JPK_V7", xPoz.JPK_V7)
		Case TiPozycjaZw
			eksport.Pole("kosztZakupu", Using "%f", xPoz.kosztZakupu)
		Case TiPozycjaMg
			eksport.Pole("cenaZakupu", Using "%f", xPoz.cenaZakupu)
			eksport.Pole("cenaCennikowa", Using "%f", xPoz.cenaCennikowa)
			EksportRejestrVAT(xPoz.rejestr)
			eksport.PoczatekPodsekcji("rejestr")	//rejestr
				eksport.Pole("skrot", xPoz.rejestr.skrot)
			eksport.KoniecSekcji()	//rejestr
	EndSelect
	if (TiPozycjaMg != xPoz.objId) then
		eksport.Pole("cenaPLNWp", Using "%f", xPoz.cenaPLNWp)
		eksport.Pole("cenaWWalucieWp", Using "%f", xPoz.cenaWWalucieWp)
		eksport.Pole("cenaWp", Using "%f", xPoz.cenaWp)
		eksport.Pole("typCeny", Using "%d", xPoz.typCeny)
		eksport.Pole("rodzajCeny", Using "%d", xPoz.rodzajCeny)
		eksport.Pole("netto", Using "%f", xPoz.netto)
		eksport.Pole("nettoWal", Using "%f", xPoz.nettoWal)
		eksport.Pole("VAT", Using "%f", xPoz.VAT)
		eksport.Pole("brutto", Using "%f", xPoz.brutto)
		eksport.Pole("bruttoWal", Using "%f", xPoz.bruttoWal)
		eksport.Pole("niePodlega", Using "%f", xPoz.niePodlega)
		eksport.Pole("niePodlegaWal", Using "%f", xPoz.niePodlegaWal)
		EksportStawkaVAT(xPoz.infoStVAT)
	endif
	if (TiPozycjaZk == xPoz.objId) then
		eksport.Pole("clo", Using "%f", xPoz.clo)
		eksport.Pole("akcyza", Using "%f", xPoz.akcyza)
	endif
	eksport.Pole("wartosc", Using "%f", xPoz.wartosc)
	if (TiPozycjaMg == xPoz.objId) then
		eksport.Pole("przychod", Using "%f", xPoz.przychod)
		eksport.Pole("rozchod", Using "%f", xPoz.rozchod)
		eksport.Pole("dostawa", Using "%f", xPoz.dostawa)
		eksport.Pole("nazwaDostawy", xPoz.nazwaDostawy)
		eksport.Pole("wartk", Using "%f", xPoz.wartk)
	else
		eksport.Pole("wartoscWp", Using "%f", xPoz.wartoscWp)
	endif
	Select Case xPoz.objId
		Case TiPozycjaSp, TiPozycjaZk, TiPozycjaMg
			eksport.Pole("schematKsiegowania", xPoz.schematKsiegowania)
	EndSelect

	EksportTWbyKod(xPoz.kod, 0)

	If FunctionalityDimensioning() Then
		// wymiarowanie pozycji dokumentu
		xPoz.inicjujPodzialKwoty( czyKorekta )
		xPoz.podzialKwoty.odczytajPodzialKwoty()
		EksportujWymiary( xPoz.podzialKwoty )
	EndIf

	WypelnijEksportRec_Poz = 0
EndSub

int Sub WypelnijEksportRec_DkAttr(Dispatch xDk)
	WypelnijEksportRec_DkAttr = 0
	//eksport do gwnych sekcji wybranych atrybutow dokumentu

	//kontrahent_1
	if (xDk.daneKh.KhID) then
		if (TiDokumentPn == xDk.objId) then
			if (!xDk.transfer) then
				select case xDk.danekh.KhTyp
					case 2 // pracownik
						EksportWR(xDk.danekh.KhID, 0)
					case 3 // urzad
						EksportUZ(xDk.danekh.KhID, 0)
					case 1 // kontrahent
						EksportKH(xDk.danekh.KhID, 0)
				endselect
			EndIf
		Else
			if (!xDk.czyMM) then
				EksportKH(xDk.daneKh.KhID, 0)
			EndIf
		EndIf
	EndIf

	Select case xDk.objId
		case TiDokumentSp, TiDokumentZk, TiDokumentZo, TiDokumentZw
			//kontrahent_2
			if (xDk.daneOd.KhID) then
				EksportKH(xDk.daneOd.KhID, 0)
			EndIf
	EndSelect

	Select case xDk.objId
		case TiDokumentSp, TiDokumentZk, TiDokumentZo, TiDokumentZw
			//dzia
			EksportDzial(xDk.dzial.id)
			//rejestr patnoci
//			EksportRejestr(xDk.rejestr.id)
			if (!xDk.czyFakturaWewnetrzna) then
				EksportRejestrIFormaPl(xDk.rejestr, xDk.formaPl)
			EndIf
			EksportTypDokumentu(xDk.typDk, xDk.seria, xDk.charakter, xDk.objId)
			EksportWaluta(xDk.waluta)
		case TiDokumentMg
			//magazyn
			EksportMagazyn(xDk.dzial.id)
			if (xDk.czyMM) then
				EksportMagazyn(xDk.magazyn_przesuniecia.id)
			EndIf
			EksportTypDokumentu(xDk.typDk, xDk.seria, xDk.charakter, xDk.objId)
		case TiDokumentPn
			//rejestr patnoci
			EksportRejestr(xDk.rejestr.id)
//			EksportRejestrIFormaPl(xDk.rejestr, xDk.formaPl)
			//rejestr transferu
			if (xDk.transfer) Then
				EksportRejestr(xDk.rejestr_transferu.id)
			EndIf
			EksportTypDokumentu(xDk.typDk, xDk.seria, xDk.charakter, xDk.objId)
	EndSelect


//rodzaj

//katalog

//rejestr(VAT)

//forma patnoci

//kraj

//stawka VAT

//uytkownik

//towar

//kontrahent

//waluta?

//typDokumentu

//seria dokumentu

	WypelnijEksportRec_DkAttr = 1
EndSub

int Sub EksportTransakcji(Dispatch xTrans)
	Select Case xTrans.objId
		Case TiTransakcjaTw
			eksport.PoczatekPodsekcji("transakcjaTw")	//transakcja
		Case TiTransakcjaZm
			eksport.PoczatekPodsekcji("transakcjaZm")	//transakcja
		Case TiTransakcjaPn
//			eksport.PoczatekPodsekcji("transakcjaPn")	//transakcja
			debugger
	EndSelect
		eksport.Pole("rozliczona", (Using "%d", xTrans.rozliczona))
		eksport.Pole("status", (Using "%d", xTrans.status))
	eksport.KoniecSekcji()	//transakcja
EndSub

int Sub EksportPowiazan(long idTrans, long idDk)
	if (!idTrans) then
		Exit
	EndIf

	Dispatch connAdo	// poczenie ADO
	String   strSQL		// polecenia SQL
	Dispatch xRec		// RecordSet

	xRec="ADODB.Recordset"
	xRec.LockType=3		// adLockOptimistic
	xRec.CursorType=1	// OpenKeyset cursor - dziala RecordCount()
	connAdo = GetAdoConnection()

	int nTyp, nOk, nLpSwoj, nLpObcy
	long lId, lIdBazy
	String strKod, strData
	float dIlosc, dWartosc

	int nTypPrev = -1
	long lIdPrev = 0
	String strKodPrev = ""

	int nSectionBegin = 0

	//(typ, id, kodDk, okDk, lpSwoj, lpObcy, ilosc, wartosc, data)
	strSQL = Using "EXEC hm_Eksport_RozliczeniaDk '%d', '%d'", idTrans, idDk
	xRec.Open(strSQL, connAdo)
	if (!xRec.EOF()) then

		While !xRec.EOF()
			//odczyt danych z rekordu
			nTyp = xRec.Fields("typ").Value
			lId = xRec.Fields("id").Value
			strKod = xRec.Fields("kodDk").Value
			lIdBazy = xRec.Fields("baza").Value
			nOk = xRec.Fields("okDk").Value
			nLpSwoj = xRec.Fields("lpSwoj").Value
			nLpObcy = xRec.Fields("lpObcy").Value
			dIlosc = xRec.Fields("ilosc").Value
			dWartosc = xRec.Fields("wartosc").Value
			strData = xRec.Fields("data").Value

			//zapisanie odpowiedniej (pod)sekcji
			if ((nTypPrev != nTyp) || (lIdPrev != lId) || AmStrCmpI(strKodPrev, strKod)) Then
				if (nSectionBegin) Then
					eksport.KoniecSekcji()	//powiazanie
				EndIf
				eksport.PoczatekPodsekcji("powiazanie")	//powiazanie
				eksport.Pole("typ", (Using "%d", nTyp))
				eksport.Pole("kodDk", strKod)
				eksport.Pole("baza", (Using "%l", lIdBazy))
				eksport.Pole("okDk", (Using "%d", nOk))
				nSectionBegin = 1
			EndIf

			eksport.PoczatekPodsekcji("rozliczenie")	//rozliczenie
				eksport.Pole("lpSwoj", (Using "%d", nLpSwoj))
				eksport.Pole("lpObcy", (Using "%d", nLpObcy))
				eksport.Pole("kodDk", strKod)
				eksport.Pole("baza", (Using "%l", lIdBazy))
				eksport.Pole("okDk", (Using "%d", nOk))
				eksport.Pole("ilosc", (Using "%f", dIlosc))
				eksport.Pole("wartosc", (Using "%f", dWartosc))
				eksport.Pole("data", strData)
			eksport.KoniecSekcji()	//rozliczenie

			//zapamietanie poprzednich wartosci
			nTypPrev = nTyp
			lIdPrev = lId
			strKodPrev = strKod

			//nastpny rekord
			xRec.MoveNext()
		wend
	endif
	xRec.Close()

	if (nSectionBegin) Then
		eksport.KoniecSekcji()	//powiazanie
	EndIf

	EksportPowiazan = 0
EndSub

int Sub EksportSekcjiPowiazania(int nTyp, String strKod, long lBaza, int nOk)
	eksport.PoczatekPodsekcji("powiazanie")	//powiazanie
		eksport.Pole("typ", (Using "%d", nTyp))
		eksport.Pole("kodDk", strKod)
		eksport.Pole("baza", (Using "%l", lBaza))
		eksport.Pole("okDk", (Using "%d", nOk))
	eksport.KoniecSekcji()	//powiazanie
	EksportSekcjiPowiazania = 0
EndSub

/*
//typ:
#define	DKconnNORMAL		0
#define	DKconnBUFOR			1
#define	DKconnLABEL			2
//subtyp:
#define	DKconnPARAGONY		8
#define	DKconnDK_MM			9
#define	DKconnKWM			10
#define	DKconnPRZYJDOKWM	11
#define	DKconnFAKTURAWEWN	12
#define	DKconnZLECENIE		13
*/

int Sub EksportPowiazanychDk(Dispatch xPowDk)

	long nCount, i
	Dispatch xTmp

	xPowDk.RefreshOK()
	nCount = xPowDk.count
	for i=1 to i>nCount
		xTmp = xPowDk.item(i)

		Select Case xTmp.subtyp
			Case DKconnPARAGONY, DKconnDK_MM, DKconnKWM, DKconnPRZYJDOKWM, DKconnFAKTURAWEWN, DKconnZLECENIE
			if (DKconnNORMAL == xTmp.typ) then
				EksportSekcjiPowiazania(xTmp.subtyp, xTmp.nazwa, xTmp.dkBase, xTmp.dkOk)
			EndIf
		EndSelect

	next i

	EksportPowiazanychDk = 0
EndSub


int Sub EksportujPowiazania(Dispatch xDk)

	Select Case xDk.objId
		Case TiDokumentSp, TiDokumentZk
			if (xDk.czyKorekta) then
				EksportPowiazan(xDk.idTransOrig, xDk.id)
			else
				EksportPowiazan(xDk.transakcjaTw.id, xDk.id)
			EndIf
//			EksportPowiazan(xDk.transakcjaPn.id, xDk.id)
			if (xDk.rozrachunekDk) then
				EksportujRozliczeniaPn(xDk.rozrachunekDk.rozliczeniaPn)
			EndIf
		Case TiDokumentMg
			if (xDk.czyKorekta) then
				EksportPowiazan(xDk.idTransOrig, xDk.id)
			else
				EksportPowiazan(xDk.transakcjaTw.id, xDk.id)
			EndIf
		Case TiDokumentZo, TiDokumentZw
			if (xDk.czyKorekta) then
				EksportPowiazan(xDk.idTransOrig, xDk.id)
			else
				EksportPowiazan(xDk.transakcjaZm.id, xDk.id)
			EndIf
		Case TiDokumentPn
			debugger //?? i co teraz ??
	EndSelect

	if (TiDokumentPn != xDk.ObjId) Then
		EksportPowiazanychDk(xDk.powiazaneDk)
	EndIf

	EksportujPowiazania = 1
EndSub

int Sub WypelnijEksportRec_Dokument(Dispatch xDk, String strSectionName)

	WypelnijEksportRec_Dokument = WypelnijEksportRec_DkAttr(xDk)
	If (!WypelnijEksportRec_Dokument) Then
		Exit
	EndIf

	String strFieldName, strFieldValue
	Dispatch xDkZKor
	Long idSuperKoryg

	eksport.PoczatekSekcji(strSectionName, xDk.id)	//strSectionDok
		long nCount, i
		Dispatch xTmp
		Int CzyKZ = IIF( xDk.CzyHandlowy, xDk.CzyKZ, 0 )
		If (xDk.czyKorekta && !CzyKZ) then
			// pojedyncza korekta - zapisujemy powiazanie z poprzednia korekta lub dokumentem oryginalnym
			xDkZKor = xDk.dokumentZKorektami
			nCount = xDkZKor.count
			if (nCount > 1) then
				if (xDk.korekty) then
					nCount = nCount - xDk.korekty.count
				EndIf
				xTmp = xDkZKor.item(nCount-1)
				eksport.Pole("kodDokKoryg", xTmp.numer)
			EndIf
		EndIf
		If ( xDk.czyKorekta && CzyKZ ) Then
			// korekta zbiorcza - zapisujemy powiazanie z dokumentami oryginalnymi
			xDkZKor = xDk.dokumentyKorygowaneKZ
			nCount = xDkZKor.count
			For i = 1 To i > nCount
				eksport.PoczatekPodsekcji( "kodDokKZ" )
				eksport.Pole( "numer", xDkZKor.Item( i ).kod )
				eksport.KoniecSekcji()
			Next i
		EndIf

		eksport.Pole("id", Using "%l", xDk.id)
		eksport.Pole("numer", xDk.numer)
		eksport.Pole("typDk", xDk.typDk)
		eksport.Pole("nazwa", xDk.nazwa)
		eksport.Pole("charakter", Using "%l", xDk.charakter)
		eksport.Pole("seria", xDk.seria)
		eksport.Pole("numerWSerii", Using "%l", xDk.numerWSerii)
		eksport.Pole("dataWystawienia", xDk.dataWystawienia)
		eksport.Pole( "jpk", ( Using "%d", xDk.jpk ) )
		If (MKP_EXP) then
			eksport.Pole("okresNumeracji", Using "%l",  RecalculatePeriod(xDk.okresNumeracji, xDk.dataWystawienia))
		else
			eksport.Pole("okresNumeracji", Using "%l", xDk.okresNumeracji)
		endif
		eksport.Pole("numeracjaWDziale", Using "%l", xDk.numeracjaWDziale)
		eksport.Pole("opis", xDk.opis)
		eksport.Pole("odebranyPrzez", xDk.odebranyPrzez)
		eksport.Pole("znacznik", Using "%l", xDk.znacznik)
		eksport.Pole("czyAnulowany", Using "%d", xDk.czyAnulowany)
		eksport.Pole("anulowanyFaktura", IIF(xDk.czyAnulowany==3,"1","0"))
		eksport.Pole("czyImportZPrem", Using "%d", xDk.czyImportZPrem)
		eksport.Pole("rozliczenieReczne", Using "%l", xDk.rozliczenieReczne)
		if Test(xDk.objId, FIdkJPK_V7) then
			eksport.Pole("JPK_V7", xDk.JPK_V7)
		endif
		if Test(xDk.objId, FiGUID) then
			eksport.Pole("uid", xDk.guid)
		endif
		if Test(xDk.objId, FiMETODAVAT) then
			eksport.Pole("metodaVAT", Using "%d", xDk.metodaVAT)
		endif
		if Test(xDk.objId, FiNALICZVAT) then
			eksport.Pole("naliczanieVAT", Using "%d", xDk.naliczanieVAT)
		endif
		if Test(xDk.objId, FiSCHEMATKS) then
			eksport.Pole("schematKsiegowania", xDk.schematKsiegowania)
		endif
		if Test(xDk.objId, FiDATASPRZEDAZY) then
			eksport.Pole("dataSprzedazy", xDk.dataSprzedazy)
			// Czy akceptowalna pusta data operacji gospodarczej ?
			// Tak jesli akceptowalna pusta data sprzedazy.
			//eksport.Pole("flag", (Using "%d", IIF(xDk.PustaDataSprzedazy, DOK_PUSTAOPER, 0))) // nie wysyamy flagi, bazujemy na typach dokumentw FK
		endif
		if Test(xDk.objId, FiDATAZAKUPU) then
			eksport.Pole("dataZakupu", xDk.dataZakupu)
		endif
		if Test(xDk.objId, FiDATAOBCY) then
			eksport.Pole("dataWystawieniaObca", xDk.dataWystawieniaObca)
		endif
		if Test(xDk.objId, FiDATAOPERACJI) then
			eksport.Pole("dataOperacji", xDk.dataOperacji)
		endif
		if Test(xDk.objId, FiTERMIN) then
			eksport.Pole("termin", xDk.termin)
		endif
		if Test(xDk.objId, FiDATAWPLYWU) then
			eksport.Pole("dataWplywu", xDk.dataWplywu)
		endif
		if Test(xDk.objId, FiWALUTA) then
			eksport.Pole("waluta", xDk.waluta)
		endif
		if Test(xDk.objId, FiKURS) then
			eksport.Pole("kurs", Using "%.12f", xDk.kurs)
		endif
		if Test(xDk.objId, FiPRZELICZNIK) then
			eksport.Pole("przelicznikKursu", Using "%f", xDk.przelicznikKursu)
		endif
		if Test(xDk.objId, FiKURSWP) then
			eksport.Pole("kursWp", Using "%f", xDk.kursWp)
		endif
		if Test(xDk.objId, FiKURSDOCH) then
			eksport.Pole("kurs", Using "%.12f", xDk.kurs)
		endif
		if Test(xDk.objId, FiKURSDOCHWP) then
			eksport.Pole("kursDochWp", Using "%f", xDk.kursDochWp)
		endif
		if Test(xDk.objId, FiNETTO) then
			eksport.Pole("netto", Using "%f", xDk.netto)
		endif
		if Test(xDk.objId, FiVAT) then
			eksport.Pole("vat", Using "%f", xDk.vat)
		endif
		if Test(xDk.objId, FiBRUTTO) then
			eksport.Pole("brutto", Using "%f", xDk.brutto)
		endif
		if Test(xDk.objId, FiNIEPODLEGA) then
			eksport.Pole("niePodlega", Using "%f", xDk.niePodlega)
		endif
		if Test(xDk.objId, FiPRZYCHOD) then
			eksport.Pole("przychod", Using "%f", xDk.przychod)
		endif
		if Test(xDk.objId, FiROZCHOD) then
			eksport.Pole("rozchod", Using "%f", xDk.rozchod)
		endif
		if Test(xDk.objId, FiWARTK) then
			eksport.Pole("wartk", Using "%f", xDk.wartk)
		endif
		if Test(xDk.objId, FiWARTOSC) then
			eksport.Pole("wartosc", Using "%f", xDk.wartosc)
		endif
		if Test(xDk.objId, FiWARTOSCWAL) then
			eksport.Pole("wartoscWWalucie", Using "%f", xDk.wartoscWWalucie)
		endif
		if Test(xDk.objId, FiRABAT) then
			eksport.Pole("rabat", Using "%f", xDk.rabat)
		endif
		if Test(xDk.objId, FiRABATDOWARTOSCI) then
			eksport.Pole("rabatDoWartosci", Using "%l", xDk.rabatDoWartosci)
		endif
		if Test(xDk.objId, FiNUMEROBCY) then
			eksport.Pole("numerObcy", Using "%s", OdczytajKodObcy( xDk.id, xDk.charakter, xDk.numerObcy ))
		endif
		if Test(xDk.objId, FiTYPCENY) then
			eksport.Pole("typCeny", Using "%d", xDk.typCeny)
		endif
		if Test(xDk.objId, FiRODZAJCENY) then
			eksport.Pole("rodzajCeny", Using "%d", xDk.rodzajCeny)
		endif
		EksportNotatka(xDk.notatka, "notatka")
		eksport.PoczatekPodsekcji("dzial")	//dzial
			eksport.Pole("kod", xDk.dzial.kod)
		eksport.KoniecSekcji()	//dzial
		eksport.PoczatekPodsekcji("rodzaj")	//rodzaj
			eksport.Pole("id", Using "%l", xDk.rodzaj.id)
			eksport.Pole("kod", xDk.rodzaj.kod)
		eksport.KoniecSekcji()	//rodzaj
		eksport.PoczatekPodsekcji("katalog")	//katalog
			eksport.Pole("nazwa", xDk.katalog.nazwa)
		eksport.KoniecSekcji()	//katalog
		if Test(xDk.objId, FiFORMAPLATN) then
			eksport.PoczatekPodsekcji("rejestr")	//rejestr
				eksport.Pole("id", Using "%l", xDk.rejestr.id)
				eksport.Pole("kod", xDk.rejestr.kod)
				eksport.Pole("nazwa", xDk.rejestr.nazwa)
				eksport.Pole("aktywny", Using "%l", xDk.rejestr.aktywny)
				eksport.Pole("typRejestru", Using "%l", xDk.rejestr.typRejestru)
			eksport.KoniecSekcji()	//rejestr
			eksport.PoczatekPodsekcji("formaPl")	//formaPl
				eksport.Pole("nazwa", xDk.formaPl.nazwa)
				eksport.Pole("typ", Using "%l", xDk.formaPl.typ)
				eksport.Pole("id", Using "%l", xDk.formaPl.id)
				eksport.Pole("klient", Using "%l", xDk.formaPl.klient)
			eksport.KoniecSekcji()	//formaPl
		endif
		if Test(xDk.objId, FiTERMINPLAT) then
			eksport.Pole("terminPlatnosci", xDk.terminPlatnosci)
		endif
		if Test(xDk.objId, FiREJESTRVAT) then
			EksportRejestrVAT(xDk.rejestrVAT)
			eksport.PoczatekPodsekcji("rejestrVAT")	//rejestrVAT
				eksport.Pole("skrot", xDk.rejestrVAT.skrot)
			eksport.KoniecSekcji()	//rejestrVAT
		endif
		if Test(xDk.objId, FiREJESTRVATDATA) then
			eksport.Pole("dataRejestrVAT", xDk.dataRejestrVAT)
		endif
		if Test(xDk.objId, FiREJESTRMG) then
			EksportRejestrVAT(xDk.rejestr)
			eksport.PoczatekPodsekcji("rejestr")	//rejestr
				eksport.Pole("skrot", xDk.rejestr.skrot)
			eksport.KoniecSekcji()	//rejestr
		endif
		if Test(xDk.objId, FiREJVATNALICZ) then
			if xDk.czyFakturaWewnetrzna then
				EksportRejestrVAT(xDk.rejVATnalicz)
				eksport.PoczatekPodsekcji("rejVATnalicz")	//rejVATnalicz
					eksport.Pole("skrot", xDk.rejVATnalicz.skrot)
				eksport.KoniecSekcji()	//rejVATnalicz
			endif
		endif
		if Test(xDk.objId, FiREJVATDATANALICZ) then
			if xDk.czyFakturaWewnetrzna then
				eksport.Pole("dataRejVATnalicz", xDk.dataRejVATnalicz)
			endif
		endif
		if Test(xDk.objId, FiREJVATNALEZNY) then
			if xDk.czyDrugiRej then
				EksportRejestrVAT(xDk.rejestrVATnalezny)
				eksport.PoczatekPodsekcji("rejestrVATnalezny")	//rejestrVATnalezny
					eksport.Pole("skrot", xDk.rejestrVATnalezny.skrot)
				eksport.KoniecSekcji()	//rejestrVATnalezny
			endif
		endif
		if (xDk.czyMM) then
			eksport.PoczatekPodsekcji("magazyn_przesuniecia")	//magazyn_przesuniecia
				eksport.Pole("id", Using "%l", xDk.magazyn_przesuniecia.id)
				eksport.Pole("kod", xDk.magazyn_przesuniecia.kod)
				eksport.Pole("nazwa", xDk.magazyn_przesuniecia.nazwa)
			eksport.KoniecSekcji()	//magazyn_przesuniecia
		else
			eksport.PoczatekPodsekcji("daneKh")	//daneKh
				WypelnijEksportRec_Kh(xDk.daneKh)
			eksport.KoniecSekcji()	//daneKh
		EndIf
		if (TiDokumentMg != xDk.objId) then
			eksport.PoczatekPodsekcji("daneOd")	//daneOd
				WypelnijEksportRec_Kh(xDk.daneOd)
			eksport.KoniecSekcji()	//daneOd
		endif
		if (xDk.czyPWM) then
			eksport.Pole("cenyPWM", Using "%d", xDk.cenyPWM)
		endif

		WypelnijEksportRec_Uz(xDk.osoba)

		if xDk.objId == TiDokumentZk Then
			eksport.Pole("RejestrPodatnikow", Using "%d", xDk.czySprawdzWL)
		EndIf
		if xDk.objId == TiDokumentSp || xDk.objId == TiDokumentZk Then
			eksport.Pole("MPP", Using "%d", xDk.splitPayment)
		EndIf
		if xDk.objId == TiDokumentZk Then
			eksport.Pole("DMPP", Using "%d", xDk.czyDobrowolneMPP)
			eksport.Pole("RachunekBankowy", Using "%s", xDk.accountNo)
		EndIf

		nCount = xDk.pozycje.count
		for i=1 to i>nCount
			xTmp = xDk.pozycje.item(i)
			eksport.PoczatekPodsekcji("pozycja")	//pozycja
			If xDk.CzyKorekta && xDk.CzyHandlowy Then
				// korekta zbiorcza - dodatkowa informacja o dokumencie korygowanym zbiorczo
				idSuperKoryg = IIF( xDk.CzyKZ, xTmp.idSuperKoryg, 0 )
			Else
				idSuperKoryg = 0
			EndIf

			if (xDk.czyKorekta) then
				eksport.PoczatekPodsekcji("przedKorekta")	//przedKorekta
					WypelnijEksportRec_Poz(xTmp.przedKorekta, idSuperKoryg, xDk.CzyPrzychod)
				eksport.KoniecSekcji()	//przedKorekta
				eksport.PoczatekPodsekcji("poKorekcie")	//poKorekcie
					WypelnijEksportRec_Poz(xTmp.poKorekcie, idSuperKoryg, xDk.CzyPrzychod)
				eksport.KoniecSekcji()	//poKorekcie
			else
				WypelnijEksportRec_Poz(xTmp, idSuperKoryg, xDk.CzyPrzychod)
			endif
			eksport.KoniecSekcji()	//pozycja
		next i

		Select Case xDk.objId
			Case TiDokumentSp, TiDokumentZk
				EksportTransakcji(xDk.transakcjaTw)
//				EksportTransakcji(xDk.transakcjaPn)
			Case TiDokumentMg
				EksportTransakcji(xDk.transakcjaTw)
			Case TiDokumentZo, TiDokumentZw
				EksportTransakcji(xDk.transakcjaZm)
		EndSelect

		WypelnijEksportRec_Dokument = EksportujPowiazania(xDk)
		If (!WypelnijEksportRec_Dokument) Then
			Exit
		EndIf

		if (TiDokumentMg == xDk.objId) then
			if (xDk.czyITS && !xDk.czyAnulowany) then
				Eksport_ITS(xDk)
			EndIf
		EndIf

		if Test(xDk.objId, XiROZRACHUNEK) then
			if (!xDk.czyAnulowany) then
				xTmp = xDk.rozrachunekDk
				if (xTmp) then
					Eksport_rozrachunek(xTmp)
				EndIf
			EndIf
		endif

	eksport.KoniecSekcji()	//strSectionDok

	WypelnijEksportRec_Dokument = 1
EndSub

int Sub EksportujRozliczeniaPn(Dispatch xRozliczenia)

	long nCount, i
	Dispatch xTmp//, xOperacja

	nCount = xRozliczenia.count
	for i=1 to i>nCount
		xTmp = xRozliczenia.item(i)

//		xOperacja = xFactory.NewObject("BOperacjaPn")
//		xOperacja.Load(Using "id = %l", xTmp.idOperacji)

		eksport.PoczatekPodsekcji("powiazaniePn")	//powiazanie
//			eksport.Pole("typ", (Using "%d", 2))
			eksport.Pole("kodDk", xTmp.numerSecPn)
//			eksport.Pole("baza", (Using "%l", 32))
//			eksport.Pole("okDk", (Using "%d", xOperacja.rozliczona)) //!AM! Cos z tym trzeba zrobi!!!!
//			eksport.PoczatekPodsekcji("rozliczeniePn")	//rozliczenie
//				eksport.Pole("kodDk", xTmp.numerSecPn)
//				eksport.Pole("baza", (Using "%l", 32))
				eksport.Pole("okDk", (Using "%d", xTmp.okSecPn))
//				eksport.Pole("ilosc", (Using "%f", xTmp.ilosc))
				eksport.Pole("wartosc", (Using "%f", xTmp.wartosc))
				eksport.Pole("kurs", (Using "%.12f", xTmp.kurs))
				eksport.Pole("kursSecPn", (Using "%f", xTmp.kursSecPn))
				eksport.Pole("data", xTmp.data)
//			eksport.KoniecSekcji()	//rozliczenie
		eksport.KoniecSekcji()	//powiazanie

	next i

	EksportujRozliczeniaPn = 1
EndSub

int Sub WypelnijEksportRec_DkPn(Dispatch xDk)

	WypelnijEksportRec_DkPn = WypelnijEksportRec_DkAttr(xDk)
	If (!WypelnijEksportRec_DkPn) Then
		Exit
	EndIf

	String strSectionName, strFieldName, strFieldValue

	strSectionName = strSectionDokPN

	eksport.PoczatekSekcji(strSectionName, xDk.id)	//strSectionDok
		eksport.Pole("id", Using "%l", xDk.id)
		eksport.Pole("uid", xDk.guid)
		eksport.Pole("numer", xDk.numer)
		eksport.Pole("typDk", xDk.typDk)
		eksport.Pole("charakter", Using "%l", xDk.charakter)
		eksport.Pole("seria", xDk.seria)
		eksport.Pole("numerWSerii", Using "%l", xDk.numerWSerii)
		eksport.Pole("data_platnosci", xDk.data_platnosci)
		If(MKP_EXP) then
			eksport.Pole("okresNumeracji", Using "%l", RecalculatePeriod(xDk.okresNumeracji, xDk.data_platnosci))
		else
			eksport.Pole("okresNumeracji", Using "%l", xDk.okresNumeracji)
		endif
		eksport.Pole("numeracjaWDziale", Using "%l", xDk.numeracjaWDziale)
		eksport.Pole("opis", xDk.opis)
		eksport.Pole("znacznik", Using "%l", xDk.znacznik)
		eksport.Pole("schemat", xDk.schemat)
		eksport.Pole("kwota", Using "%f", xDk.Kwota)
		eksport.Pole("kwotaFK", Using "%f", IIF(xDk.Wyplata, -1, 1) * xDk.Kwota)
		eksport.Pole("kurs", Using "%.12f", xDk.kurs)
		eksport.Pole("waluta", xDk.waluta)
		eksport.Pole("wyplata", Using "%l", xDk.Wyplata)
		eksport.Pole("skojarzony", xDk.skojarzony)
		eksport.Pole("termin", xDk.Termin)
//		DISP_READONLY_I4	(BDokumentPn, "id_dokumentu",		FiIDDOK,		m_dwDkId)
//		eksport.Pole("kodDokumentu", xDk.kodDokumentu)
		eksport.Pole("transfer", Using "%l", xDk.transfer)
		eksport.Pole("platnosc", Using "%l", xDk.platnosc)
		eksport.Pole("bufor", Using "%l", xDk.bufor)
		eksport.Pole("czyAnulowany", Using "%l", xDk.czyAnulowany)
		eksport.Pole("rozliczona", Using "%l", xDk.rozliczona)
		eksport.Pole("rappn_kod", xDk.rappn_kod)
		eksport.Pole("rappnExpFK", Using "%l", xDk.rappnExpFK)
		eksport.Pole("CzyRozrachunekFK", Using "%l", xDk.CzyRozrachunekFK)
		eksport.Pole("CzyAutomatyczny", Using "%l", xDk.CzyAutomatyczny)
		eksport.Pole("rozliczenieReczne", Using "%l", xDk.rozliczenieReczne)
		eksport.Pole("status", Using "%l", xDk.status)
		eksport.Pole("rejestr_platnosci", xDk.rejestr.kod)

		EksportNotatka(xDk.notatka, "notatka")

		eksport.PoczatekPodsekcji("rejestr")	//rejestr
			eksport.Pole("id", Using "%l", xDk.rejestr.id)
			eksport.Pole("kod", xDk.rejestr.kod)
			eksport.Pole("nazwa", xDk.rejestr.nazwa)
			eksport.Pole("aktywny", Using "%l", xDk.rejestr.aktywny)
			eksport.Pole("typRejestru", Using "%l", xDk.rejestr.typRejestru)
		eksport.KoniecSekcji()	//rejestr

		if (xDk.transfer) Then
			eksport.PoczatekPodsekcji("rejestr_transferu")	//rejestr_transferu
				eksport.Pole("kod", xDk.rejestr_transferu.kod)
				eksport.Pole("nazwa", xDk.rejestr_transferu.nazwa)
				eksport.Pole("aktywny", Using "%l", xDk.rejestr_transferu.aktywny)
				eksport.Pole("typRejestru", Using "%l", xDk.rejestr_transferu.typRejestru)
			eksport.KoniecSekcji()	//rejestr_transferu
		Else
			eksport.PoczatekPodsekcji("daneKh")	//daneKh
				WypelnijEksportRec_Kh(xDk.daneKh)
			eksport.KoniecSekcji()	//daneKh
		EndIf

		WypelnijEksportRec_Uz(xDk.osoba)

		EksportujRozliczeniaPn(xDk.rozliczeniaPn)
		Eksport_RozliczenieDok_RP(xDk)
	eksport.KoniecSekcji()	//strSectionDok

	WypelnijEksportRec_DkPn = 1
EndSub

int Sub WypelnijEksportRec_Dk(Dispatch xDk)

	WypelnijEksportRec_Dk = 0

	long nCount, i, j, nTmp
	Dispatch xTmp, xDokument, xDok, xTrans, xDkOrig, xDkZKor
	String strSectionName, strObjectName, str

	Select Case xDk.objId
		Case TiDokumentSp
			strSectionName = strSectionDokSP
			strObjectName = objDokumentSp
		Case TiDokumentZk
			strSectionName = strSectionDokZK
			strObjectName = objDokumentZk
		Case TiDokumentMg
			strSectionName = strSectionDokMG
			strObjectName = objDokumentMg
		Case TiDokumentZo
			strSectionName = strSectionDokZO
			strObjectName = objDokumentZo
		Case TiDokumentZw
			strSectionName = strSectionDokZW
			strObjectName = objDokumentZw
		Case Else
			debugger
			//nie powinien tu wej!
	EndSelect

	xDkZKor = xDk.dokumentZKorektami
	If SKIP_INVOICE_CORRECTION_defined Then
		// eksport tylko biezacego / wskazanego dokumentu
		nCount = 0
	Else
		// eksport dokumentu oryginalnego i lancucha korekt
		nCount = xDkZKor.count
	EndIf
	if (nCount) then
		for i=1 to i>nCount
			xTmp = xDkZKor.item(i)
			if (!eksport.SekcjaIstnieje(strSectionName, xTmp.id)) then

				xDokument = xFactory.NewObject(strObjectName)
				xDokument.Load(Using "id=%l", xTmp.id)

				if (xDokument.czyWystawiony) then
					WypelnijEksportRec_Dokument(xDokument, strSectionName)
				EndIf
			EndIf
		next i
	Else
		if (!eksport.SekcjaIstnieje(strSectionName, xDk.id)) then
			WypelnijEksportRec_Dokument(xDk, strSectionName)
		EndIf
	EndIf

	if (iRownoKsiegMag && ((TiDokumentSp == xDk.objId) || (TiDokumentZk == xDk.objId))) Then
		if (xDk.czyKorekta) then
			str = GetObjectNameFromObjectId(xDk.ObjId)
			xDkOrig = xFactory.NewObject(str)
			xDkOrig.Load(Using "id = %l", xDk.idKorygowany)
			xTrans = xDkOrig.transakcjaTw
		else
			xTrans = xDk.transakcjaTw
		EndIf
		nCount = xTrans.powiazaniaTw.count

		for i=1 to i>nCount
			xTmp = xTrans.powiazaniaTw.item(i)
			if (!xTmp.bufor) then

				xDokument = xFactory.NewObject("BDokumentMg")
				xDokument.Load(Using "id = %l", xTmp.idWlascicielaTrans)

				xDkZKor = xDokument.dokumentZKorektami
				If SKIP_INVOICE_CORRECTION_defined Then
					// eksport tylko biezacego / wskazanego dokumentu
					nTmp = 0
				Else
					// eksport dokumentu oryginalnego i lancucha korekt
					nTmp = xDkZKor.count
				EndIf
				if (nTmp) then
					for j=1 to j>nTmp
						xTmp = xDkZKor.item(j)
						if (!eksport.SekcjaIstnieje(strSectionDokMG, xTmp.id)) then

							xDok = xFactory.NewObject("BDokumentMg")
							xDok.Load(Using "id=%l", xTmp.id)

							if (xDok.czyWystawiony) then
								WypelnijEksportRec_Dokument(xDok, strSectionDokMG)
							EndIf
						EndIf
					next j
				Else
					if (!eksport.SekcjaIstnieje(strSectionDokMG, xDokument.id)) then
						WypelnijEksportRec_Dokument(xDokument, strSectionDokMG)
					EndIf
				EndIf
			EndIf
		next i
	EndIf

	WypelnijEksportRec_Dk = 1

EndSub

#endif //__EKSPORTDKNEW_SCI


