//"ekspDef.sci","Eksport definicje - include","\Eksport\Eksport include\",0,2.0.10,SYSTEM
/////////////////////////////////////////
// "Eksport definicje - include"
// ekspDef.sci
/////////////////////////////////////////
#include "Const - include"
#include "Przelicz okres dla Symfonii - include"

limit 10000

Int MKP_EXP = 0
#ifdef EKSPORT_MK
	MKP_EXP = 1
#endif
#define KHtypKH		1
#define KHtypPR		2
#define KHtypUR		3

// dokumenty sprzeday

#define ANUL	  0		// dokument anulowany
#define WZANUL	  1		// dokument anulowany
#define PANUL	  3		// paragon anulowany

// dokumenty sprzeday

#define FVS      40     // faktura VAT
#define FKS      41     // faktura korygujca VAT
#define RUS      42     // rachunek uproszczony
#define RKS      43     // rachunek korygujcy VAT
#define DXK      45     // dokument eksp. korygujcy
#define DEX      46     // dokument eksportowy
#define FAS      79     // faktura
#define FAK      80     // faktura korygujca
#define PAR      50     // paragon
#define PRK      51     // paragon korekta
#define ZMO		 86     // zamwienia obce
#define FVW		101		// f-ra VAT w walucie
#define FKW		102		// korekta VAT w walucie
#define ZWO		103		//Zamowienie obce w walucie
#define FVM		106		//Faktura VAT MP
#define FKM		107		//Faktura korygujaca VAT MP
#define FZS		108		//Faktura zaliczkowa
#define KZS		109		//Kontrakt zaliczkowy
#define ZKS		112		//Faktura korygujaca zaliczkowa
#define WDT		114		//Wewntrzwsplnotowa dostawa towaru
#define FWS		116		//Faktura wewntrzna (sprzeday)
#define WKS		118		//Faktura korygujca wewntrzna (sprzeday)
#define WDK		120		//Wewntrzwsplnotowa dostawa towaru korekta
#define ZSK		122		//Kontrakt zaliczkowy korekta
#define FVT		124		//Faktura VAT mara	(inaczej: turystyczna)
#define FTK		125		//Faktura VAT mara (inaczej: turystyczna) korekta
#define REX		126		//Rachunek eksportowy
#define RXK		127		//Rachunek eksportowy korekta
#define SKO		134		//Kontrakt sprzeday
#define SKK		135		//Kontrakt sprzeday korekta
#define SZA		136		//Zaliczka sprzeday
#define SZK		137		//Zaliczka sprzeday korekta
#define SKW		150		//Kontrakt sprzedazy w walucie
#define SKWK	151		//Kontrakt sprzedazy w walucie korekta
#define SZW		152		//Zaliczka sprzedazy w walucie
#define SZWK	153		//Zaliczka sprzedazy w walucie korekta

// dokumenty zakupu

#define FVZ      68      // faktura VAT zakupu
#define FKZ      69      // faktura korygujaca VAT zakupu
#define RUZ      70      // rachunek uproszczony zakupu
#define RKZ      71      // rachunek korygujacy VAT zakupu
#define DIM      72      // dokument importowy
#define DKM      73      // dokument importowy korekta
#define ZMW      87      // zamwienia wasne
#define ZRZ      97      // rachunek zakupu
#define ZRK      98      // rachunek zakupu korekta
#define FVR      99      // fakura VAT RR
#define FKR      100     // faktura korygujca VAT RR
#define ZWW		 104	 // Zamowienie wlasne w walucie
#define KZZ		111		//Kontrakt zaliczkowy zakupu
#define ZKZ		113		//Faktura korygujaca zaliczkowa zakupu
#define WNT		115		//Wewntrzwsplnotowe nabycie towaru
#define FWZ		117		//Faktura wewntrzna (zakupu)
#define WKZ		119		//Faktura korygujca wewntrzna (zakupu)
#define WNK		121		//Wewntrzwsplnotowe nabycie towaru korekta
#define ZZK		123		//Kontrakt zaliczkowy zakupu korekta
#define FZZ		128		//Faktura zaliczkowa zakupu
#define	ZVW		138		//Faktura VAT zakupu w walucie
#define	ZWK		139		//Faktura VAT zakupu w walucie korekta

// dokumenty magazynowe

#define PW       74     // przychod wewnetrzny
#define PWK      75     // przychod wewnetrzny korekta
#define RW       76     // rozchod wewnetrzny
#define RWK      77     // rozchod wewnetrzny korekta
#define WZM      78     // wydanie z magazynu
#define WZK      88     // wydanie z magazynu korekta
#define PZM      89     // przyjcie do magazynu
#define PZK      81     // przyjcie do magazynu korekta
#define MMP      82     // przesunicie magazynowe plus
#define MKP      83     // przesunicie magazynowe plus korekta
#define MMM      84     // przesunicie magazynowe minus
#define MKM      85     // przesunicie magazynowe minus korekta
#define KWM      90     // korekta wartoci magazynu
#define PWM      91     // przecena wartoci magazynu
#define	WDP		129		// wydanie do produkcji
#define	WPK		130		// wydanie do produkcji korekta
#define	PZP		131		// przyjcie z produkcji
#define	PPK		132		// przyjcie z produkcji korekta

#define TiRejSp			0x2B6A	//	typ rejestru sp
#define TiRejZk			0x2B6B	//	typ rejestru zk
#define TiRejMg			0x2B6C	//	typ rejestru mg

#define	TiDokumentSp	0x2BD2	// dokument sprzeday
#define	TiDokumentZk	0x2BD3	// dokument zakupu
#define	TiDokumentMg	0x2BD4	// dokument magazynowy
#define	TiDokumentZo	0x2BD5	// dokument zamwienie obce
#define	TiDokumentZw	0x2BD6	// dokument zamwienie wasne
#define TiDokumentPn	0x2BFA	// dokument patnoci

#define TiDokSp			0x2BA0
#define TiDokZo			0x2BA1
#define TiDokMg			0x2BA2
#define TiDokZk			0x2BA3
#define TiDokZw			0x2BA4
#define TiDokPn			0x2BA9
#define TiRapPn			0x2C60	// raport patnoci
#define TiRapOkr		0x2E64	// raport okresowy

#define flagDpTypEksUsl		0x0100  //Eksport usug  domylnie zaznaczony dla towarw typu usuga i odznaczony dla pozostaych
#define flagDpTypVatUE		0x0200  //VAT-UE  domylnie zaznaczony dla kontrahentw z opcj Zarejestrowany w VIES

#define flagDpTypPozComm	0x01	//nie wchodzi do dekretacji

#define ESTATUS_PUSTY		0		// zwykly        - nie zlecony
#define ESTATUS_EPRZELEW	1       // elektroniczny - zlecony
#define ESTATUS_BANKOPER	2		// platnosc na podstawie operacji bankowej

long DECLARE GETIDxVATNP ()
dispatch DECLARE GETxStawkaObjectByIdentifier (long identifier)

record InfoStVat
	long id
	int  typ
	float stawka
	string nazwa[10]
	int aktywna
	float netto
	float vat
	float wnetto
	float wbrutto

	int Sub ClearRec()
		id = -2000
		typ = 0
		stawka = 0
		nazwa = ""
		aktywna = 0
		netto = 0
		vat = 0
		wnetto = 0
		wbrutto = 0
	EndSub

	int Sub Init(dispatch dpStVat)
		id = dpStVat.id
		typ = dpStVat.typ
		select case typ
			case STVAT_ZWOLNIONE
				stawka = -1
			case STVAT_NIEPODLEGA
				stawka = -2
			case else
				stawka = dpStVat.wartosc * 100
		endselect
		nazwa = dpStVat.nazwa
		aktywna = dpStVat.aktywny
	EndSub
endrec

record InfoRejVat
	InfoStVat StVat(1)
	long id
	string JPK_V7[10]
	long ABCD
	string nazwaFK[50]
	float sumNetto
	float sumVat
	int Naliczony
	string Skrot[50]
	string Nazwa[40]
	int Rodzaj
	int Sub ClearRec()
		int iPom
		id = -2000
		JPK_V7 = ""
		ABCD=1
		nazwaFK = ""
		sumNetto = 0
		sumVat = 0
		Naliczony = 0
		Skrot = ""
		Nazwa = ""
		Rodzaj = 0
		for iPom = 1 to iPom > size(StVat)
			StVat(iPom).ClearRec()
		next iPom
	EndSub

	int Sub Znajdz(dispatch dpStVat)
		int iPom

		Znajdz=-2000
		for iPom=1 to iPom > size(StVat)
			if StVat(iPom).id == dpStVat.id then exit
		next iPom
		if iPom > size(StVat) then
			if size(StVat) == 1 && StVat(1).id == -2000 then
				StVat(1).Init(dpStVat)
				Znajdz = 1
			else
				grow StVat,1
				StVat(size(StVat)).ClearRec()
				StVat(size(StVat)).Init(dpStVat)
				Znajdz = size(StVat)
			endif
		else
			Znajdz = iPom
		endif
	endsub

	int Sub Wstaw(dispatch dpStVat, dispatch dpPozycja, int p_Naliczony, int nMinus)
		int iPom = Znajdz(dpStVat)
		float f = 1.0
		if nMinus then f = -1.0
		if !dpPozycja.czyVat50 then
		StVat(iPom).netto+=(f * dpPozycja.netto)
		StVat(iPom).netto+=(f *dpPozycja.niePodlega)
		StVat(iPom).vat+=(f *dpPozycja.VAT)
		StVat(iPom).wnetto+=(f *dpPozycja.nettoWal)
		StVat(iPom).wnetto+= (f * dpPozycja.niePodlegaWal)
		StVat(iPom).wbrutto+=(f *dpPozycja.bruttoWal)
		StVat(iPom).wbrutto+= (f * dpPozycja.niePodlegaWal)
		Naliczony=p_Naliczony
		sumNetto+=(f *dpPozycja.netto)
		//sumNetto+=(f *dpPozycja.niePodlega)
		sumVat+=(f *dpPozycja.VAT)
		else 
			if dpStVat.czyNpNew || dpStVat.czyNpOld then	//ta czesc co nie podlega
				StVat(iPom).netto+=(f * Round(dpPozycja.netto/2))
				StVat(iPom).netto+=(f * dpPozycja.Vat50)
				StVat(iPom).wnetto+=(f * Round(dpPozycja.bruttoWal/2))
				StVat(iPom).wnetto+=(f * Round(dpPozycja.niePodlegaWal/2))
				StVat(iPom).wbrutto+=(f * Round(dpPozycja.bruttoWal/2))
				StVat(iPom).wbrutto+= (f * Round(dpPozycja.niePodlegaWal/2))
				Naliczony=p_Naliczony
			else
				StVat(iPom).netto+=(f * (dpPozycja.netto - Round(dpPozycja.netto/2)))
				//StVat(iPom).netto+=(f * (dpPozycja.niePodlega - Round(dpPozycja.niePodlega/2)))
				StVat(iPom).vat+=(f * (dpPozycja.VAT - dpPozycja.Vat50))
				StVat(iPom).wnetto+=(f * (dpPozycja.nettoWal - Round(dpPozycja.nettoWal/2)))
				//StVat(iPom).wnetto+= (f * (dpPozycja.niePodlegaWal - Round(dpPozycja.niePodlegaWal/2)))
				StVat(iPom).wbrutto+=(f * (dpPozycja.bruttoWal - Round(dpPozycja.bruttoWal/2)))
				//StVat(iPom).wbrutto+= (f * (dpPozycja.niePodlegaWal - Round(dpPozycja.niePodlegaWal/2)))
				Naliczony=p_Naliczony
				sumNetto+=(f * (dpPozycja.netto - Round(dpPozycja.netto/2)))
				//sumNetto+=(f *dpPozycja.niePodlega)
				sumVat+=(f * (dpPozycja.VAT - dpPozycja.Vat50))
			endif
		endif
	endsub

	Int Sub WstawRV( Dispatch dpStVat, Float netto, Float vat )

		Int		iPom = Znajdz( dpStVat )

		StVat( iPom ).netto += netto
		StVat( iPom ).vat += vat
		StVat( iPom ).wnetto += netto
		StVat( iPom ).wbrutto += ( netto + vat )
		Naliczony = 0
		sumNetto += netto
		sumVat += vat

	EndSub

	int Sub IloscStawek(int ile)
		if !ile then
			IloscStawek=size(StVat)
		else
			shrink StVat,ile
		endif
	endsub
endrec


record InfoTabRejVat
	InfoRejVat RejVat(1)

	int Sub ClearRec()
		int iPom

		for iPom = 1 to iPom > size(RejVat)
			RejVat(iPom).ClearRec()
		next iPom
	endsub

	int Sub Znajdz(dispatch dpRej, string JPK_V7, long ABCD)
		int iPom

		Znajdz=-2000
		for iPom=1 to iPom > size(RejVat)
			if RejVat(iPom).id == dpRej.id  && RejVat(iPom).ABCD==ABCD && RejVat(iPom).JPK_V7==JPK_V7 then exit
		next iPom
		if iPom > size(RejVat) then
			if size(RejVat) == 1 && RejVat(1).id == -2000 then
				RejVat(1).id = dpRej.id
				RejVat(1).ABCD = ABCD
				RejVat(1).Skrot = dpRej.skrot
				RejVat(1).Nazwa = dpRej.nazwa
				RejVat(1).Rodzaj = dpRej.rodzaj
				RejVat(1).JPK_V7 = JPK_V7
				Znajdz = 1
			else
				grow RejVat,1
				RejVat(size(RejVat)).ClearRec()
				RejVat(size(RejVat)).id = dpRej.id
				RejVat(size(RejVat)).ABCD = ABCD
				RejVat(size(RejVat)).Skrot = dpRej.skrot
				RejVat(size(RejVat)).Nazwa = dpRej.nazwa
				RejVat(size(RejVat)).Rodzaj = dpRej.rodzaj
				RejVat(size(RejVat)).JPK_V7 = JPK_V7
				Znajdz = size(RejVat)
			endif
		else
			Znajdz = iPom
		endif
	endsub

	int Sub Wstaw(dispatch dpRej, dispatch dpStVat, dispatch dpPozycja, long ABCD, int p_Naliczony, int nMinus, Int SendAggregated)
		int iPom

		if ABCD&2 then
			ABCD=2
		else
			if ABCD&4 then
				ABCD=4
			else
				if ABCD&8 then
					ABCD=8
				else
					ABCD=1
				endif
			endif
		endif

		iPom = Znajdz(dpRej, IIF(SendAggregated, AggregatedGTU(), dpPozycja.JPK_V7), ABCD)
		RejVat(iPom).Wstaw(dpStVat, dpPozycja, p_Naliczony, nMinus)
		
	endsub
	
	Int Sub WstawRV( Dispatch dpRej, string JPK_V7, Dispatch dpStVat, Float netto, Float vat )

		Int iPom = Znajdz( dpRej, JPK_V7, 1 )

		RejVat( iPom ).WstawRV( dpStVat, netto, vat )
		
	EndSub
	
	float Sub Wartosc(int iRej, int iStVat, string pole)
		select case pole
			case "netto"
				Wartosc=RejVat(iRej).StVat(iStVat).netto
			case "vat"
				Wartosc=RejVat(iRej).StVat(iStVat).vat
			case "stawka"
				Wartosc=RejVat(iRej).StVat(iStVat).stawka
			case "wnetto"
				Wartosc=RejVat(iRej).StVat(iStVat).wnetto
			case "wbrutto"
				Wartosc=RejVat(iRej).StVat(iStVat).wbrutto
		endselect
	endsub

	int Sub IloscRejestrow(int ile)
		int iPom

		if !ile then
			IloscRejestrow=size(RejVat)
		else
			shrink RejVat,ile
			for iPom = 1 to iPom > size(RejVat)
				RejVat(iPom).IloscStawek(ile)
			next iPom
		endif
	endsub

	int Sub IloscStawek(int iRej)
		IloscStawek=RejVat(iRej).IloscStawek(0)
	endsub
endrec

InfoTabRejVat TabRejVat

Dispatch xAdoConnection = GetAdoConnection()
Dispatch xAdoRecordset = "ADODB.Recordset"
dispatch cmdAdoCommand = "ADODB.Command"
xAdoRecordset.CursorType = 1
xAdoRecordset.LockType = 3

String		sSqlRequest
Dispatch	StVatRV
Dispatch	RejVatRV

record InfoPozycjaVat
	long id
	long stawka
	string towar[50]
	string opis[250]
	float wartosc
	long rejestrVat
	string JPK_V7[10]
	int usluga
	int UE

	int Sub ClearRec()
		id = -2000
		stawka = 0
		towar = ""
		wartosc = 0
		rejestrVat = 0
		opis = ""
		usluga = 0
		UE = 0
		JPK_V7 = ""
	EndSub
endrec

record InfoTabPozycjaVat
	InfoPozycjaVat PozVat(1)
	InfoStVat	   StVat(1)

	int Sub ClearRec()
		int iPom

		for iPom = 1 to iPom > size(StVat)
			StVat(iPom).ClearRec()
		next iPom

		for iPom = 1 to iPom > size(PozVat)
			PozVat(iPom).ClearRec()
		next iPom
	endsub

	int Sub ZnajdzStawke(long lStVat)
		int iPom
		ZnajdzStawke = -1
		for iPom=1 to iPom > size(StVat)
			if StVat(iPom).id == lStVat then
				ZnajdzStawke = iPom
				exit
			endif
		next iPom
	endsub

	int Sub InitStawke(dispatch dpStVat)
		int iPom

		InitStawke=-2000
		for iPom=1 to iPom > size(StVat)
			if StVat(iPom).id == dpStVat.id then exit
		next iPom
		if iPom > size(StVat) then
			if size(StVat) == 1 && StVat(1).id == -2000 then
				StVat(1).Init(dpStVat)
				InitStawke = 1
			else
				grow StVat,1
				StVat(size(StVat)).ClearRec()
				StVat(size(StVat)).Init(dpStVat)
				InitStawke = size(StVat)
			endif
		else
			InitStawke = iPom
		endif
	endsub

	int Sub Wstaw(dispatch pozycja, float wartosc, int czyDEX)
		int iPom
		dispatch stawka

    	//dla DEX i DXK poza pozycjami NP,wszystkie wysylamy ze stawka 0%
		if czyDEX && pozycja.stVAT.typ != STVAT_NIEPODLEGA && pozycja.stVAT.typ != STVAT_ZEROWA then
			stawka = xFactory.GetObject("BStawkaVAT")
			stawka.Load("id=1004")
		else
			stawka = pozycja.stVAT
		endif
		if size(PozVat) > 1 || (PozVat(1).id != -2000) then grow PozVat,1
		iPom = size(PozVat)
		PozVat(iPom).ClearRec()
		PozVat(iPom).id = pozycja.id
		PozVat(iPom).stawka = StVat(InitStawke(stawka)).id
		PozVat(iPom).towar = pozycja.kod
		PozVat(iPom).opis = pozycja.opis
		PozVat(iPom).wartosc = wartosc
		PozVat(iPom).rejestrVat = pozycja.rejestrVAT.id
		PozVat(iPom).usluga = pozycja.eksportUslug
		PozVat(iPom).UE = pozycja.vatue
		PozVat(iPom).JPK_V7 = pozycja.JPK_V7
		Wstaw = iPom
	endsub

	int Sub Rozmiar()
		Rozmiar = size(PozVat)
	endsub
endrec

InfoTabPozycjaVat	TabPozVat

dispatch sub GetObjById(string sObiekt, long id)
	dispatch xParams = xFactory.NewObject("XParams")

	xParams.id = id
	GetObjById = xFactory.GetObject(sObiekt, xParams)
endsub

dispatch sub GetObjByKod(string sObiekt, string str)
	dispatch xParams = xFactory.NewObject("XParams")

	xParams.kod = str
	GetObjByKod = xFactory.GetObject(sObiekt, xParams)
endsub


String strOpis

int Sub DodajDoOpisu(String strCzescOpisu, String strSeparator)
// zmienne globalne: String strOpis

	if ( 59 == len(strOpis) ) then Exit

	String Tablica_kod(2) = "\"","\'"
	String strTmp = Translate(strCzescOpisu, Tablica_kod)

	if ( strOpis == "" ) then
		strOpis = strTmp
	else
		if ( len(strOpis) < 55 ) then
			strOpis += strSeparator
			strOpis += strTmp
		endif
	endif

	if ( len(strOpis) > 59 ) then
		strOpis = mid(strOpis, 0, 56)
		strOpis += "..."
	endif
EndSub

#define		EKSP_WSZYSTKIE		0	// eksportuj wszystkie
#define		PYTAJ_UZYTK			1	// pytaj uytkownika
#define		POMIN_WSZYSTKIE		2	// pomi wszystkie
#define 	NOTATKA "Notatka_Dl"
#define 	MaxLenLine 300
#define 	NAZWA "Nazwa_Dl"

int nEZatwWart = PYTAJ_UZYTK

// sprawdzanie czy eksportowa niezatwierdzone wartociowo

int Sub EkspZatwWart(dispatch dpDokMg, string strKodHandl)
	EkspZatwWart = 1

	int err, nRes, bZatw = 1
	string sMessTekst

	// 0- niezatwierdzony wartosciowo
	Dispatch xDokMg = GetObjByKod("BDokMg", dpDokMg.numer)

	long idMG = xDokMg.id
	bZatw = xDokMg.czyZatwWart

	if strKodHandl == "" then
		sMessTekst = "Dokument '%s' nie zosta zatwierdzony wartociowo.{{icon=? check=(&zastosuj dla wszystkich) buttons=[&Eksportuj:o](&Pomi:i)  title=(Eksport danych)}}"
		sMessTekst = using sMessTekst, dpDokMg.numer
	else
		sMessTekst = "Dokument magazynowy '%s' skojarzony z dokumentem handlowym '%s' nie zosta zatwierdzony wartociowo.{{icon=? check=(&zastosuj dla wszystkich) buttons=[&Eksportuj:o](&Pomi:i)  title=(Eksport danych)}}"
		sMessTekst = using sMessTekst, dpDokMg.numer, strKodHandl
	endif

	if nEZatwWart == EKSP_WSZYSTKIE then // nie sprawdzamy czy zatwierdzone wartociowo
		if !bZatw then
			eksport.AddInfo(sMessTekst)
		endif
		EkspZatwWart = 1
		Exit
	endif

	if !bZatw then // nie jest zatwierdzony wartociowo
		if nEZatwWart == POMIN_WSZYSTKIE then // nie eksportujemy nie zatwierdzonych
			eksport.AddError(sMessTekst)
			EkspZatwWart = 0
			Exit
		endif

		// Pytamy si uytkownika
		err = Message(sMessTekst)
		eksport.AddAsk(sMessTekst, err)

		if err == 1 || err == (1+16) then // eksportuj
			EkspZatwWart = 1
			if err == (1+16) then // dla wszystkich
				nEZatwWart = EKSP_WSZYSTKIE
			endif
			Exit
		endif

		// pozostae pomi...
		EkspZatwWart = 0
		if err == (5+16) then // pomi dla wszystkich
			nEZatwWart = POMIN_WSZYSTKIE
		endif
	endif
EndSub

int Sub EksportMagazyn(long lMag)
	int nRes
	int idx

	dispatch xMagazyn = GetObjById("BMagazyn", lMag)

	if !eksport.SekcjaIstnieje("Magazyn", lMag) then
		eksport.PoczatekSekcji("Magazyn", lMag)
			eksport.Pole("kod",					xMagazyn.kod)
			eksport.Pole("nazwa",				xMagazyn.nazwa)
			eksport.Pole("miejscowosc",			xMagazyn.miejscowosc)
			eksport.Pole("ulica",				xMagazyn.ulica)
			eksport.Pole("dom",					xMagazyn.dom)
			eksport.Pole("lokal",				xMagazyn.lokal)
			eksport.Pole("kodPocztowy",			xMagazyn.kodPocztowy)
			eksport.Pole("rejon", 				xMagazyn.rejon)
			eksport.Pole("telefon1",			xMagazyn.telefon1)
			eksport.Pole("telefon2",			xMagazyn.telefon2)
			eksport.Pole("fax",					xMagazyn.fax)
			eksport.Pole("email",				xMagazyn.email)
			eksport.Pole("kontoFK",				xMagazyn.kontoFK)

			for idx = 1 to idx > xMagazyn.dzialy.Count()
				eksport.PoczatekPodsekcji("dzialy")
					eksport.Pole("kod", xMagazyn.dzialy.Item(idx).obiekt.kod)
				eksport.KoniecSekcji() //"dzialy"
			next idx

		eksport.KoniecSekcji() //"Magazyn"
	endif
EndSub

int Sub EksportDzial(long lDz)
	int nRes
	int idx

	dispatch xDzial = GetObjById("BDzial", lDz)

	if !eksport.SekcjaIstnieje("Dzial", lDz) then
		eksport.PoczatekSekcji("Dzial", lDz)
			eksport.Pole("kod",					xDzial.kod)
			eksport.Pole("nazwa",				xDzial.nazwa)
			eksport.Pole("miejscowosc",			xDzial.miejscowosc)
			eksport.Pole("ulica",				xDzial.ulica)
			eksport.Pole("dom",					xDzial.dom)
			eksport.Pole("lokal",				xDzial.lokal)
			eksport.Pole("kodPocztowy",			xDzial.kodPocztowy)
			eksport.Pole("rejon", 				xDzial.rejon)
			eksport.Pole("telefon1",			xDzial.telefon1)
			eksport.Pole("telefon2",			xDzial.telefon2)
			eksport.Pole("fax",					xDzial.fax)
			eksport.Pole("email",				xDzial.email)
			eksport.Pole("kontoFK",				xDzial.kontoFK)

			for idx = 1 to idx > xDzial.magazyny.Count()
				eksport.PoczatekPodsekcji("magazyny")
					eksport.Pole("kod", xDzial.magazyny.Item(idx).obiekt.kod)
				eksport.KoniecSekcji() //"magazyny"
			next idx

			for idx = 1 to idx > xDzial.rejestry.Count()
				eksport.PoczatekPodsekcji("rejestry")
					eksport.Pole("kod", xDzial.rejestry.Item(idx).obiekt.kod)
				eksport.KoniecSekcji() //"rejestry"
			next idx

		eksport.KoniecSekcji() //"Dzial"
	endif
EndSub

int Sub EksportRejestr(long lRj)
	int nRes
	int idx

	dispatch xRejestr = GetObjById("BRejestr", lRj)

	if !eksport.SekcjaIstnieje("Rejestr", lRj) then
		eksport.PoczatekSekcji("Rejestr", lRj)
			eksport.Pole("kod",					xRejestr.kod)
			eksport.Pole("nazwa",				xRejestr.nazwa)
			eksport.Pole("miejscowosc",			xRejestr.miejscowosc)
			eksport.Pole("ulica",				xRejestr.ulica)
			eksport.Pole("dom",					xRejestr.dom)
			eksport.Pole("lokal",				xRejestr.lokal)
			eksport.Pole("kodPocztowy",			xRejestr.kodPocztowy)
			eksport.Pole("rejon", 				xRejestr.rejon)
			eksport.Pole("telefon1",			xRejestr.telefon1)
			eksport.Pole("telefon2",			xRejestr.telefon2)
			eksport.Pole("fax",					xRejestr.fax)
			eksport.Pole("email",				xRejestr.email)
			eksport.Pole("kontoFK",				xRejestr.kontoFK)
			eksport.Pole("jednowalutowy",		(Using "%d", xRejestr.jednowalutowy))
			eksport.Pole("waluta",				xRejestr.waluta)

			for idx = 1 to idx > xRejestr.dzialy.Count()
				eksport.PoczatekPodsekcji("dzialy")
					eksport.Pole("kod", xRejestr.dzialy.Item(idx).obiekt.kod)
				eksport.KoniecSekcji() //"dzialy"
			next idx

		eksport.KoniecSekcji() //"Rejestr"
	endif
EndSub


int Sub EksportRejestrIFormaPl(Dispatch xObjRj, Dispatch xObjPl)

	if !eksport.SekcjaIstnieje("RejestrIFormaPl", xObjPl.id) then
		eksport.PoczatekSekcji("RejestrIFormaPl", xObjPl.id)

			eksport.Pole("kodRejestru", xObjRj.Kod)
			eksport.Pole("nazwa", xObjPl.Nazwa)
			eksport.Pole("termin", (Using "%d", xObjPl.Termin))

		eksport.KoniecSekcji() //"RejestrIFormaPl"
	endif
EndSub

int Sub EksportRejestrVAT(Dispatch xObjRj)

	String strNazwaSekcji

	Select case xObjRj.objId
		case TiRejSp
			strNazwaSekcji = "RejestrSp"
		case TiRejZk
			strNazwaSekcji = "RejestrZk"
		case TiRejMg
			strNazwaSekcji = "RejestrMg"
	EndSelect

	if !eksport.SekcjaIstnieje(strNazwaSekcji, xObjRj.id) then
		eksport.PoczatekSekcji(strNazwaSekcji, xObjRj.id)
			eksport.Pole("skrot", xObjRj.skrot)
		eksport.KoniecSekcji()
	endif
EndSub

int Sub EksportTypDokumentu(string typDk, string seria, long charakter, long objId)

	String strNazwaSekcji

	Select case objId
		case TiDokumentSp
			strNazwaSekcji = "TypDokumentuSp"
		case TiDokumentZk
			strNazwaSekcji = "TypDokumentuZk"
		case TiDokumentMg
			strNazwaSekcji = "TypDokumentuMg"
		case TiDokumentZo
			strNazwaSekcji = "TypDokumentuZo"
		case TiDokumentZw
			strNazwaSekcji = "TypDokumentuZw"
		case TiDokumentPn
			strNazwaSekcji = "TypDokumentuPn"
	Endselect

		eksport.PoczatekSekcji(strNazwaSekcji, 1)
			eksport.Pole("typDk", typDk)
			eksport.Pole("seria", seria)
			eksport.Pole("charakter", (Using "%l", charakter))
		eksport.KoniecSekcji()

EndSub


int Sub EksportWaluta(string sWal)

	int nRes, nCount, i
	Dispatch xWaluta = xFactory.GetObject("BWaluta")

	if sWal!="" then

		nCount = xWaluta.Count()
		for i=1 to i > nCount
			if lCase(xWaluta.item(i).nazwa) == lCase(sWal) then
				if !nRes && !eksport.SekcjaIstnieje("Waluta", xWaluta.item(i).id) then
					eksport.PoczatekSekcji("Waluta", xWaluta.item(i).id)
						eksport.Pole("kod",					xWaluta.item(i).nazwa)
						eksport.Pole("nazwa",				xWaluta.item(i).opis)
						eksport.Pole("przelicznik", (Using "%d", xWaluta.item(i).przelicznik))
					eksport.KoniecSekcji() //"Waluta"
				endif
			endif
		next i
	endif
EndSub

int Sub EksportKraj(string sSymbolKraju)

	Dispatch xKraj

	if sSymbolKraju != "" then
		xKraj = GetObjByKod("BKraj", sSymbolKraju)

		if !eksport.SekcjaIstnieje("Kraj", xKraj.id) then
			eksport.PoczatekSekcji("Kraj", xKraj.id)
				eksport.Pole("symbol", xKraj.symbol)
				eksport.Pole("nazwa", xKraj.nazwa)
				eksport.Pole("aktywny", (Using "%d", xKraj.aktywny))
				eksport.Pole("ue", (Using "%d", xKraj.ue))
			eksport.KoniecSekcji() //"Kraj"
		endif
	endif
EndSub

int Sub EksportKrajIST(string sSymbolKraju, int nCzyKraj)

	Dispatch xKraj

	if sSymbolKraju != "" then
		if (nCzyKraj) then
			xKraj = GetObjByKod("BKraj", sSymbolKraju)
		else
			xKraj = GetObjByKod("BMiejscePrzeznaczenia", sSymbolKraju)
		endIf

		if !eksport.SekcjaIstnieje("Kraj", xKraj.id) then
			eksport.PoczatekSekcji("Kraj", xKraj.id)
				eksport.Pole("symbol", xKraj.symbol)
				eksport.Pole("nazwa", xKraj.nazwa)
				eksport.Pole("aktywny", (Using "%d", xKraj.aktywny))
				if (nCzyKraj) then
					eksport.Pole("ue", (Using "%d", xKraj.ue))
				else
					eksport.Pole("ue", (Using "%d", 0))
				endif
			eksport.KoniecSekcji() //"Kraj"
		endif
	endif
EndSub

int Sub EksportStawkaVAT(Dispatch xStawkaVAT)

	eksport.PoczatekPodsekcji("stVAT")
		eksport.Pole("typ", (Using "%d", xStawkaVAT.Typ))
		eksport.Pole("wartosc", (Using "%.4f", Round(xStawkaVAT.Wartosc,4)))
	eksport.KoniecSekcji() // "stVAT"

	if !eksport.SekcjaIstnieje("StawkaVAT", xStawkaVAT.id) then
		eksport.PoczatekSekcji("StawkaVAT", xStawkaVAT.id)
			eksport.Pole("aktywny", (Using "%d", xStawkaVAT.aktywny))
			eksport.Pole("typ", (Using "%d", xStawkaVAT.Typ))
			eksport.Pole("wartosc", (Using "%.4f", Round(xStawkaVAT.Wartosc,4)))
			eksport.Pole("nazwa", xStawkaVAT.nazwa)
			eksport.Pole("opis", xStawkaVAT.opis)
			eksport.Pole("stawka", (Using "%.2f", Round(xStawkaVAT.stawka,2)))
			eksport.Pole("dataod", xStawkaVAT.dataOd)
			eksport.Pole("datado", xStawkaVAT.dataDo)
			eksport.Pole("czyRR", (Using "%d", xStawkaVAT.czyRR))
			eksport.Pole("kolejnosc", (Using "%d", xStawkaVAT.kolejnosc))
		eksport.KoniecSekcji() //"stVAT"
	endif

EndSub

int nEKontrZrealiz = PYTAJ_UZYTK
int Sub AskKontrZrealiz(dispatch dpDokumentSp)
	AskKontrZrealiz = 1
	int err, bZreal = 1
	string sMessTekst

	bZreal = dpDokumentSp.dataRealizacji != ""

	if !bZreal then
		sMessTekst = "Kontrakt '%s' nie zosta zrealizowany.{{icon=? check=(&zastosuj dla wszystkich) buttons=[&Eksportuj:o](&Pomi:i)  title=(Eksport danych)}}"
		sMessTekst = using sMessTekst, dpDokumentSp.numer
	endif

	if nEKontrZrealiz == EKSP_WSZYSTKIE then // nie sprawdzamy czy zrealizowany
		if !bZreal then
			eksport.AddInfo(sMessTekst)
		endif
		AskKontrZrealiz = 1
		Exit
	endif

	if !bZreal then // nie jest zrealizowany
		if nEKontrZrealiz == POMIN_WSZYSTKIE then // nie eksportujemy niezrealizowanych
			eksport.AddError(sMessTekst)
			AskKontrZrealiz = 0
			Exit
		endif

		// Pytamy uytkownika
		err = Message(sMessTekst)
		eksport.AddAsk(sMessTekst, err)

		if err == 1 || err == (1+16) then // eksportuj
			AskKontrZrealiz = 1
			if err == (1+16) then // dla wszystkich
				nEKontrZrealiz = EKSP_WSZYSTKIE
			endif
			Exit
		endif

		// pozostae pomi...
		AskKontrZrealiz = 0
		if err == (5+16) then // pomi dla wszystkich
			nEKontrZrealiz = POMIN_WSZYSTKIE
		endif
	endif

EndSub

// Czy przerwa eksport w przypadku napotkania dokumentu z bufora

int nDokBufor = PYTAJ_UZYTK

int Sub CzyPrzerwEkspBufor(int iCzyWystawiony, string strKodDok)
	CzyPrzerwEkspBufor = 1

	int err
	string sMessTekst
	string sMessTekst2

	sMessTekst = "Dokument '%s' z bufora nie zostanie wyeksportowany.{{icon=? check=(&Zastosuj dla wszystkich) buttons=[P&rzerwij:o](&Pomi:i)  title=(Eksport danych)}}"
	sMessTekst = using sMessTekst, strKodDok
	sMessTekst2 = "Dokument '"+strKodDok+"' z bufora nie zosta wyeksportowany."

	if nDokBufor == EKSP_WSZYSTKIE then // nie sprawdzamy czy brak
		if !iCzyWystawiony then // brak
			eksport.AddError(sMessTekst2)
		endif
		CzyPrzerwEkspBufor = 1
		Exit
	endif

	if !iCzyWystawiony then // brak
		if nDokBufor == POMIN_WSZYSTKIE then // nie wysyamy z brakujcym
			eksport.AddError(sMessTekst2)
			CzyPrzerwEkspBufor = 0
			Exit
		endif

		// Pytamy si uytkownika
		err = Message(sMessTekst)
		eksport.AddError(sMessTekst2)

		if err == 1 || err == (1+16) then // przerwij
			CzyPrzerwEkspBufor = EKSP_WSZYSTKIE
			Exit
		endif

		// pozostae pomi...
		CzyPrzerwEkspBufor = 0
		if err == (5+16) then // pomi dla wszystkich
			nDokBufor = POMIN_WSZYSTKIE
		endif
	endif
EndSub

// Czy eksportowa dokumenty dla ktrych nie jest okrelony schemat ksigowa

int nBrakSchematu = PYTAJ_UZYTK

int Sub CzyEkspBrakSchematu(string strSchemat, string strKodDok)
	CzyEkspBrakSchematu = 1

	int err
	string sMessTekst

	sMessTekst = "Dokument '%s' ma nieokrelony schemat ksigowa.{{icon=? check=(&zastosuj dla wszystkich) buttons=[&Eksportuj ze wzorcem:o](&Pomi:i)  title=(Eksport danych)}}"
	sMessTekst = using sMessTekst, strKodDok

	if nBrakSchematu == EKSP_WSZYSTKIE then // nie sprawdzamy czy brak schematu
		if strSchemat == "" then // brak schematu
			eksport.AddInfo(sMessTekst)
		endif
		CzyEkspBrakSchematu = 1
		Exit
	endif

	if strSchemat == "" then // brak schematu
		if nBrakSchematu == POMIN_WSZYSTKIE then // nie eksportujemy z brakujcym schematem
			eksport.AddError(sMessTekst)
			CzyEkspBrakSchematu = 0
			Exit
		endif

		// Pytamy si uytkownika
		err = Message(sMessTekst)
		eksport.AddAsk(sMessTekst, err)

		if err == 1 || err == (1+16) then // eksportuj
			CzyEkspBrakSchematu = 1
			if err == (1+16) then // dla wszystkich
				nBrakSchematu = EKSP_WSZYSTKIE
			endif
			Exit
		endif

		// pozostae pomi...
		CzyEkspBrakSchematu = 0
		if err == (5+16) then // pomi dla wszystkich
			nBrakSchematu = POMIN_WSZYSTKIE
		endif
	endif
EndSub

// Czy eksportowa dokumenty dla ktrych okrelony schemat ksigowa nie istnieje

int nBlednySchemat = PYTAJ_UZYTK

int Sub CzyEkspBlednySchemat(int iSchemat, string strKodDok)
	CzyEkspBlednySchemat = 1

	int err
	string sMessTekst


	sMessTekst = "Okrelony dla dokumentu '%s' schemat ksigowa nie istnieje.{{icon=? check=(&zastosuj dla wszystkich) buttons=[&Eksportuj ze wzorcem:o](&Pomi:i)  title=(Eksport danych)}}"
	sMessTekst = using sMessTekst, strKodDok

	if nBlednySchemat == EKSP_WSZYSTKIE then
		if iSchemat then
			eksport.AddInfo(sMessTekst)
		endif
		CzyEkspBlednySchemat = 1
		Exit
	endif

	if iSchemat then
		if nBlednySchemat == POMIN_WSZYSTKIE then
			eksport.AddError(sMessTekst)
			CzyEkspBlednySchemat = 0
			Exit
		endif

		// Pytamy si uytkownika
		err = Message(sMessTekst)
		eksport.AddAsk(sMessTekst, err)

		if err == 1 || err == (1+16) then // eksportuj
			CzyEkspBlednySchemat = 1
			if err == (1+16) then // dla wszystkich
				nBlednySchemat = EKSP_WSZYSTKIE
			endif
			Exit
		endif

		// pozostae pomi...
		CzyEkspBlednySchemat = 0
		if err == (5+16) then // pomi dla wszystkich
			nBlednySchemat = POMIN_WSZYSTKIE
		endif
	endif
EndSub

// Czy eksportowa faktury walutowe z roznym kursem VAT i CIT/PIT jako stare (nie walutowe) dokumenty FK

int nBlednyTypFK = PYTAJ_UZYTK

int Sub CzyEkspBlednyTypFK(int iTypFK, string strKodDok)
	CzyEkspBlednyTypFK = 1

	int err
	string sMessTekst

	sMessTekst = "Ze wzgldu na rnic kursw, dokument '%s'\npowinien by wyeksportowany do FK jako 'Faktura walutowa VAT'.{{icon=? check=(&zastosuj dla wszystkich) buttons=[&Eksportuj:o](&Pomi:i)  title=(Eksport danych)}}"
	sMessTekst = using sMessTekst, strKodDok

	if nBlednyTypFK == EKSP_WSZYSTKIE then
		if iTypFK then
			eksport.AddInfo(sMessTekst)
		endif
		CzyEkspBlednyTypFK = 1
		Exit
	endif

	if iTypFK then
		if nBlednyTypFK == POMIN_WSZYSTKIE then
			eksport.AddError(sMessTekst)
			CzyEkspBlednyTypFK = 0
			Exit
		endif

		// Pytamy si uytkownika
		err = Message(sMessTekst)
		eksport.AddAsk(sMessTekst, err)

		if err == 1 || err == (1+16) then // eksportuj
			CzyEkspBlednyTypFK = 1
			if err == (1+16) then // dla wszystkich
				nBlednyTypFK = EKSP_WSZYSTKIE
			endif
			Exit
		endif

		// pozostae pomi...
		CzyEkspBlednyTypFK = 0
		if err == (5+16) then // pomi dla wszystkich
			nBlednyTypFK = POMIN_WSZYSTKIE
		endif
	endif
EndSub

// Czy eksportowa dokumenty zlotowkowe jako faktury walutowe

int nBlednyTypFK2 = PYTAJ_UZYTK

int Sub CzyEkspBlednyTypFK2(int iTypFK, string strKodDok, long idDK)
	CzyEkspBlednyTypFK2 = 1

	int err
	string sMessTekst
	string sMessTekst2

	sMessTekst = "Dokument '%s' nie moe zosta wysany jako faktura walutowa.{{icon=? check=(&Zastosuj dla wszystkich) buttons=[P&rzerwij:o](&Pomi:i)  title=(Eksport danych)}}"
	sMessTekst = using sMessTekst, strKodDok
	sMessTekst2 = strKodDok+" Typ dokumentu bdnie uzgodniony."

	if iTypFK then
		if nBlednyTypFK2 == EKSP_WSZYSTKIE then // nie sprawdzamy czy brak
			if iTypFK then
				AddError(sMessTekst2, idDK)
			endif
			CzyEkspBlednyTypFK2 = 1
			Exit
		endif

		if nBlednyTypFK2 == POMIN_WSZYSTKIE then // nie wysyamy z brakujcym
			AddError(sMessTekst2, idDK)
			CzyEkspBlednyTypFK2 = 0
			Exit
		endif

		// Pytamy si uytkownika
		err = Message(sMessTekst)
		AddError(sMessTekst2, idDK)

		if err == 1 || err == (1+16) then // przerwij
			CzyEkspBlednyTypFK2 = EKSP_WSZYSTKIE
			Exit
		endif

		// pozostae pomi...
		CzyEkspBlednyTypFK2 = 0
		if err == (5+16) then // pomi dla wszystkich
			nBlednyTypFK2 = POMIN_WSZYSTKIE
		endif
	endif
EndSub

int nBrakTypDK = PYTAJ_UZYTK

int Sub CzyEkspBrakTypDK(int iTypDK, string strKodDok, long idDK, string strTypDK)
	CzyEkspBrakTypDK = 1

	int err
	string sMessTekst
	string sMessTekst2

	sMessTekst = "Dokument '%s' ma nieznany typ dokumentu '%s'.{{icon=? check=(&Zastosuj dla wszystkich) buttons=[P&rzerwij:o](&Pomi:i)  title=(Eksport danych)}}"
	sMessTekst = using sMessTekst, strKodDok, strTypDK
	sMessTekst2 = strKodDok+" Nieznany typ dokumentu '"+strTypDK+"'."

	if nBrakTypDK == EKSP_WSZYSTKIE then // nie sprawdzamy czy brak
		if iTypDK then // brak
			AddError(sMessTekst2, idDK)
		endif
		CzyEkspBrakTypDK = 1
		Exit
	endif

	if iTypDK then // brak
		if nBrakTypDK == POMIN_WSZYSTKIE then // nie wysyamy z brakujcym
			AddError(sMessTekst2, idDK)
			CzyEkspBrakTypDK = 0
			Exit
		endif

		// Pytamy si uytkownika
		err = Message(sMessTekst)
		AddError(sMessTekst2, idDK)

		if err == 1 || err == (1+16) then // przerwij
			CzyEkspBrakTypDK = EKSP_WSZYSTKIE
			Exit
		endif

		// pozostae pomi...
		CzyEkspBrakTypDK = 0
		if err == (5+16) then // pomi dla wszystkich
			nBrakTypDK = POMIN_WSZYSTKIE
		endif
	endif
EndSub

// Eksportujemy transakcje i rozliczenia

int Sub ZapiszTRAROZ(Dispatch xDekret, int nPn, float dKurs)
	///////////////////////////////////////
	// transakcje i rozliczenia
	int bMinusJeden = 0
	int ii
	float dKwota
	String terminPlatnosci

	for ii=1 to ii>xDekret.rozliczenia.Count()
		if xDekret.rozliczenia.item(ii).rozliczenie then

			eksport.PoczatekPodsekcji("Rozliczenie")
			eksport.Pole("IdDlaRozliczen", (Using "%d", xDekret.rozliczenia.item(ii).pozycja))
			eksport.Pole("dSymbol", xDekret.rozliczenia.item(ii).rozliczany)

			if xDekret.rozliczenia.item(ii).rachunek != "" then
				eksport.Pole("rachunek", xDekret.rozliczenia.item(ii).rachunek)
			endif

			if (xDekret.rozliczenia.item(ii).waluta == "") then // rozrachunek w PLN
				eksport.Pole("kwota", (Using "%.2f", Round(xDekret.rozliczenia.item(ii).kwotaPLN,2)))

				if ( xDekret.rozliczenia.item(ii).walutaObca != "" ) then // rozrachunek PLN, dokument rozliczajcy w walucie
					eksport.Pole("walutaObca", xDekret.rozliczenia.item(ii).walutaObca)
					eksport.Pole("rozliczonoWO", (Using "%.2f", Round(xDekret.rozliczenia.item(ii).kwotaObca,2)))
					eksport.Pole("kursWO", (Using "%.6f", Round(xDekret.rozliczenia.item(ii).kursObcy,6)))
				endif
			else
				if (xDekret.rozliczenia.item(ii).walutaObca == "" || xDekret.rozliczenia.item(ii).walutaObca == xDekret.rozliczenia.item(ii).waluta) then
					// rozrachunek w walucie, dokument rozliczajcy w PLN lub w tej samej walucie
					dKwota = Round(xDekret.rozliczenia.item(ii).kwota * xDekret.rozliczenia.item(ii).kurs, 2)
					eksport.Pole("kwota", (Using "%.2f", dKwota))
					eksport.Pole("wkwota", (Using "%.2f", Round(xDekret.rozliczenia.item(ii).kwota,2)))
				else	// rozrachunek w walucie, dokument rozliczajcy w innej walucie
					dKwota = Round(xDekret.rozliczenia.item(ii).kwota * xDekret.rozliczenia.item(ii).kurs, 2)
					eksport.Pole("kwota", (Using "%.2f", dKwota))
					eksport.Pole("wkwota", (Using "%.2f", Round(xDekret.rozliczenia.item(ii).kwota,2)))
					eksport.Pole("walutaObca", xDekret.rozliczenia.item(ii).walutaObca)
					eksport.Pole("rozliczonoWO", (Using "%.2f", Round(xDekret.rozliczenia.item(ii).kwotaObca,2)))
					eksport.Pole("kursWO", (Using "%.6f", Round(xDekret.rozliczenia.item(ii).kursObcy,6)))
				endif
			endif
			terminPlatnosci = xDekret.rozliczenia.item(ii).termin
			If terminPlatnosci != "" Then
				eksport.Pole("termin", terminPlatnosci)
			EndIf
			eksport.KoniecSekcji() //"Rozliczenie"
		else
			if xDekret.rozliczenia.item(ii).pozycja != -1 || !bMinusJeden then
				if xDekret.rozliczenia.item(ii).pozycja == -1 then bMinusJeden = 1
				eksport.PoczatekPodsekcji("Transakcja")
				eksport.Pole("IdDlaRozliczen", (Using "%d", xDekret.rozliczenia.item(ii).pozycja))
				eksport.Pole("termin", xDekret.rozliczenia.item(ii).termin)

				if xDekret.rozliczenia.item(ii).rachunek != "" then
					eksport.Pole("rachunek", xDekret.rozliczenia.item(ii).rachunek)
				endif
				eksport.KoniecSekcji() //"Transakcja"
			endif
		endif
	next ii
EndSub

Int Sub Eksport_RozliczenieBody(Dispatch xPlatnosc, Dispatch xRozrachunek, Int indRozliczenia, Int rozliczeniaPlatnosci)

	If !xPlatnosc || !xRozrachunek || indRozliczenia < 1 Then Exit

	Dispatch rozliczenia = IIF(rozliczeniaPlatnosci, xPlatnosc.rozliczeniaPn, xRozrachunek.rozliczeniaPn)

	If rozliczenia.Count() < indRozliczenia Then Exit

	Float	wartoscPlatnosci, wartoscRozrachunku
	Int		sp

	Dispatch	sDoc		// dokument sprzedazy
	Dispatch	psRep		// raport okresowy
	Int			psrData		// do rozliczenia wez dane z raportu okresowego

	sp = (xPlatnosc.wyplata == 0)

	psrData = 0
	if (MKP_EXP) then
		If rozliczeniaPlatnosci && xRozrachunek.id_dokumentu Then
			// rozliczenia platnosci i rozrachunek sprzedazy powiazany z dokumentem sprzedazy
			sDoc = GetObjById("BDokumentSp", xRozrachunek.id_dokumentu)
			If sDoc && sDoc.IdPeriodicSaleReport Then
				// uwzgledniony w raporcie okresowym
				psRep = GetObjById("BRapOkr", sDoc.IdPeriodicSaleReport)
				If psRep Then
					// bedzie rozliczal dokument raportu okresowego
					psrData = 1
				EndIf
			EndIf
		EndIf
	endif

	eksport.PoczatekPodsekcji("RozliczenieDok")
					//			JEDYNKI			DWOJKI
					// SP		platnosci		rozrachunki
					// ZK		rozrachunki		platnosci
	eksport.Pole("flag",						"0")
	eksport.Pole("typ",							"0")
	eksport.Pole("subtyp",						"0")
	eksport.Pole("rejestr_platnosci1",			IIF(sp, IIF(xPlatnosc.id_dokumentu, "", xPlatnosc.rejestr.kod), ""))
	eksport.Pole("rejestr_platnosci2", 			IIF(sp, "",								IIF(xPlatnosc.id_dokumentu, "",			xPlatnosc.rejestr.kod)))
	eksport.Pole("seria1",						IIF(sp, xPlatnosc.seria,				IIF(psrData, psRep.seria,				xRozrachunek.seria)))
	eksport.Pole("serianr1",	Using "%l",		IIF(sp, xPlatnosc.numerWSerii,			IIF(psrData, psRep.numerSeryjny,		xRozrachunek.numerWSerii)))
	if (MKP_EXP) then
		eksport.Pole("okres1",		Using "%l",		IIF(sp, RecalculatePeriod(xPlatnosc.okresNumeracji, xPlatnosc.data_platnosci),		IIF(psrData, psRep.okresRaportowania,	RecalculatePeriod(xRozrachunek.okresNumeracji, xRozrachunek.data_platnosci))))
	else
		eksport.Pole("okres1",		Using "%l",		IIF(sp, xPlatnosc.okresNumeracji,		IIF(psrData, psRep.okresRaportowania,	xRozrachunek.okresNumeracji)))
	endif
	eksport.Pole("dzial1",		Using "%l",		IIF(sp, xPlatnosc.numeracjaWDziale,		IIF(psrData, 0,							xRozrachunek.numeracjaWDziale)))

	eksport.Pole("seria2",						IIF(sp, IIF(psrData, psRep.seria, xRozrachunek.seria),						xPlatnosc.seria))
	eksport.Pole("serianr2",	Using "%l",		IIF(sp, IIF(psrData, psRep.numerSeryjny,  xRozrachunek.numerWSerii),		xPlatnosc.numerWSerii))
	if (MKP_EXP) then
		eksport.Pole("okres2",		Using "%l",		IIF(sp, IIF(psrData, psRep.okresRaportowania, RecalculatePeriod(xRozrachunek.okresNumeracji, xRozrachunek.data_platnosci)),	RecalculatePeriod(xPlatnosc.okresNumeracji, xPlatnosc.data_platnosci)))
	else
		eksport.Pole("okres2",		Using "%l",		IIF(sp, IIF(psrData, psRep.okresRaportowania, xRozrachunek.okresNumeracji),	xPlatnosc.okresNumeracji))
	endif
	eksport.Pole("dzial2",		Using "%l",		IIF(sp, IIF(psrData, 0, xRozrachunek.numeracjaWDziale),						xPlatnosc.numeracjaWDziale))

	eksport.Pole("kod1",						IIF(sp, xPlatnosc.numer,										IIF(psrData, psRep.numerDokumentu, xRozrachunek.numer)))
	eksport.Pole("kod2",						IIF(sp, IIF(psrData, psRep.numerDokumentu, xRozrachunek.numer),	xPlatnosc.numer))

	eksport.Pole("rejestr1",	Using "%l",		IIF(sp, xPlatnosc.rejestr.id,			xRozrachunek.rejestr.id))
	eksport.Pole("rejestr2",	Using "%l",		IIF(sp, xRozrachunek.rejestr.id,		xPlatnosc.rejestr.id))
	eksport.Pole("wartosc",		Using "%.12f",	rozliczenia.item(indRozliczenia).wartoscPLN)
	eksport.Pole("kursrozl1",	Using "%.12f",	IIF(sp, xPlatnosc.kurs,					xRozrachunek.kurs))
	eksport.Pole("kursrozl2",	Using "%.12f",	IIF(sp, xRozrachunek.kurs,				xPlatnosc.kurs))
	eksport.Pole("waluta1",						IIF(sp, xPlatnosc.waluta,				xRozrachunek.waluta))
	eksport.Pole("waluta2",						IIF(sp, xRozrachunek.waluta,			xPlatnosc.waluta))
	wartoscPlatnosci =		IIF(rozliczeniaPlatnosci, rozliczenia.item(indRozliczenia).wartosc, rozliczenia.item(indRozliczenia).wartoscSecPn)
	wartoscRozrachunku =	IIF(rozliczeniaPlatnosci, rozliczenia.item(indRozliczenia).wartoscSecPn, rozliczenia.item(indRozliczenia).wartosc)
	eksport.Pole("wartrozl1",	Using "%.12f",	IIF(sp, wartoscPlatnosci,				wartoscRozrachunku))
	eksport.Pole("wartrozl2",	Using "%.12f",	IIF(sp, wartoscRozrachunku,				wartoscPlatnosci))
	eksport.Pole("data",						rozliczenia.item(indRozliczenia).data)
	eksport.KoniecSekcji()

EndSub

Int Sub Eksport_RozliczenieDok(Dispatch xRozrachunek)

	If !xRozrachunek Then Exit

	Dispatch	xPlatnosc
	Int			ind

	For ind=1 To ind>xRozrachunek.rozliczeniaPn.Count()
		If xPlatnosc Then xPlatnosc.Clear()
		xPlatnosc=GetObjById("BDokumentPn",xRozrachunek.rozliczeniaPn.item(ind).idSecPn)
		If xPlatnosc Then
			Eksport_RozliczenieBody(xPlatnosc, xRozrachunek, ind, 0)
		EndIf
	Next ind

EndSub

// RP - raport platnosci
Int Sub Eksport_RozliczenieDok_RP(Dispatch xPlatnosc)

	If !xPlatnosc Then Exit

	Dispatch	xRozrachunek
	Int			ind

	For ind=1 To ind>xPlatnosc.rozliczeniaPn.Count()
		If xRozrachunek Then xRozrachunek.Clear()
		xRozrachunek=GetObjById("BDokumentPn",xPlatnosc.rozliczeniaPn.item(ind).idSecPn)
		If xPlatnosc && xRozrachunek Then
			Eksport_RozliczenieBody(xPlatnosc, xRozrachunek, ind, 1)
		EndIf
	Next ind

EndSub

int Sub CzyWalutowy(long idDK)
	Dispatch xDokumentPn

	CzyWalutowy = 0

	xDokumentPn = GetObjById("BDokumentPn", idDK)
	if !xDokumentPn then  error "Brak takiego rozrachunku"

	CzyWalutowy = xDokumentPn.CzyWalutowy
endsub

#define ROZ_STRONA_MA 1
#define ROZ_STRONA_WN 2
int rozUidStrona

#define wymiarFORMAT	"wymiar%02d"

Int Sub EksportujWymiary( Dispatch wymiarowanie )

	Int iWektor, iWymiar

	For iWektor = 1 To iWektor > wymiarowanie.Count()
		eksport.PoczatekPodsekcji( "Wymiar" )
		eksport.Pole( "kwota", ( Using "%.2f", wymiarowanie.Item( iWektor ).kwota ) )
			eksport.Pole( "podzial", ( Using "%d", wymiarowanie.Item( iWektor ).typ ) )
			eksport.Pole( "procent", ( Using "%.2f", wymiarowanie.Item( iWektor ).procent ) )
				For iWymiar = 1 To iWymiar > IloscWymiarowPozycji()
					eksport.Pole( ( Using wymiarFORMAT, iWymiar ), wymiarowanie.Item( iWektor ).Get( Using wymiarFORMAT, iWymiar ) )
				Next iWymiar
			eksport.KoniecSekcji()	// "Wymiar"
		Next iWektor

EndSub

// Eksportujemy zapisy
int Sub ZapiszZAP(Dispatch xDekret, int nRownolegle, int nCzyWalutowy, string strWaluta, float dKurs, int czyUID, int iTiDok)

	// nRownolegle ??? nie wykorzystywany
	// w wersji tej funkcji dla integracji te mona uproci rezygnujc z nRownolegle

	// zapisy
	int czyHandlowy = (iTiDok == TiDokSp) || (iTiDok == TiDokZk)
	int czyRapPn = (iTiDok == TiRapPn)
	int czyRapOkr = (iTiDok == TiRapOkr)

	int pozycjazap
	Dispatch xDokumentPn, xRozliczeniePn
	float dKwota, dKwotaWal

	ZapiszZAP = 0

	int ii, ii2, nZapCount, nRozlCount
	nZapCount = xDekret.zapisy.Count()
	int pozPN = 0
	string dataKPKW

	for ii=1 to ii > nZapCount
		ZapiszZAP = xDekret.zapisy.item(ii).idDlaRozliczen

		eksport.PoczatekPodsekcji("Zapis")
			eksport.Pole("strona", iif(xDekret.zapisy.item(ii).ma,"MA","WN"))

			//ewentualny eksport guida
			if(!czyRapPn && !czyRapOkr) then
				
				if (czyUID && xDekret.zapisy.item(ii).kontoKh && xDekret.zapisy.item(ii).guid && !xDekret.zapisy.item(ii).Rownolegly) then
					if(!rozUidStrona || (xDekret.zapisy.item(ii).ma && rozUidStrona == ROZ_STRONA_MA) || (!xDekret.zapisy.item(ii).ma && rozUidStrona == ROZ_STRONA_WN)) then
						czyUID = 0//tylko jeden raz wysyamy guida - wybieramy pierwszy moliwy
						eksport.Pole("uid", xDekret.zapisy.item(ii).guid)
					endif
				endif
			else
				//raporty zbiorcze, jeden guid dla pozycji(gdy konto KH)
				if (pozPn != xDekret.zapisy.item(ii).lp && xDekret.zapisy.item(ii).kontoKh) then
					if (czyRapPn && !xDekret.zapisy.item(ii).Rownolegly) then
						pozPn = xDekret.zapisy.item(ii).lp
						eksport.Pole("uid",  xDekret.zapisy.item(ii).guid)
					endif

					if (czyRapOkr && xDekret.zapisy.item(ii).Rownolegly) then
						pozPn = xDekret.zapisy.item(ii).lp
						eksport.Pole("uid",  xDekret.zapisy.item(ii).guid)
					endif
				endif
			endif
			eksport.Pole("kwota", (Using "%.2f", Round(xDekret.zapisy.item(ii).kwotaPLN,2)))
			if (xDekret.zapisy.item(ii).Rownolegly) then
				if(nCzyWalutowy) then
					if dKurs != 0 then
						dKwotaWal = Round(xDekret.zapisy.item(ii).kwotaPLN / dKurs, 2)
					else
						dKwotaWal = Round(xDekret.zapisy.item(ii).kwotaPLN, 2)
					endif
					eksport.Pole("kurs", (Using "%.12f", Round(dKurs,12)))
					eksport.Pole("waluta", strWaluta)
					eksport.Pole("wkwota", (Using "%.2f", dKwotaWal))
				endif
			endif

			if(xDekret.zapisy.item(ii).waluta != "") && (xDekret.zapisy.item(ii).kwota != 0.0) then
				eksport.Pole("kurs", (Using "%.12f", Round(xDekret.zapisy.item(ii).kurs,12)))
				eksport.Pole("waluta", xDekret.zapisy.item(ii).waluta)
				eksport.Pole("wkwota", (Using "%.2f", Round(xDekret.zapisy.item(ii).kwota,2)))
			endif

			eksport.Pole("konto", xDekret.zapisy.item(ii).konto)
			eksport.Pole("IdDlaRozliczen", (Using "%d", xDekret.zapisy.item(ii).idDlaRozliczen))
			eksport.Pole("opis", xDekret.zapisy.item(ii).opis)
			eksport.Pole("NumerDok", xDekret.zapisy.item(ii).numerDokDlaRK)

			if (czyRapOkr && xDekret.zapisy.item(ii).Rownolegly) || (czyRapPn && !xDekret.zapisy.item(ii).Rownolegly) then		
				dataKPKW = xDekret.zapisy.item(ii).dataKPKW
				if dataKPKW != "" then eksport.Pole("dataKPKW", dataKPKW)
			endif

			if nRownolegle then
				eksport.Pole("Pozycja", (Using "%d", ((xDekret.zapisy.item(ii).lp-1)+pozycjazap)))
				eksport.Pole("ZapisRownolegly", (Using "%d", 0x21))
			else
				eksport.Pole("Pozycja", (Using "%d", (xDekret.zapisy.item(ii).lp-1)))
				pozycjazap=(xDekret.zapisy.item(ii).lp-1)
				eksport.Pole("ZapisRownolegly", (Using "%d", iif(xDekret.zapisy.item(ii).Rownolegly, 0x21, 0)))
			endif

		If FunctionalityDimensioning() Then
			// wymiarowanie zapisu ksiegowego
			EksportujWymiary( xDekret.zapisy.item( ii ).podzialKwoty )
		EndIf

		eksport.KoniecSekcji() //"Zapis"
	next ii
EndSub

string Sub GetNthElement(int nNth, String strText, char ch)
/*
Jesli strText zawiera lancuchy oddzielone znakiem 'ch'
to GetNthElement zwroci nNth-ty taki lancuch
jesli go nie znajdzie, zwraca parametr strText bez zmian
elementy indeksowane sa od 1 (nNth)
*/
	String strCh
	int i, pos, count, posPrev
	String strTmp
	count = 0

	pos = 0
	posPrev = 0
	strCh = Using "%c", ch
	For i=0 To i > Len(strText)
		strTmp = Mid(strText, i, 1)
		If (!AMStrCMpi(strTmp, strCh)) Then
			count = count + 1
			If (pos) Then
				posPrev = pos + 1
			Else
				posPrev = 0
			EndIf
			pos = i
		EndIf
		If (count >= nNth) Then
			i = Len(strText)
		EndIf
	Next i

	If (count >= nNth) Then
		If (!posPrev) Then
			i = posPrev + 1
		Else
			i = posPrev
		EndIf
		If (pos - i <= 0) then
			GetNthElement = ""
		else
			GetNthElement = Mid(strText, posPrev, pos - i)
		Endif
	Else
		GetNthElement = strText
	EndIf
EndSub

string Sub PoleFormaPlatnosci(Dispatch xFormaPlatn)
	if 0 == xFormaPlatn.termin then
		PoleFormaPlatnosci = mid(xFormaPlatn.nazwa,1,25)
	else
		PoleFormaPlatnosci = (Using "%s %l dni",(mid(xFormaPlatn.nazwa,1,(25-(5+len(using "%l", xFormaPlatn.termin))))), xFormaPlatn.termin)
	endif
EndSub

int Sub EksportNotatka(String opis, string NazwaSec)
	String strExp, ret, typ

	If opis != "" Then
		Arg "#*", "$#$*"
		Arg "#&", "$#$&"
		buf=opis
		Replace Arg
		Delete Arg
		opis=buf
		Arg "\r", "#&"
		Arg "\n", "#*"
		buf=opis
		Replace Arg
		Delete Arg
		opis=buf
		while opis
			eksport.PoczatekPodsekcji( NazwaSec )
				eksport.Pole("opis", Mid( opis, 1, MaxLenLine ))
			eksport.KoniecSekcji()
			opis=Mid( opis, MaxLenLine+1, 10000)
		wend
	EndIf
EndSub

dispatch sub KonFullGetByKod(string strKod, int subTyp)
	select case subTyp
		case KHtypKH
			KonFullGetByKod = GetObjByKod("BKontrahent", strKod)
		case KHtypPR
			KonFullGetByKod = GetObjByKod("BPracownik", strKod)
		case KHtypUR
			KonFullGetByKod = GetObjByKod("BUrzad", strKod)
	endselect
endsub

string sub NormalizeString(string src, int length)
	string temp
	int bAdd = 0, pos = 1
	Arg "\t", " "
	Arg "\r", " "
	Arg "\n", " "
	buf = src
	Replace Arg
	Delete Arg
	src = buf
	if Len(buf) <= 128 then
		buf = NormalizeStr(buf)
	else
		buf = ""
		while pos && ((length && Len(buf) <= length) || !length)
			temp = Mid(src, pos, 128)
			if Mid(temp,1,1) == " " && pos != 1 then buf = buf + " "
			bAdd = iif(Mid(temp, Len(temp), 1) == " ", 1, 0)
			buf = buf + NormalizeStr(temp)
			if bAdd then buf = buf + " "
			pos = iif(Len(src) >= pos + 128, pos + 128, 0)
		wend
		if Mid(buf, Len(buf), 1) == " " then buf = Mid(buf, 1, Len(buf) - 1)
	endif
	if  length && Len(buf) > length then buf = Mid(buf, 1, length)
	NormalizeString = buf
endsub

// Eksportujemy operacje bankowe
int Sub ZapiszBANKOPER(dispatch xDekret)
	string strId
	int i
	//zebranie IdDlaRozliczenTraRoz
	MapValue mIds
	mIds.Clear()
	mIds.Type(int)
	for i = 1 to  i > xDekret.rozliczenia.Count()
		mIds.Get((using "%d", xDekret.rozliczenia.item(i).pozycja),0)
	next i

	//wypisanie operacji bankowych
	for i = 1 to  i > xDekret.zapisy.Count()
		if(xDekret.zapisy.item(i).guid != "" && xDekret.zapisy.item(i).epStatus == ESTATUS_BANKOPER) then
			strId = Using "%d",  xDekret.zapisy.item(i).idDlaRozliczen
			if(mIds.Index(strId)) then
				eksport.PoczatekPodsekcji("Operacja bankowa")
					eksport.Pole("IdDlaRozliczen", strId)
					eksport.Pole("GUID", xDekret.zapisy.item(i).guid)
				eksport.KoniecSekcji() //"Operacja bankowa"
			endif
		endif
	next i
EndSub

int	Sub ZapiszETRANSFERS(dispatch xDok, dispatch xDekret)
	int i
	dispatch xRozr
	dispatch xTransfers
	string strIdDlaRoz

	//dla pierwszej tranzakcji/rozliczenia z brzegu
	//czy wiemy gdzie dopic zlecenia??
	if  xDekret.rozliczenia.Count() == 0 then exit
	if xDekret.rozliczenia.item(1).pozycja == 0 then exit
	
	xRozr = xDok.rozrachunekDk
	if !xRozr || !xRozr.id then exit

	xTransfers = xRozr.zleconePrzelewy
	if !xTransfers || xTransfers.Count() == 0 then exit

	strIdDlaRoz = using "%d", xDekret.rozliczenia.item(1).pozycja
	
	for i = 1 to i > xTransfers.Count()
		eksport.PoczatekPodsekcji("Zlecenie przelewu")
		eksport.Pole("IdDlaRozliczen", strIdDlaRoz)
		eksport.Pole("GUID", xTransfers.item(i).guid)
		eksport.KoniecSekcji() 
	next i
EndSub

Int Sub CzyCechaOO( Int subtypi )

	Select Case subtypi
		// sprzedaz - cecha OO dla wyszczegolnionych ponizej dokumentow i kontraktow
		Case FAS, FAK, REX, RXK, FVS, FVW, RUS, PAR, FKS, FKW, RKS, PRK, FZS, ZKS, KZS, ZSK
				CzyCechaOO = 1
		// zakup - cecha OO dla dokumentow z cecha "samoopodatkowanie" i kontraktow
		Case FVZ, FKZ, KZZ, ZZK
				CzyCechaOO = 1
		Case Else
				CzyCechaOO = 0
	EndSelect

EndSub

Int Sub CzyCechaVat50( Int subtypi )
	Select Case subtypi
		Case FVZ, FKZ, ZVW, ZWK
				CzyCechaVat50 = 1
		Case Else
				CzyCechaVat50 = 0
	EndSelect
EndSub

dispatch sub GETxStawkaObjectByIdentifier (long identifier)
	dispatch xStawki=xFactory.GetObject("BStawkaVAT")
	int index
	for index = 1 to index > xStawki.count
		if xStawki.item(index).id == identifier then
			GETxStawkaObjectByIdentifier = xStawki.item(index)
			exit
		endif
	Next index
endsub

long sub GETIDxVATNP ()
	dispatch xStawki=xFactory.GetObject("BStawkaVAT")
	int index
	for index = 1 to index > xStawki.count
		if xStawki.item(index).aktywny && (xStawki.item(index).czyNpOld || xStawki.item(index).czyNpNew)  then
			GETIDxVATNP = xStawki.item(index).id
			exit
		endif
	Next index
endsub

int sub GetValuesFromFile()	
	if !GetIni( "EksportSD", "nEZatwWart" ) then 
		nEZatwWart = PYTAJ_UZYTK
	else
		nEZatwWart = Val( GetIni ( "EksportSD", "nEZatwWart" ) )
	endif
	if !GetIni( "EksportSD", "nBrakSchematu" ) then 
		nBrakSchematu = PYTAJ_UZYTK
	else
		nBrakSchematu = Val( GetIni ( "EksportSD", "nBrakSchematu" ) )
	endif
	if !GetIni( "EksportSD", "nBlednySchemat" ) then 
		nBlednySchemat = PYTAJ_UZYTK
	else
		nBlednySchemat = Val( GetIni ( "EksportSD", "nBlednySchemat" ) )
	endif
	if !GetIni( "EksportSD", "nDokBufor" ) then 
		nDokBufor = PYTAJ_UZYTK
	else
		nDokBufor = Val( GetIni ( "EksportSD", "nDokBufor" ) )
	endif
endsub

int sub SaveValuesToFile()
	PutIni( "EksportSD", "nEZatwWart", using "%d", nEZatwWart)
	PutIni( "EksportSD", "nBrakSchematu", using "%d", nBrakSchematu)
	PutIni( "EksportSD", "nBlednySchemat", using "%d", nBlednySchemat)
	PutIni( "EksportSD", "nDokBufor", using "%d", nDokBufor)
endsub

Int Sub Eksport_RozrachunekDok(Dispatch xRozr, Int sp)

	If (!xRozr) Then
		Eksport_RozrachunekDok = 0
		Exit
	EndIf

	Eksport_RozrachunekDok = 1

	eksport.PoczatekPodsekcji("RozrachunekDok")
		eksport.Pole("waluta", xRozr.waluta)
		eksport.Pole("kurs", Using "%.12f", xRozr.kurs)
		eksport.Pole("kwota", Using "%f", IIF(sp, 1, -1 ) * xRozr.kwotaPLN)
		eksport.Pole("wkwota", Using "%f", IIF(sp, 1, -1 ) * xRozr.kwota)
	eksport.KoniecSekcji()

EndSub