//"interofk.sci","Integracja rozrachunkw z FK - include","\Integracja z FK a\",0,1.0.0,SYSTEM
/////////////////////////////////////////
// "Integracja rozrachunkw z FK - include"
// interofk.sci
#define APOSTROF "\t"

#define TRUE				1

#define BAS_Pn  0x20

#define XrozliczALL					0
#define XrozliczNIEROZLICZONE		1
#define XrozliczROZLICZONE			2

#define KH_TABLE	 "#SRFK_KH"
#define PR_TABLE	 "#SRFK_PR"
#define UR_TABLE	 "#SRFK_UR"

int subTyp = 0
int ask_wal = 0
dispatch xWaluta=xFactory.NewObject("BWaluta") : xWaluta.Load()
dispatch xWalutaNew=xFactory.NewObject("BWaluta")



record ProgressCounter
	int all, curr, last, new

	int sub Reset(int a)
		if !a then a = 1
		all = a : curr = last = 0
		WriteStatusBar("")
	endsub

	int sub NextOne()
		curr += 1 : new = (curr*100)/all
		if new > last then last = new
		if last > 100 then last = 100 : curr = all
		WriteStatusBar(using "=%d%%%%", last)
	endsub
endrec

ProgressCounter progress

record RozrachFKF
	long idTrans
	int stronaTmp
	string dokSymbol[41]
	string dokData[11]
	float kwotaa
	float kwotaWal
	float kurs
	string waluta[5]
endrec

record RozrachKh
	int subTyp
	int pozycja
	RozrachFKF rozr(1)
	long sub rozrCount()
		if (rozr(1).idTrans == 0) then
			rozrCount = 0
		else
			rozrCount = size(rozr)
		endif
	endsub

	int sub ClearRozrachKh()
		subtyp = 0
		pozycja = 0
		shrink rozr,-1
		rozr(1).idtrans = 0
	endsub

	int sub AddRozr(long idtrans, int stronaTmp, string dokSymbol, string dokData, float kwotaa, float kwotaWal, float kurs, string waluta)
		if(rozr(1).idtrans > 0) then
			grow rozr,1
		endif
		long i = size(rozr)
		rozr(i).idtrans = idtrans
		rozr(i).stronaTmp = stronaTmp
		rozr(i).dokSymbol = dokSymbol
		rozr(i).dokData = dokData
		rozr(i).kwotaa = kwotaa
		rozr(i).kwotaWal = kwotaWal
		rozr(i).kurs = kurs
		rozr(i).waluta = waluta
	endsub
endrec
MapValue r4Kh(1)
r4Kh(1).Clear()
r4Kh(1).Type(long)
MapValue subTyps
subTyps.Clear()
subTyps.Type(int)

record MapRozrachunki
	RozrachKh rozr(1)
	RozrachFKF currFKF
	long currFKFidx
	long currIdx

	int sub ClearMapRozrachunki()
		shrink r4Kh,-1
		r4Kh(1).Clear()
		r4Kh(1).Type(long)

		subtyps.Clear()
		subTyps.Type(int)

		shrink rozr,-1
		rozr(1).ClearRozrachKh()

		currFKFidx = 0
		currIdx = 0
	endsub

	int sub SetCurrent(int subtyp, long pozycja)
		int idx = subTyps.Index(using "%d", subtyp)
		if(idx == 0) then
			if(r4Kh(1).Size() > 0) then
				grow r4Kh,1
				r4Kh(size(r4Kh)).Clear()
				r4Kh(size(r4Kh)).Type(long)
			endif
			idx = size(r4Kh)
			subtyps.Set((using "%d", subtyp), idx)
		endif
		if(r4Kh(idx).Index(using "%l", pozycja)) then
			currIdx = 	r4Kh(idx).Get(using "%l", pozycja)
		else
			if(rozr(1).pozycja >0 ) then
				grow rozr,1
			endif
			currIdx = size(rozr)
			rozr(currIdx).subtyp = subtyp
			rozr(currIdx).pozycja = pozycja
			r4Kh(idx).Set((using "%l", pozycja), currIdx)
		endif
		currFKF = rozr(currIdx).rozr(1)
		currFKFidx = 1
	endsub

	int sub MoveFirst()
		currFKFidx = 1
		currFKF = rozr(currIdx).rozr(currFKFidx)
		MoveFirst =  IIF(currFKF.idtrans == 0, 1, 0)
	endsub

	int sub MoveNext()
		if (rozr(currIdx).rozrCount() == currFKFidx) then
			MoveNext = 1
		else
			currFKFidx+=1
			currFKF = rozr(currIdx).rozr(currFKFidx)
			MoveNext = 0
		endif
	endsub

	int sub AddRozrachunek(long idtrans, int stronaTmp, string dokSymbol, string dokData, float kwotaa, float kwotaWal, float kurs, string waluta)
		rozr(currIdx).AddRozr(idtrans, stronaTmp, dokSymbol, dokData, kwotaa, kwotaWal,kurs, waluta)
	endsub
endrec

MapRozrachunki mapKh

dispatch xConn=GetAdoConnection()
dispatch xRecTmp="ADODB.Recordset"
Dispatch cmdAdo		// instrukcja ADO

cmdAdo = "ADODB.Command"
cmdAdo.ActiveConnection = xConn
cmdAdo.CommandTimeout = 5000

int sub CreateKhTempTables(int typ)
	string strSQL
	if(typ & khKONTRAHENT) then
		strSQL = "SELECT C.id as Id, C.kod as Shortcut, C.AccountNo as Position, ISNULL(C.IdFK, '') as Idfk INTO "
		strSQL += KH_TABLE
		strSQL +=" FROM SSCommon.vKhFK C"
		strSQL +=" INNER JOIN PN ON (PN.typkh = 0 AND PN.khid = C.Id)"
		strSQL +=" GROUP BY  C.id, C.kod, C.AccountNo, C.IdFK"
		cmdAdo.CommandText = strSQL
		cmdAdo.Execute()
	endif
	if(typ & khPRACOWNIK) then
		strSQL = "SELECT C.id as Id, C.kod as Shortcut, C.AccountNo as Position, ISNULL(C.IdFK, '') as Idfk INTO "
		strSQL += PR_TABLE
		strSQL +=" FROM SSCommon.vPrFK C"
		strSQL +=" INNER JOIN PN ON (PN.typkh = 106 AND PN.khid = C.Id)"
		strSQL +=" GROUP BY  C.id, C.kod, C.AccountNo, C.IdFK"
		cmdAdo.CommandText = strSQL
		cmdAdo.Execute()
	endif
	if(typ & khURZAD) then
		strSQL = "SELECT KH.id as Id, KH.kod as Shortcut, CAST(ISNULL(KH.idfk, 0) AS nvarchar) as Position, CAST(ISNULL(KH.idfk, 0) AS nvarchar) as Idfk INTO "
		strSQL += UR_TABLE
		strSQL +=" FROM KH"
		strSQL +=" INNER JOIN PN ON (PN.typkh = 107 AND PN.khid = KH.id)"
		strSQL +=" GROUP BY  KH.Id, KH.kod, KH.idfk, KH.idfk"
		cmdAdo.CommandText = strSQL
		cmdAdo.Execute()
	endif
endsub


///////////////////////////////////////////////////////////////////////////////
//-----------------------------------------------------------------------------
String Sub ZamienDziwneZnakiSQL(String strInput)
//-----------------------------------------------------------------------------
	ZamienDziwneZnakiSQL = strInput

	Arg "'", "''"

	buf = strInput
	Replace Arg
	Delete Arg
	ZamienDziwneZnakiSQL = buf

EndSub
//-----------------------------------------------------------------------------

int sub DropKhTempTables(int typ)
	string strSQL
	if(typ & khKONTRAHENT) then
		strSQL = "DROP TABLE "
		strSQL += KH_TABLE
		cmdAdo.CommandText = strSQL
		cmdAdo.Execute()
	endif
	if(typ & khPRACOWNIK) then
		strSQL = "DROP TABLE "
		strSQL += PR_TABLE
		cmdAdo.CommandText = strSQL
		cmdAdo.Execute()
	endif
	if(typ & khURZAD) then
		strSQL = "DROP TABLE "
		strSQL += UR_TABLE
		cmdAdo.CommandText = strSQL
		cmdAdo.Execute()
	endif
endsub

long sub GetFKId4KhKod(string kod, int subTyp)
	string idfkCol = "Idfk"
	string strSQL = "SELECT %s FROM %s WHERE Shortcut = '%s'"
	if (xIntegracjaFK.trybWspolpracy == TRYB_WSP_REP || xIntegracjaFK.trybWspolpracy == TRYB_WSP_CDB) then idfkCol = "Position"
	select case subTyp
		case khKONTRAHENT
			strSQL = using strSQL, idfkCol, KH_TABLE, ZamienDziwneZnakiSQL(kod)
		case khPRACOWNIK
			strSQL = using strSQL, idfkCol, PR_TABLE, ZamienDziwneZnakiSQL(kod)
		case khURZAD
			strSQL = using strSQL, idfkCol, UR_TABLE, ZamienDziwneZnakiSQL(kod)
		case else
			error "Brak takiego typu"
	endselect
	xRecTmp.Open(strSQL, xConn)
	if (!xRecTmp.EOF()) then
		GetFKId4KhKod = Val(xRecTmp.Fields(idfkCol).Value)
	else
		GetFKId4KhKod = 0//nie ma
	endif
	xRecTmp.Close()
endsub

long sub GetHMId4FKId(long fkid, int subTyp)
	string idfkCol = "Idfk"
	string strSQL = "SELECT Id FROM %s WHERE %s = %l"
	if (xIntegracjaFK.trybWspolpracy == TRYB_WSP_REP || xIntegracjaFK.trybWspolpracy == TRYB_WSP_CDB) then idfkCol = "Position"
	select case subTyp
		case khKONTRAHENT
			strSQL = using strSQL, KH_TABLE, idfkCol, fkid
		case khPRACOWNIK
			strSQL = using strSQL, PR_TABLE, idfkCol, fkid
		case khURZAD
			strSQL = using strSQL, UR_TABLE, idfkCol, fkid
		case else
			error "Brak takiego typu"
	endselect

	xRecTmp.Open(strSQL, xConn)
	if (!xRecTmp.EOF()) then
		GetHMId4FKId = xRecTmp.Fields("Id").Value
	else
		GetHMId4FKId = 0
	endif

	xRecTmp.Close()
endsub

/*
int sub CheckKhUsed(long fkid, int subTyp)
	string idfkCol = "Idfk"
	string strSQL = "SELECT * FROM %s WHERE %s = %l"
	if (xIntegracjaFK.trybWspolpracy == TRYB_WSP_REP || xIntegracjaFK.trybWspolpracy == TRYB_WSP_CDB) then idfkCol = "Position"
	select case subTyp
		case khKONTRAHENT
			strSQL = using strSQL, KH_TABLE, idfkCol, fkid
		case khPRACOWNIK
			strSQL = using strSQL, PR_TABLE, idfkCol, fkid
		case khURZAD
			strSQL = using strSQL, UR_TABLE, idfkCol, fkid
		case else
			error "Brak takiego typu"
	endselect

	xRecTmp.Open(strSQL, xConn)
	if (!xRecTmp.EOF()) then
		CheckKhUsed = 1
	else
		CheckKhUsed = 0
	endif

	xRecTmp.Close()
endsub
*/
dispatch sub CheckIdFKNotExistAndGet(Dispatch xObject, string objName)
//jeszcze mae sprawdzenie na wypadek replikacji w tle
int nErr
		if(!xObject.identyfikatorFK) then
			CheckIdFKNotExistAndGet = xFactory.NewObject(objName)
			nErr = CheckIdFKNotExistAndGet.Load(using "id = %l", xObject.id)
			if (nErr) then XErr(nErr): Message(sStndError) : error ""
		else
			CheckIdFKNotExistAndGet = xObject
		endif
endsub


dispatch sub KonFullGet(long idKH, int subTyp)

Dispatch xKontrahent
	Dispatch xPracownik
	Dispatch xUrzad

	select case subTyp
		case khKONTRAHENT
			xKontrahent = GetObjById("BKontrahent", idKH)
			if !xKontrahent then  error "Brak takiego kontrahenta"
			KonFullGet = CheckIdFKNotExistAndGet(xKontrahent, "BKontrahent")

		case khPRACOWNIK
			xPracownik = GetObjById("BPracownik", idKH)
			if !xPracownik then  error "Brak takiego pracownika"
			KonFullGet = CheckIdFKNotExistAndGet(xPracownik, "BPracownik")

		case khURZAD
			xUrzad = GetObjById("BUrzad", idKH)
			if !xUrzad then  error "Brak takiego urzdu"
			KonFullGet = xUrzad

		case else
			error "Brak takiego typu"
	endselect
endsub

dispatch sub KonShortGetByIdFK(long idFK, int subTyp)
		select case subTyp
		case khKONTRAHENT
			xKartParamsKh = xKh.Params()
			xKartParamsKh.idFKSynchr=idFK
			nRes=xKh.Load(xKartParamsKh)
			if !nRes then
				nRes = !xKh.Count()
				KonShortGetByIdFK = xKh.item(1)
			endif
		case khPRACOWNIK
			xKartParamsPr = xPr.Params()
			xKartParamsPr.idFKSynchr=idFK
			nRes=xPr.Load(xKartParamsPr)
			if !nRes then
				nRes = !xPr.Count()
				KonShortGetByIdFK = xPr.item(1)
			endif
		case khURZAD
			xKartParamsUr = xUr.Params()
			xKartParamsUr.idFKSynchr=idFK
			nRes=xUr.Load(xKartParamsUr)
			if !nRes then
				nRes = !xUr.Count()
				KonShortGetByIdFK = xUr.item(1)
			endif
		case else
			error "Brak takiego typu"
	endselect
endsub

dispatch sub KonFullGetByKod(string strKod, int subTyp)
	Dispatch xKontrahent
	Dispatch xPracownik
	Dispatch xUrzad

	select case subTyp
		case khKONTRAHENT
			xKontrahent = GetObjByKod("BKontrahent", strKod)
			if !xKontrahent then  error "Brak takiego kontrahenta"
			KonFullGetByKod = CheckIdFKNotExistAndGet(xKontrahent, "BKontrahent")

		case khPRACOWNIK
			xPracownik = GetObjByKod("BPracownik", strKod)
			if !xPracownik then  error "Brak takiego pracownika"
			KonFullGetByKod = CheckIdFKNotExistAndGet(xPracownik, "BPracownik")

		case khURZAD
			xUrzad = GetObjByKod("BUrzad", strKod)
			if !xUrzad then  error "Brak takiego urzdu"
			KonFullGetByKod = xUrzad

		case else
			error "Brak takiego typu"
	endselect
endsub

dispatch sub KonGet(long idKH, int subTyp)

		select case subTyp
		case khKONTRAHENT
			KonGet = xKhMan.Give(using "id=%l", idKH)
		case khPRACOWNIK
			KonGet = xPrMan.Give(using "id=%l", idKH)
		case khURZAD
			KonGet = xUrMan.Give(using "id=%l", idKH)
		case else
			error "Brak takiego typu"
	endselect
endsub

int sub AddWal(string sWaluta)
	AddWal = 0
	xWalutaNew.Clear()
	if !xWalutaNew.Edit() then
		xWalutaNew.Nazwa=sWaluta
		xWalutaNew.Przelicznik=1
		if !xWalutaNew.Save() then
			AddWal = xWalutaNew.Przelicznik
		else
			xWalutaNew.Undo()
		endif
		xWalutaNew.Clear()
	endif
endsub

int sub GetPrzelicznik(string sWaluta)
 	dispatch xW
	GetPrzelicznik =0
 	if (!xWaluta) then xWaluta=xFactory.NewObject("BWaluta") : xWaluta.Load()
 	xW = xWaluta.Give(using "nazwa='%s'", sWaluta)
 	if (xW) then
		GetPrzelicznik = xWaluta.przelicznik
 	else
		if (ask_wal & 16) == 0 then
			ask_wal = message using "Nie mona doda rozrachunku z programu FK w sowniku brakuje waluty '%s'. \nDoda now walut?{{icon=? buttons=[&Dodaj:1](&Nie dodawaj:2) check=(&Zastosuj dla wszystkich)}}", sWaluta
		endif
		if (ask_wal & 1) == 1 then GetPrzelicznik = AddWal(sWaluta)
 	endif
endsub

////////////////////////////////////////////////////////
MapValue Powiazania
Powiazania.Type(int)

int sub PowiazaniaClear()
	Powiazania.Clear()
	Powiazania.Type(int)
endsub

////////////////////////////////////////////////////////
MapValue Kontrahenci
Kontrahenci.Type(int)

int sub KontrahenciClear()
	Kontrahenci.Clear()
	Kontrahenci.Type(int)
endsub

///////////////////////////////////////////////////
string strPow

float Sub ABS(float liczba)
	ABS=sign(liczba)*liczba
EndSub

int Sub GetSubTypFK(int subTyp)
	GetSubTypFK = -1
	select case subTyp
		case TiKontrahent
			GetSubTypFK = SUB_KONTRAHENCI
		case TiPracownik
			GetSubTypFK = SUB_PRACOWNICY
		case TiUrzad
			GetSubTypFK = SUB_URZEDY
		case khKONTRAHENT
			GetSubTypFK = SUB_KONTRAHENCI
		case khPRACOWNIK
			GetSubTypFK = SUB_PRACOWNICY
		case khURZAD
			GetSubTypFK = SUB_URZEDY
		case else
			error "Brak takiego typu"
	endselect
EndSub

int Sub GetSubTypHM(int subTyp)
	GetSubTypHM = 0
	select case subTyp
		case SUB_NULL
			GetSubTypHM = 0
		case SUB_PRACOWNICY
			GetSubTypHM = khPRACOWNIK
		case SUB_KONTRAHENCI
			GetSubTypHM = khKONTRAHENT
		case SUB_URZEDY
			GetSubTypHM = khURZAD
	endselect
EndSub

int Sub GetTiObjId(int subTyp)
	GetTiObjId = -1
	select case subTyp
		case SUB_NULL
			GetTiObjId = -1
		case SUB_PRACOWNICY
			GetTiObjId = TiPracownik
		case SUB_KONTRAHENCI
			GetTiObjId = TiKontrahent
		case SUB_URZEDY
			GetTiObjId = TiUrzad
		case else
			error "Brak takiego typu"
	endselect
EndSub

int Sub GetSubTyp4KhTyp(int subTyp)
	GetSubTyp4KhTyp = -1
	select case subTyp
		case KHtypKH
			GetSubTyp4KhTyp = SUB_KONTRAHENCI
		case KHtypPR
			GetSubTyp4KhTyp = SUB_PRACOWNICY
		case KHtypUR
			GetSubTyp4KhTyp = SUB_URZEDY
		case else
			error "Brak takiego typu"
	endselect
EndSub

int Sub GetKhTyp4FK(int subTyp)
	GetKhTyp4FK = -1
	select case subTyp
		case SUB_KONTRAHENCI
			GetKhTyp4FK = KHtypKH
		case SUB_PRACOWNICY
			GetKhTyp4FK = KHtypPR
		case SUB_URZEDY
			GetKhTyp4FK = KHtypUR
		case else
			error "Brak takiego typu"
	endselect
EndSub

int Sub GetKhTyp4HM(int subTyp)
	GetKhTyp4HM = -1
	select case subTyp
		case khPRACOWNIK
			GetKhTyp4HM = KHtypPR
		case khURZAD
			GetKhTyp4HM = KHtypUR
		case khKONTRAHENT
			GetKhTyp4HM = KHtypKH
		case else
			error "Brak takiego typu"
	endselect
EndSub

int Sub GetKhTyp4Obj(int subTyp)
	GetKhTyp4Obj = -1
	select case subTyp
		case TiKh
			GetKhTyp4Obj = KHtypKH
		case TiPr
			GetKhTyp4Obj = KHtypPR
		case TiUr
			GetKhTyp4Obj = KHtypUR
		case else
			error "Brak takiego typu"
	endselect
EndSub

int Sub KonwTyp(int Typ)
	select case Typ
		case khPRACOWNIK
			KonwTyp = 0x001
		case khURZAD
			KonwTyp = 0x010
		case khKONTRAHENT
			KonwTyp = 0x100
		case TiPracownik
			KonwTyp = 0x001
		case TiUrzad
			KonwTyp = 0x010
		case TiKontrahent
			KonwTyp = 0x100
		case TiPr
			KonwTyp = 0x001
		case TiUr
			KonwTyp = 0x010
		case TiKh
			KonwTyp = 0x100
		case else
			error "Brak takiego typu"
	endselect
EndSub

int Sub IsKhUsed(Dispatch xKonKH)
	IsKhUsed = 0


	if xKonKH.objId == TiKontrahent then
		xKonShort = KonGet(xKonKH.id, KonwTyp(xKonKH.objId))
	else
		xKonShort = xKonKH
	endif
	xDokPn.Clear()
	xKartParamsDokPn = xDokPn.Params()
	xKartParamsDokPn.typKontrahenta=GetKhTyp4HM(KonwTyp(xKonShort.objId))
	xKartParamsDokPn.kontrahent=xKonShort
	xKartParamsDokPn.stanRozliczenia=XrozliczALL
	xKartParamsDokPn.stanRozliczeniaRoz=XrozliczALL
	xKartParamsDokPn.czySynchronizacja=1

	if xDokPn.PoliczIle(xKartParamsDokPn) then
		IsKhUsed=1
	endif
EndSub

int Sub RozrachunekFK(Dispatch xShortKH, dispatch rozr)
float kwRozr = 0
int nPrzelicznik
dispatch xWaluta
string strNumer = using "Dokument FK: %s nr ewid. %l",rozr.Value("dokSkrot"), rozr.Value("dokNumer")

if rozr.Value("strona")==ROZ_NALEZ then
	kwRozr = rozr.Value("kwotaWal")
else
	kwRozr = (-1) * rozr.Value("kwotaWal")
endif

	xDokumentPn.Clear()
	nRes = xDokumentPn.Edit()
	if !nRes then
		if kwRozr>0 then
			xDokumentPn.Quiet = 0
			xDokumentPn.Wyplata = 2 //naleznosc
			xDokumentPn.Quiet = 1
			xDokumentPn.rejestr	= xIntegracjaFK.rejestrNal
			xDokumentPn.typDk = xIntegracjaFK.typDkNal
			xDokumentPn.seria = xIntegracjaFK.seriaNal
		else
			xDokumentPn.Quiet = 0
			xDokumentPn.Wyplata = 3 //zobowiazanie
			xDokumentPn.Quiet = 1
			xDokumentPn.rejestr	= xIntegracjaFK.rejestrZob
			xDokumentPn.typDk = xIntegracjaFK.typDkZob
			xDokumentPn.seria = xIntegracjaFK.seriaZob
		endif
		xDokumentPn.CzyRozrachunekFK = 1
		xDokumentPn.data_platnosci = rozr.Value("dokData")
		xDokumentPn.Termin = rozr.Value("termin")
		xDokumentPn.danekh.KhTyp=  GetKhTyp4Obj(xShortKH.objId)
		xDokumentPn.danekh.KhKod = xShortKH.kod
		xDokumentPn.opis = strNumer
		xDokumentPn.numer = rozr.Value("dokSymbol")
		if	CheckETransfersEnabled() then
			if rozr.Value("eGUID") != "" then
				xDokumentPn.ePrzelew = ESTATUS_BANKOPER
				xDokumentPn.UstawGuid(rozr.Value("eGUID"))
			endif
		endif
		if "z" != Lcase(rozr.Value("waluta")) then
			nPrzelicznik = GetPrzelicznik(rozr.Value("waluta"))
			if ( xDokumentPn.UstawWalute(rozr.Value("waluta")) || !nPrzelicznik) then
//				message using "Nie udao si zaadowa waluty '%s'. Dokument '%s' nie zostanie dodany", rozr.Value("waluta"), rozr.Value("dokSymbol")
				xDokumentPn.Undo()
				exit
			endif
			xDokumentPn.kurs = rozr.Value("kurs") * nPrzelicznik
		endif
		xDokumentPn.Kwota = ABS(kwRozr)
		nRes = xDokumentPn.Save()
	endif

	if nRes then
		xDokumentPn.Undo()
	endif

EndSub

float sub KwotaRozlFK(dispatch xRozliczeniePn, int wPLN)
// idziemy po rozliczeniach od dokumentu szukamy RozliczeniaFK
int ii
	ii = 1
	while ii <= xRozliczeniePn.Count()
		if xRozliczeniePn.item(ii).id && xRozliczeniePn.item(ii).czyRozliczenieZFK then
			if wPLN then
				KwotaRozlFK = xRozliczeniePn.item(ii).wartoscPLN
			else
				KwotaRozlFK = xRozliczeniePn.item(ii).wartosc
			endif
			exit
		endif
		ii = ii + 1
	wend
endsub

float sub ZliczKwote( dispatch xDokumentPn, long khidfk, int wPLN)
// idziemy po rozliczeniach od dokumentu i zliczamy kwoty nie wyeksportowanych rozliczen
int ii
long rejestr
int typkh,err,succ
string strKod,termin,plattyp,typ,k2,datapn,strPole, strTmp
dispatch xRozliczeniePn = xDokumentPn.rozliczeniaPn

	ZliczKwote=0
	ii = 1
	typkh = xDokumentPn.danekh.KhTyp

	while ii <= xRozliczeniePn.Count()
		strKod = xRozliczeniePn.item(ii).kodDkwFk
/*		nRes=xDokumentPn2.Load("kod="+APOSTROF+xRozliczeniePn.item(ii).numerOperacji+APOSTROF)
		if !nRes then
			typkh = xDokumentPn2.danekh.KhTyp
			strKod = xDokumentPn2.numer
			termin = xDokumentPn2.Termin
			datapn = xDokumentPn2.data_platnosci

			//jesli pozycja raportu bankowego to kod taki jak raport kod WB
			if ((xDokumentPn2.Wyplata == 0) || (xDokumentPn2.Wyplata == 1)) && xDokumentPn2.rejestr.typRejestru == 1 then
				xRapPnMan.Clear()
				xRrpPnParams = xRapPnMan.Params()
				xRrpPnParams.dzialy=xDokumentPn2.rejestr
				xRrpPnParams.okresOd=datapn
				xRrpPnParams.okresDo=datapn

				xRapPnMan.Load(xRrpPnParams)
				if xRapPnMan.Count() then
					strKod = xRapPnMan.item(1).numer
				endif
			else
				//jesli dokument zakupu numer dokumentu w FK
				nRes=xDokumentZk.Load(using "id=%l", xDokumentPn2.id_dokumentu)
				if !nRes && xDokumentZk.id then
					strKod = xDokumentZk.numerObcy
					strKod += " ["
					strKod += xDokumentZk.numer
					strKod += "]"
					datapn = xDokumentZk.dataWystawienia
				endif
				strKod = Mid(strKod, 1, iif(len(strkod)>40,40,len(strkod)))
			endif
*/
/*			if xDokumentPn2.CzyRozrachunekFK then
				if len(strKod)==25 then
					if (mid(strKod,25,1) == "") then
						strKod = mid(strKod,1,24)+" "
					endif
					buf = xDokumentPn2.schemat
					arg ""," "
					replace arg
					strKod += buf
				endif
			endif
*/
			rozrpom.ClearParams
			rozrpom.StanType = ROZ_STAN_ALL
			rozrpom.Type = ROZ_WSZYSTKO
			rozrpom.SubjectPoz = khidfk
			rozrpom.SubjectType = GetSubTyp4KhTyp(typkh)
			rozrpom.DocumentName = strKod
			rozrpom.Load
			err = rozrpom.MoveFirst
			succ = 0
			while !err && !succ
//				if iif((xDokumentPn2.Wyplata == 2 || xDokumentPn2.Wyplata == 3),1,(rozrpom.Value("dokData")==datapn)) then
					succ = 1
//				endif
				err = rozrpom.MoveNext
			wend
			if !succ then
				if len(strkod)>28 then
					rozrpom.ClearParams
					rozrpom.StanType = ROZ_STAN_ALL
					rozrpom.Type = ROZ_WSZYSTKO
					rozrpom.SubjectPoz = khidfk
					rozrpom.SubjectType = GetSubTyp4KhTyp(typkh)
					strTmp = Mid(strKod, 1, iif(len(strkod)>28,28,len(strkod)))
					if ( mid(strTmp, len(strTmp), 1) == " " ) then
						strTmp = mid(strTmp, 1, len(strTmp)-1)
					endif
					rozrpom.DocumentName = strTmp
					rozrpom.Load
					err = rozrpom.MoveFirst
					succ = 0
					while !err && !succ
//						if iif((xDokumentPn2.Wyplata == 2 || xDokumentPn2.Wyplata == 3),1,(rozrpom.Value("dokData")==datapn)) then
							succ = 1
//						endif
						err = rozrpom.MoveNext
					wend
				endif
				if !succ then
					if wPLN then
						ZliczKwote+=xRozliczeniePn.item(ii).wartoscPLN
					else
						ZliczKwote+=xRozliczeniePn.item(ii).wartosc
					endif
				endif
			endif
//		endif
		ii = ii + 1
	wend
endsub

string sub GetDataRozlFK(string guid)
	GetDataRozlFK=""

	long idTrans, idRozl, transakcja
	int nRet, nRet2
	string dataRozl
		
	dispatch rozrpom2,rozlpom2
	rozrpom2.Create(ObjectFK(".Rozrachunki"))
    rozrpom2.Open(dbd)

	rozrpom2.ClearParams
	rozrpom2.StanType 	= ROZ_STAN_ALL
	rozrpom2.Type 		= ROZ_WSZYSTKO
	rozrpom2.UId		= guid
	rozrpom2.related = 0
	rozrpom2.SimpleInfo = TRUE
	rozrpom2.Load

	nRet2=rozrpom2.MoveFirst
	if !nRet2 then
		rozlpom2.Create(ObjectFK(".Rozliczenia"))
	endif
	
	while nRet2==0
		transakcja = rozrpom2.Value("transakcja")
		idTrans = rozrpom2.Value("idTrans")
		idRozl = rozrpom2.Value("idRozl")
		

		if  transakcja > 0 then
			rozlpom2.Open(dbd, transakcja, idRozl)
		else
			rozlpom2.Open(dbd, idTrans, idRozl)
		endif
		
		nRet=rozlpom2.MoveFirst
		while nRet == 0
			if dataRozl < rozlpom2.Value("dokDataOkr") then dataRozl = rozlpom2.Value("dokDataOkr")
			nRet = rozlpom2.MoveNext
		wend
		nRet2 = rozrpom2.MoveNext
	wend

	GetDataRozlFK = dataRozl
endsub

int Sub SprawdzPlatnosciHandlu(string typ, long idKH,int czyKH)
int err,znaleziony,typpn,succ,mnozn,stronaTmp,stronafk, fkSubTyp
long khidfk
string strKod,strData, strTmp, strSymbol, strDataTmp
float fKwota,fKwH, fKwRozlFK, fKwotaRozrFK //kwota rozraunku w FK
Dispatch xDokPnLocal=xFactory.NewObject("BDokPnExt")
long lCountBefore
long ii, wPLN
//Dispatch rozrkh

	//rozrkh.Create(ObjectFK(".Rozrachunki"))
	//rozrkh.Open(dbd)

	xDokPnLocal.Clear()
	xKartParamsDokPn = xDokPnLocal.Params()
	if czyKH then
		xKonShort = KonGet(idKH, subTyp)
		xKartParamsDokPn.typKontrahenta=GetKhTyp4HM(subTyp)
		xKartParamsDokPn.kontrahent=xKonShort
	endif

	xKartParamsDokPn.stanRozliczenia=XrozliczNIEROZLICZONE
	xKartParamsDokPn.stanRozliczeniaRoz=XrozliczNIEROZLICZONE
	xKartParamsDokPn.czyWplaty=(typ==PLAT)
	xKartParamsDokPn.czyWyplaty=(typ==PLAT)
	xKartParamsDokPn.czyNaleznosci=(typ==NAL)
	xKartParamsDokPn.czyZobowiazania=(typ==NAL)
	xKartParamsDokPn.anulowany=NIEANULOWANY
	xKartParamsDokPn.wystawioneIBufor=WYSTAWIONY
	xKartParamsDokPn.sort="kodKontrahenta"
	xKartParamsDokPn.sortASC=1
	xKartParamsDokPn.czySynchronizacja=1

	nRes=xDokPnLocal.Load(xKartParamsDokPn)
	if nRes then  error "Dokumenty patnoci nie zaadowane"

	ii = 1
	lCountBefore = xDokPnLocal.Count()
	while ii <= xDokPnLocal.Count()
//		nRes=xDokumentPn.Load("id="+(using "%l", xDokPnLocal.item(ii).id))
//		if nRes then  Error "Brak takiego rekordu w bazie PN"
		wPLN=1

		//xKonFull = KonFullGetByKod(xDokPnLocal.item(ii).kodKontrahenta,  GetSubTypHM(GetSubTyp4KhTyp(xDokPnLocal.item(ii).kh_typ)))
		khidfk = 0
		fkSubTyp = GetSubTypHM(GetSubTyp4KhTyp(xDokPnLocal.item(ii).kh_typ))
		if(fkSubTyp & subTyp) then
			khidfk = GetFKId4KhKod(xDokPnLocal.item(ii).kodKontrahenta, fkSubTyp)
		endif


		if (khidfk) then
			mnozn = iif((xDokPnLocal.item(ii).CzyWyplata&0x01)==1,-1,1)
			if typ==PLAT then
				stronaTmp = !(xDokPnLocal.item(ii).CzyWyplata&0x01)
			else
				stronaTmp = xDokPnLocal.item(ii).CzyWyplata&0x01
			endif
		
//			strKod = xDokPnLocal.item(ii).numer
			strKod = xDokPnLocal.item(ii).kodDkwFk
			if strKod == "" then  error using "Kod dokumentu %s o id=%l, jaki powinien by w FK jest pusty", xDokPnLocal.item(ii).numer, xDokPnLocal.item(ii).id
			strData = xDokPnLocal.item(ii).data_platnosci

			if xDokPnLocal.item(ii).typDkHandl == 2 then strData = xDokPnLocal.item(ii).dataWystZk
/*
			//jesli pozycja raportu bankowego to kod taki jak raport kod WB
			//1 - bankowy
			if (typ==PLAT) && xDokPnLocal.item(ii).dzial.typRejestru == 1 then
				xRapPnMan.Clear()
				xRrpPnParams = xRapPnMan.Params()
				xRrpPnParams.dzialy=xDokPnLocal.item(ii).dzial
				xRrpPnParams.okresOd=xDokPnLocal.item(ii).data_platnosci
				xRrpPnParams.okresDo=xDokPnLocal.item(ii).data_platnosci

				xRapPnMan.Load(xRrpPnParams)
				if !xRapPnMan.Count() then  error "Brak takiego rekordu w bazie PN"
				//zalozenie na dzien jeden raport bankowy
				strKod = xRapPnMan.item(1).numer
			else
				//jesli dokument zakupu numer dokumentu w FK
				if ( xDokPnLocal.item(ii).id_dokumentu && (xDokPnLocal.item(ii).CzyWyplata & 0x01) ) then
					nRes=xDokumentZk.Load(using "id=%l", xDokPnLocal.item(ii).id_dokumentu)
					if !nRes && xDokumentZk.id then
						strKod = xDokumentZk.numerObcy
						strKod += " ["
						strKod += xDokumentZk.numer
						strKod += "]"
						strData = xDokumentZk.dataWystawienia
					endif
				endif
				strKod = Mid(strKod, 1, iif(len(strkod)>40,40,len(strkod)))
			endif
*/
/*			if xDokumentPn.CzyRozrachunekFK then
				if len(strKod)==25 then
					if (mid(strKod,25,1) == "") then
						strKod = mid(strKod,1,24)+" "
					endif
					buf = xDokumentPn.schemat
					arg ""," "
					replace arg
					strKod += buf
				endif
			endif
*/
			if !czyKH then popup(2,using "Patno %s",strKod)
			/*
			if rozrkh.SubjectPoz != khidfk then
				rozrkh.ClearParams
				rozrkh.StanType = ROZ_STAN_NROZ
				rozrkh.SubjectPoz = khidfk
				rozrkh.SubjectType = GetSubTyp4KhTyp(xDokPnLocal.item(ii).kh_typ)
				rozrkh.Load
			endif
			err = rozrkh.MoveFirst
			*/
			znaleziony=0
			mapKh.SetCurrent(GetSubTyp4KhTyp(xDokPnLocal.item(ii).kh_typ), khidfk)
			err = mapKh.MoveFirst()
			While !err && !znaleziony
				strPow = using "%l", mapKh.currFKF.idTrans
				if !Powiazania.Get(strPow) then
					if mapKh.currFKF.kwotaa<0 then
						stronafk = !mapKh.currFKF.stronaTmp
					else
						stronafk = mapKh.currFKF.stronaTmp
					endif

					strTmp = Mid(strKod, 1, iif(len(strkod)>28, 28, len(strkod)))
					if ( mid(strTmp, len(strTmp), 1) == " " ) then
						strTmp = mid(strTmp, 1, len(strTmp)-1)
					endif
					strSymbol = mapKh.currFKF.dokSymbol
					strDataTmp = mapKh.currFKF.dokData
					if (stronafk == stronaTmp) && (Mid(strSymbol, 1, iif(len(strSymbol)>28,28,len(strSymbol))) == strTmp) && iif(typ==NAL,1,(strDataTmp == strData)) then
						znaleziony=1
						nRes=xDokumentPn.Load("id="+(using "%l", xDokPnLocal.item(ii).id))
						if nRes then  Error "Nie mona zaadowa dokumentu '" + xDokPnLocal.item(ii).numer + "'"

						strPow = using "%l",mapKh.currFKF.idTrans
						Powiazania.Set(strPow,1)
//						fKwH = xDokumentPn.kwotaDoRozl // Round( (basPN.GetField("kwota")-iif(typ=="2",basPN.GetField("kwotarozl"),0)),2 ) * mnozn
						if xDokumentPn.CzyWalutowy && Lcase(xDokumentPn.waluta) == Lcase(mapKh.currFKF.waluta) then wPLN=0
						if wPLN then
							fKwotaRozrFK = mapKh.currFKF.kwotaa
							fKwH = xDokumentPn.kwotaDoRozlPLN
						else
							fKwotaRozrFK = mapKh.currFKF.kwotaWal
							fKwH = xDokumentPn.kwotaDoRozl
						endif

						if Round(fKwH - fKwotaRozrFK,2) then
							fKwota=ZliczKwote(xDokumentPn, khidfk, wPLN)
							fKwH = Round(fKwH + fkwota,2) //xDokumentPn.kwotaDoRozl
							fKwRozlFK = KwotaRozlFK(xDokumentPn.rozliczeniaPn, wPLN)
							// jesli ma sie zmienic kwota rozliczenia FK
							if (fKwRozlFK - Round(fKwRozlFK + fKwH - ABS(fKwotaRozrFK),2)) then
								xDokumentPn.rozliczeniaPn.RozliczZFK(using "wartosc='%f' kurs='%f' waluta='%s' data='%s'", Round(fKwRozlFK + fKwH - ABS(fKwotaRozrFK),2), iif(wPLN, 1, mapKh.currFKF.kurs), iif(wPLN, "", mapKh.currFKF.waluta), GetDataRozlFK(xDokumentPn.guid))
							endif
						endif
					endif
				endif
				err = mapKh.MoveNext()
			Wend

			if !znaleziony then
				rozrpom.ClearParams
				rozrpom.StanType = ROZ_STAN_ROZ
				rozrpom.Type = ROZ_WSZYSTKO
				rozrpom.SubjectPoz = khidfk
				rozrpom.SubjectType = GetSubTyp4KhTyp(xDokPnLocal.item(ii).kh_typ)

				//najpierw robimy adowanie dla penego kodu
				//strTmp = Mid(strKod, 1, iif(len(strkod)>28,28,len(strkod)))
				//if ( mid(strTmp, len(strTmp), 1) == " " ) then
				//	strTmp = mid(strTmp, 1, len(strTmp)-1)
				//endif
				rozrpom.DocumentName = strKod

				rozrpom.Load
				err = rozrpom.MoveFirst
				succ = 0
				while !err && !succ
					if rozrpom.Value("kwota")<0 then
						stronafk = !rozrpom.Value("strona")
					else
						stronafk = rozrpom.Value("strona")
					endif
					//Uwaga!!! Warunek (typ==PLAT) && xDokPnLocal.item(ii).dzial.typRejestru != 1 zosta
					//dodany poniewa nie wiem dokadnie po co suy sprawdzanie daty, a
					//sugestie byy takie e jeli czemu kolwiek to wplata bankowym
					if (stronafk == stronaTmp) && iif(typ==NAL || ((typ==PLAT) && xDokPnLocal.item(ii).dzial.typRejestru != 1),1,(rozrpom.Value("dokData") == strData)) then
						succ = 1
						nRes=xDokumentPn.Load("id="+(using "%l", xDokPnLocal.item(ii).id))
						if nRes then  Error "Nie mona zaadowa dokumentu '" + xDokPnLocal.item(ii).numer + "'"

						wPLN=0
//						fKwota=ZliczKwote(xDokumentPn, khidfk)
//						fKwH = Round(xDokumentPn.kwotaDoRozl + fkwota,2)
						fKwRozlFK = KwotaRozlFK(xDokumentPn.rozliczeniaPn, wPLN)
						// jesli ma sie zmienic kwota rozliczenia FK
//						if (fKwRozlFK - fKwH) then
							xDokumentPn.rozliczeniaPn.RozliczZFK(using "wartosc='%f' kurs='%f' waluta='%s' data='%s'", Round(fKwRozlFK + xDokumentPn.kwotaDoRozl,2), xDokumentPn.kurs, xDokumentPn.waluta, GetDataRozlFK(xDokumentPn.guid))
//						endif
					endif
					err = rozrpom.MoveNext
				wend
				if len(strKod)>28 && !succ then
					rozrpom.ClearParams
					rozrpom.StanType = ROZ_STAN_ROZ
					rozrpom.Type = ROZ_WSZYSTKO
					rozrpom.SubjectPoz = khidfk
					rozrpom.SubjectType = GetSubTyp4KhTyp(xDokPnLocal.item(ii).kh_typ)

					//dopiero teraz dla skrconego
					strTmp = Mid(strKod, 1, iif(len(strkod)>28,28,len(strkod)))
					if ( mid(strTmp, len(strTmp), 1) == " " ) then
						strTmp = mid(strTmp, 1, len(strTmp)-1)
					endif

					rozrpom.DocumentName = strTmp
					rozrpom.Load
					err = rozrpom.MoveFirst
					succ = 0
					while !err && !succ
						if rozrpom.Value("kwota")<0 then
							stronafk = !rozrpom.Value("strona")
						else
							stronafk = rozrpom.Value("strona")
						endif
						if (stronafk == stronaTmp) && iif(typ==NAL,1,(rozrpom.Value("dokData") == strData)) then
							succ = 1
							nRes=xDokumentPn.Load("id="+(using "%l", xDokPnLocal.item(ii).id))
							if nRes then  Error "Nie mona zaadowa dokumentu '" + xDokPnLocal.item(ii).numer + "'"

							wPLN=0
//							fKwota=ZliczKwote(xDokumentPn, khidfk)
//							fKwH = Round(xDokumentPn.kwotaDoRozl + fkwota,2)
							fKwRozlFK = KwotaRozlFK(xDokumentPn.rozliczeniaPn, wPLN)
//							xDokumentPn.rozliczeniaPn.RozliczZFK(fKwRozlFK + fKwH)
							xDokumentPn.rozliczeniaPn.RozliczZFK(using "wartosc='%f' kurs='%f' waluta='%s' data='%s'", Round(fKwRozlFK + xDokumentPn.kwotaDoRozl,2), xDokumentPn.kurs, xDokumentPn.waluta, GetDataRozlFK(xDokumentPn.guid))
						endif
						err = rozrpom.MoveNext
					wend
				endif
				if !succ && (xDokPnLocal.item(ii).CzyRozrachunekFK) then xDokPnLocal.item(ii).Delete()
			endif
		endif
		// jesli nie zmienilo sie nic w kolekcji
		if 	lCountBefore == xDokPnLocal.Count() then
			 ii = ii + 1
		else
			lCountBefore = xDokPnLocal.Count()
		endif
		progress.NextOne()
	wend
EndSub

int Sub ZnajdzPlatnoscHandlu(long idkhfk, long idkh, string typ, string konto, dispatch rozr)
int err, typpn, mnozn, stronafk, stronaTmp
int wPLN=1
string strKod, strData, kod, strTmp
string datapn = rozr.Value("dokData")
float fKwota, fKwRozlFK
float kwotapn = rozr.Value("kwota")
Dispatch xDokPnLocal=xFactory.NewObject("BDokPnExt")

	if rozr.Value("strona")==ROZ_NALEZ then
		stronaTmp = 1
	else
		stronaTmp = -1
	endif

	ZnajdzPlatnoscHandlu = 0

	xKonShort = KonGet(idKH, GetSubTypHM(rozr.Value("subTyp")))

	xDokPnLocal.Clear()
	xKartParamsDokPn = xDokPnLocal.Params()
	xKartParamsDokPn.typKontrahenta=GetKhTyp4FK(rozr.Value("subTyp"))
	xKartParamsDokPn.kontrahent=xKonShort

	xKartParamsDokPn.stanRozliczenia=XrozliczROZLICZONE
	xKartParamsDokPn.stanRozliczeniaRoz=XrozliczROZLICZONE
	xKartParamsDokPn.czyWplaty=(typ==PLATROZL)
	xKartParamsDokPn.czyWyplaty=(typ==PLATROZL)
	xKartParamsDokPn.czyNaleznosci=(typ==NALROZL)
	xKartParamsDokPn.czyZobowiazania=(typ==NALROZL)
	xKartParamsDokPn.anulowany=NIEANULOWANY
	xKartParamsDokPn.wystawioneIBufor=WYSTAWIONY
//	xKartParamsDokPn.terminPlatnosci=terminpn
	xKartParamsDokPn.czySynchronizacja=1

	nRes=xDokPnLocal.Load(xKartParamsDokPn)
	if nRes then  error "Dokumenty patnoci nie zaadowane"
	long ii = 1
	long lCountBefore = xDokPnLocal.Count()

	while ii <= xDokPnLocal.count() && !ZnajdzPlatnoscHandlu
//		nRes=xDokumentPn.Load("id="+(using "%l", xDokPnLocal.item(ii).id))
//		if nRes then  Error "Brak takiego rekordu w bazie PN"

//		strData = xDokPnLocal.item(ii).data_platnosci
//		strKod = xDokPnLocal.item(ii).numer

		if xDokPnLocal.item(ii).czyRozrachunek then
			if xDokPnLocal.item(ii).czyRozliczony then
				typ = NALROZL
			else
				typ = NAL
			endif
		else
			if xDokPnLocal.item(ii).czyRozliczony then
				typ = PLATROZL
			else
				typ = PLAT
			endif
		endif
		if typ==PLATROZL then
			mnozn = iif((xDokPnLocal.item(ii).CzyWyplata&0x01)==1,1,-1)
		else
			mnozn = iif((xDokPnLocal.item(ii).CzyWyplata&0x01)==1,-1,1)
		endif

		strKod = xDokPnLocal.item(ii).kodDkwFk
		if strKod == "" then  error using "Kod dokumentu %s o id=%l, jaki powinien by w FK jest pusty", xDokPnLocal.item(ii).numer, xDokPnLocal.item(ii).id

		strData = xDokPnLocal.item(ii).data_platnosci
		if xDokPnLocal.item(ii).typDkHandl == 2 then
			strData = xDokPnLocal.item(ii).dataWystZk
			strKod = Mid(strKod, 1, iif(len(strKod)>28,28,len(strKod)))
		endif
/*
		//jesli pozycja raportu bankowego to kod taki jak raport kod WB
		//1 - bankowy
		if (typ==PLATROZL) && xDokPnLocal.item(ii).dzial.typRejestru == 1 then
			xRapPnMan.Clear()
			xRrpPnParams = xRapPnMan.Params()
			xRrpPnParams.dzialy=xDokPnLocal.item(ii).dzial
			xRrpPnParams.okresOd=xDokPnLocal.item(ii).data_platnosci
			xRrpPnParams.okresDo=xDokPnLocal.item(ii).data_platnosci

			nRes=xRapPnMan.Load(xRrpPnParams)
			if nRes then  error "Brak takiego rekordu w bazie PN"
			//zalozenie na dzien jeden raport bankowy
			strKod = xRapPnMan.item(1).numer
		else
			//jesli dokument zakupu numer dokumentu w FK
			if ( xDokPnLocal.item(ii).id_dokumentu && (xDokPnLocal.item(ii).CzyWyplata & 0x01) ) then
				nRes = xDokumentZk.Load(using "id=%l", xDokPnLocal.item(ii).id_dokumentu)
				if !nRes && xDokumentZk.id then
					strKod = xDokumentZk.numerObcy
					strKod += " ["
					strKod += xDokumentZk.numer
					strKod += "]"
					strData = xDokumentZk.dataWystawienia
				endif

				strKod = Mid(strKod, 1, iif(len(strkod)>28,28,len(strkod)))
				if ( mid(strKod, len(strKod), 1) == " " ) then
					strKod = mid(strKod, 1, len(strKod)-1)
				endif

			endif
		endif
*/
/*		if xDokumentPn.CzyRozrachunekFK then
			if len(strKod)==25 then
				if (mid(strKod,25,1) == "") then
					strKod = mid(strKod,1,24)+" "
				endif
				buf = xDokumentPn.schemat
				arg ""," "
				replace arg
				strKod += buf
			endif
		endif
*/
		if kwotapn<0 then
			stronafk=-stronaTmp
		else
			stronafk = stronaTmp
		endif

		kod = rozr.Value("dokSymbol")
		strTmp = Mid(kod, 1, iif(len(kod)>28,28,len(kod)))
		if ( mid(strTmp, len(strTmp), 1) == " " ) then
			strTmp = mid(strTmp, 1, len(strTmp)-1)
		endif

		if (stronafk == mnozn) && (strKod == strTmp) && iif(typ==NALROZL,1,(strData==datapn)) then
			ZnajdzPlatnoscHandlu=1

			nRes = xDokumentPn.Load("id="+(using "%l", xDokPnLocal.item(ii).id))
			if nRes then  Error "Nie mona zaadowa dokumentu '" + xDokPnLocal.item(ii).numer + "'"

			if xDokumentPn.CzyWalutowy && Lcase(xDokumentPn.waluta) == Lcase(rozr.Value("waluta")) then wPLN=0
			if !wPLN then kwotapn = rozr.Value("kwotaWal")

			fKwota=ZliczKwote(xDokumentPn, idkhfk, wPLN)
			fKwRozlFK = KwotaRozlFK(xDokumentPn.rozliczeniaPn, wPLN)
			//ten if jest po to eby nie modyfikowa rozliczonych rcznie
			//a zakladamy e to s rozliczone i posiadajce rwnoczenie kwot do rozliczenia nie zerow
			if (xDokumentPn.kwotaDoRozl == 0.0) || !xDokumentPn.rozliczona then
				// jesli ma sie zmienic kwota rozliczenia FK
				if (fKwRozlFK - Round((fKwRozlFK + fkwota - ABS(kwotapn)),2)) then
					xDokumentPn.rozliczeniaPn.RozliczZFK(using "wartosc='%f' kurs='%f' waluta='%s' data='%s'", Round((fKwRozlFK + fkwota - ABS(kwotapn)),2), iif(wPLN, 1, rozr.Value("kurs") ), iif(wPLN, "", rozr.Value("waluta")), GetDataRozlFK(xDokumentPn.guid))
				endif
			endif
		endif

		// jesli nie zmienilo sie nic w kolekcji
		if 	lCountBefore == xDokPnLocal.Count() then
			 ii = ii + 1
		else
			lCountBefore = xDokPnLocal.Count()
		endif
	wend

	if ((!ZnajdzPlatnoscHandlu) && (typ==PLATROZL)) then
		kwotapn = rozr.Value("kwotaWal")
		sukces=0
		for i=1 to i>size(RokFKRozr)
			if RokFKRozr(i).IdRok == dbd.firmainfo.GetRokByDate(datapn) && RokFKRozr(i).Zap == 1 then sukces=i
		next i
		if sukces then
			plkn=RokFKRozr(sukces).PlanKont
		else
			if !(size(RokFKRozr)==1 && RokFKRozr(1).Zap == 0) then grow RokFKRozr, 1
			sParam = using "%d", dbd.firmainfo.GetRokByDate(datapn)
			RokFKRozr(size(RokFKRozr)).PlanKont.Create(ObjectFK(".PlanKont"))
			RokFKRozr(size(RokFKRozr)).PlanKont.Open(sParam,dbd)
//			if !RokFKRozr(size(RokFKRozr)).PlanKont.MoveFirst() then
//				AddError("Brak planu kont.",0)
//			endif
			RokFKRozr(size(RokFKRozr)).IdRok=dbd.firmainfo.GetRokByDate(datapn)
			RokFKRozr(size(RokFKRozr)).Zap=1
			plkn = RokFKRozr(size(RokFKRozr)).PlanKont
		endif
		if plkn.MoveTo(konto) then
			if (plkn.Value("Typ")==1) && (plkn.Rozrachunkowe > 0) then
				RozrachunekFK(xKonShort, rozr)
			endif
		else
			//nie ma konta w planie kont ale i tak wpisujemy
			RozrachunekFK(xKonShort, rozr)
		endif
	endif
EndSub

int Sub SprawdzRozrachunkiFK(int czyKH)
int err
long idpn, idkh, idkhfk
string konto

	err = rozr.MoveFirst
	While !err
		strPow = using "%l", rozr.Value("idTrans")
		if !Powiazania.Get(strPow) then
			idkh = GetHMId4FKId(rozr.Value("pozycja"), GetSubTypHM(rozr.Value("subTyp")))
			if(idkh) then
				idkhfk = rozr.Value("pozycja")
				if !czyKH then popup(2,using "Rozrachunek %s",rozr.Value("dokSymbol"))
				konto=using "%d",rozr.Value("synt")
				if rozr.Value("poz1") then konto += using "-%d",rozr.Value("poz1")
				if rozr.Value("poz2") then konto += using "-%d",rozr.Value("poz2")
				if rozr.Value("poz3") then konto += using "-%d",rozr.Value("poz3")
				if rozr.Value("poz4") then konto += using "-%d",rozr.Value("poz4")
				if rozr.Value("poz5") then konto += using "-%d",rozr.Value("poz5")
				if	!ZnajdzPlatnoscHandlu(idkhfk, idkh, NALROZL, konto, rozr) then
					ZnajdzPlatnoscHandlu(idkhfk, idkh, PLATROZL, konto, rozr)
//					if !ZnajdzPlatnoscHandlu(idkhfk, idkh, rozr.Value("subTyp"), rozr.Value("dokSymbol"), rozr.Value("termin"), rozr.Value("dokData"), rozr.Value("kwota"), NALROZL, rozr.Value("dokSkrot"), rozr.Value("dokNumer"),rozr.Value("strona"),konto, rozr.Value("kurs")) then
//						ZnajdzPlatnoscHandlu(idkhfk, idkh, rozr.Value("subTyp"), rozr.Value("dokSymbol"), rozr.Value("termin"), rozr.Value("dokData"), rozr.Value("kwota"), PLATROZL, rozr.Value("dokSkrot"), rozr.Value("dokNumer"),rozr.Value("strona"),konto, rozr.Value("kurs"))
				endif
			endif
		endif
		progress.NextOne()
		err = rozr.MoveNext
	Wend
EndSub

int Sub BeginProcessInt()
	BeginProcessInt = 0
	if !iProcessing then
		iProcessing = 1
		CreateObjRozr()
	else
		BeginProcessInt = 1
	endif
EndSub

int Sub EndProcessInt(int czyKH)
	if !czyKH	then popup(-1,"")
	progress.Reset(0)
	iProcessing = 0
EndSub

int Sub IntegrRozrachunki(long idKH, int typ)
int err,count=0
long khidfk
subTyp = typ

ask_wal = 0
int czyKH = (idKH != 0)

	if xIntegracjaFK.Load() then  error "Nie zaadowa si obiekt 'Integracja z FK'"
	if (!xIntegracjaFK.rejestrNal.id || !xIntegracjaFK.typDkNal.id || xIntegracjaFK.seriaNal == "" || !xIntegracjaFK.rejestrZob.id || !xIntegracjaFK.typDkZob.id || xIntegracjaFK.seriaZob == "" ) then
		Message "W oknie ustawie wsppracy z FK, dla nalenoci i zobowiza tworzonych w trakcie synchronizacji, nie zostay poprawnie ustawione typy dokumentw lub serie. Synchronizacja rozrachunkw zostanie przerwana."
		Error ""
		Exit
	endif

	if !czyKH then popup(0,"Synchronizacja rozrachunkw z FK")
	if !czyKH then popup(1,"Tworzenie obiektw")



	if BeginProcessInt() then Exit


	//tworzymy instancj nowego obiektu bo ten z jakim tutaj przychodzi czasem jest obiektem globalnym
	xDokumentPn=xFactory.NewObject("BDokumentPn")
	PowiazaniaClear()
	KontrahenciClear()

	mapKh.ClearMapRozrachunki()

	rozr.ClearParams
	rozr.StanType = ROZ_STAN_NROZ
	if czyKH then
		xKonFull = KonFullGet(idKH, subTyp)
		khidfk=val(xKonFull.identyfikatorFK)
		if !khidfk || !IsKhUsed(xKonFull) then
			EndProcessInt(czyKH)
			Exit
		endif
		rozr.SubjectType = GetSubTypFK(subTyp)
		rozr.SubjectPoz = khidfk
	endif

	if !czyKH then popup(1,"adowanie rozrachunkw FK")
	rozr.Load

	//tworzenie tabel tymczasowych
	CreateKhTempTables(typ)

	err = rozr.MoveFirst
	While !err
		strPow = using "%l", rozr.Value("idTrans")
		if czyKH then
			Powiazania.Set(strPow,0)
			mapKh.SetCurrent(rozr.Value("subTyp"),rozr.Value("pozycja"))
			mapKh.AddRozrachunek(rozr.Value("idTrans"),rozr.Value("strona"),rozr.Value("dokSymbol"),rozr.Value("dokData"),rozr.Value("kwota"),rozr.Value("kwotaWal"),rozr.Value("kurs"),rozr.Value("waluta"))
		else
			if typ&GetSubTypHM(rozr.Value("subTyp")) then
				Powiazania.Set(strPow,0)
				mapKh.SetCurrent(rozr.Value("subTyp"),rozr.Value("pozycja"))
				mapKh.AddRozrachunek(rozr.Value("idTrans"),rozr.Value("strona"),rozr.Value("dokSymbol"),rozr.Value("dokData"),rozr.Value("kwota"),rozr.Value("kwotaWal"),rozr.Value("kurs"),rozr.Value("waluta"))
			else
				Powiazania.Set(strPow,1)
			endif
		endif
		count+=1
		err = rozr.MoveNext
	Wend
//	zliczamy ile dokadnie dokumentw handlowych bdzie przerabianych w ptli
	xDokPn.Clear()
	xKartParamsDokPn = xDokPn.Params()
	if czyKH then
		xKonShort = KonGet(idKH, subTyp)
		xKartParamsDokPn.typKontrahenta=GetKhTyp4HM(subTyp)
		xKartParamsDokPn.kontrahent=xKonShort
	endif

	xKartParamsDokPn.stanRozliczenia=XrozliczNIEROZLICZONE
	xKartParamsDokPn.stanRozliczeniaRoz=XrozliczNIEROZLICZONE
	xKartParamsDokPn.czyWplaty=1
	xKartParamsDokPn.czyWyplaty=1
	xKartParamsDokPn.czyNaleznosci=1
	xKartParamsDokPn.czyZobowiazania=1
	xKartParamsDokPn.anulowany=NIEANULOWANY
	xKartParamsDokPn.wystawioneIBufor=WYSTAWIONY
	xKartParamsDokPn.czySynchronizacja=1
// i sumujemy z rozrachunkami z FK
	count = count + xDokPn.PoliczIle(xKartParamsDokPn)

	progress.Reset(count)
	if !czyKH then popup(1,"Sprawdzanie patnoci Handlu")

	if czyKH then
		SprawdzPlatnosciHandlu(NAL,idKH, czyKH)
		SprawdzPlatnosciHandlu(PLAT,idKH, czyKH)
	else
		SprawdzPlatnosciHandlu(NAL,typ, czyKH)
		SprawdzPlatnosciHandlu(PLAT,typ, czyKH)
	endif

	if !czyKH then popup(1,"Sprawdzanie rozrachunkw FK")

	SprawdzRozrachunkiFK(czyKH)
	DropKhTempTables(typ)
	EndProcessInt(czyKH)
EndSub