﻿
CREATE PROCEDURE HM.hm_PW_WstawPW



@idmz int,
@iddw int,
@iddwm int,
@ilosc float,
@wartosc float,
@kod varchar(100),
@numer int,
@zatwwart smallint,
@krajPochodzenia int
as

declare @iddwo int, @idpwo int, @idkoryg int, @idpw int
declare @return_status int
declare @iloscpw decimal(24,6), @wartoscpw decimal(24,2)
declare @iloscdosp decimal(24,6), @wartoscdosp decimal(24,2), @iloscdw decimal(24,6), @wartoscdw decimal(24,2), @iloscPz decimal(24,6)
declare @new smallint, @bufor smallint, @subtyp smallint, @typ smallint
declare @datao datetime
declare @cena decimal(24,6)
declare @przychod smallint

set @iloscpw = @ilosc
set @wartoscpw = @wartosc
set @cena = @wartosc / @ilosc
set @new = 0

if @krajPochodzenia = 0
    set @krajPochodzenia = NULL

select @bufor = MZ.bufor, @subtyp = MG.subtyp from MZ join MG on MZ.super = MG.id where MZ.id = @idmz
select @przychod = case when @subtyp in (74,131,75,132,81,82,83,89) then 1 else 0 end


if @przychod = 1 and @iddw = 0
begin
  if @iddwm = 0
  begin
    select @kod = case when @kod <> '' then @kod else
                  case when TW.szablon <> '' then '' else
                  case when MG.bufor = 0 then MG.kod else '' end end end
    from MZ join MG on MG.id = MZ.super join TW on TW.id = MZ.idtw where MZ.id = @idmz


    insert into DW select @zatwwart, 0, 0, ISNULL(@kod, ''), NULL, MZ.super, MG.khid, NULL,
                        case when @numer <> 0 then @numer else ISNULL((select MAX(numer) from DW where DW.idtw = MZ.idtw and DW.numer > 0), 16777215) + 1 end,
                        MZ.idtw, MZ.data, @iloscpw, 0.0, @cena, 0.0, MZ.magazyn, 0.0, 0.0, 0.0, MZ.bufor,NEWID(),@krajPochodzenia
    from MZ join MG on MG.id = MZ.super where MZ.id = @idmz
    select @return_status = @@error, @iddw = SCOPE_IDENTITY()
    if @return_status <> 0 return @return_status
    set @new = 1
  end
  else
  begin

    select @iddwo = ISNULL(DW.iddw, DW.id) from DW where DW.id = @iddwm

    select @iddw = DW.id
    from DW join MZ on DW.idtw = MZ.idtw and DW.magazyn = MZ.magazyn
    where MZ.id = @idmz and ISNULL(DW.iddw, DW.id) = @iddwo

    if @iddw = 0
    begin
      insert into DW select DWO.flag, 0, 0, DWO.kod, DWO.id, MZ.super, NULL, NULL,
                        ISNULL((select MAX(numer) from DW where DW.idtw = MZ.idtw and DW.numer > 0), 16777215) + 1,
                        MZ.idtw, MZ.data, @iloscpw, 0.0, DWO.cena, 0.0, MZ.magazyn, 0.0, 0.0, 0.0, MZ.bufor,NEWID(),@krajPochodzenia
      from MZ, DW as DWO where MZ.id = @idmz and DWO.id = @iddwo
      select @return_status = @@error, @iddw = SCOPE_IDENTITY()
      if @return_status <> 0 return @return_status
      set @new = 1
    end
  end
  if @iddw is NULL
    return -1
end

if @iddw = 0
  return -1

set @idkoryg = NULL
if @new = 0
begin

  select @idkoryg = MIN(PW.id)
  from MZ join MZ as MZK on MZ.superkoryg = MZK.superkoryg and MZ.lp = MZK.lp join PW on PW.typ = 37 and PW.idmg = MZK.id
  where MZ.id = @idmz and PW.iddw = @iddw and MZ.idpozkoryg is not NULL
end

if @przychod = 1
begin

  set @iloscpw = -@iloscpw
  set @wartoscpw = -@wartoscpw
end
else
begin


  if @bufor = 0 or @iloscpw > 0
  begin
    select @iloscdosp = iloscdosp, @wartoscdosp = wartoscdosp, @cena = cena
    from DW where id = @iddw

    if @iloscdosp = 0.0
      set @wartoscpw = @iloscpw * @cena
    else
      set @wartoscpw = @iloscpw * @wartoscdosp / @iloscdosp
  end
end

insert into PW select (case when @przychod = 1 then 0x10 else 0 end |
                       case when @new = 1 then 0x08 else 0 end |
                       case when (DW.flag & 1) <> 0 then 0x04 else 0 end),
                  MG.subtyp, case when MZ.bufor <> 0 then 39 else 37 end, MZ.super, MZ.id, DW.id, MZ.idtw, @iloscpw, @wartoscpw, 0.0, @idkoryg, MZ.data
from MZ join MG on MG.id = MZ.super, DW where MZ.id = @idmz and DW.id = @iddw
select @return_status = @@error, @idpw = SCOPE_IDENTITY()
if @return_status <> 0 return @return_status

if @bufor = 0
begin
  select @iloscdosp = iloscdosp - @iloscpw, @wartoscdosp = wartoscdosp - @wartoscpw,
         @iloscdw = stan - @iloscpw, @wartoscdw = wartoscst - @wartoscpw,
         @iloscPz = iloscPz - case when @przychod = 1 then @iloscpw else 0.0 end
  from DW where id = @iddw

  if @iloscdosp < 0.0

    return -4900

  if @wartoscdosp < 0.0

    return -4901

  update DW set iloscdosp = @iloscdosp, wartoscdosp = @wartoscdosp,
                stan = @iloscdw, wartoscst = @wartoscdw, iloscPz = @iloscPz,
                typ = case when @iloscdw = 0.0 then 0 else 1 end
  from DW where DW.id = @iddw
  set @return_status = @@error
  if @return_status <> 0 return @return_status
end




if @new = 0 and @subtyp in (82,83)
begin

  set @datao = NULL
  set @typ = NULL
  select @datao = MIN(data), @typ = MIN(typ) from PW where typ = 37 and (flag & 0x10) <> 0 and iddw = @iddw
  if @typ is NULL
    select @datao = min(data), @typ = MIN(typ) from PW where typ = 39 and (flag & 0x10) <> 0 and iddw = @iddw

  select @idpwo = MIN(id) from PW where typ = @typ and (flag & 0x10) <> 0 and data = @datao and iddw = @iddw

  if @idpwo = @idpw
  begin

    update PW set flag = (flag | 8) where id = @idpw
    set @return_status = @@error
    if @return_status <> 0 return @return_status

    update PW set flag = (flag & ~8) where id <> @idpw and iddw = @iddw and (flag & 0x10) <> 0
    set @return_status = @@error
    if @return_status <> 0 return @return_status


    update DW set iddkpz = PW.iddkmg, data = PW.data, ilosc = -PW.ilosc from DW join PW on DW.id = PW.iddw where PW.id = @idpw
    set @return_status = @@error
    if @return_status <> 0 return @return_status
  end

end

